VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsD3DObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Private Type objectType
Private VertexBuffer As Direct3DVertexBuffer8
'Private IBuffer As Direct3DIndexBuffer8
Private VertexSize As Long
Private Const VERTEX_TYPE = (D3DFVF_XYZ Or D3DFVF_DIFFUSE Or D3DFVF_SPECULAR Or D3DFVF_TEX1)
'Private Const VERTEX_TYPE = D3DFVF_XYZRHW
  
  Dim myMatrix As D3DMATRIX
  Dim myPosition As D3DVECTOR
  Dim myRotation As D3DVECTOR
  Public color As Long
  Public name As String
  
  Private Type VertexFormat
    X As Single
    Y As Single
    z As Single
    color As Long
    specular As Long
    tu As Single
    tv As Single
  End Type
  
  Private Type VertexInfo
    textureNumber As Long
    materialNumber As Long
  End Type
  
  'Dim colVertices As Collection
  'Private zVertices() As clsD3DVertex
  Private zVertices() As VertexFormat
  'Private zIndices() As Integer
  Private zPolygonInfo() As VertexInfo
  Public NoOfTriangles As Long
  'Private numIndices As Integer
  Private numVertices As Integer
  
  Private textures() As Direct3DTexture8
  
  'Private textures(7) As Direct3DBaseTexture8
  
  ' Object Type
  ' 0 = base hex
  ' 1 = terrain object
  Public objectType As Integer
  'Private myTexturePool As clsD3DTexturePool
  
  Private qualityType As CONST_D3DFILLMODE
  
  'Private materialOverride As D3DMATERIAL8
  'Public useMaterialOverride As Boolean
  Private material As D3DMATERIAL8
  
  Public mesh As D3DXMesh
  
'End Type

Private Sub Class_Initialize()
  'Debug.Print "Initialising d3d object"
  'Set myposition = New clsD3DVector
  numVertices = 0
  
  ' Default Quality
  qualityType = D3DFILL_SOLID
  
  ' Material
  'material.diffuse.a = 1
  'material.diffuse.g = 1
  'material.Ambient.a = 1
  'material.Ambient.g = 1
  
End Sub

Private Sub Class_Terminate()
  Debug.Print "Terminating d3d object " & name
  'Set myposition = Nothing
End Sub

Public Property Get VertexCount() As Integer
  VertexCount = numVertices
End Property
Public Property Let VertexCount(newCount As Integer)
  numVertices = newCount
End Property

Public Sub CreateBuffer(d3ddevice As Direct3DDevice8) ' ByRef texturePool As clsD3DTexturePool
  
  Dim d3dx As D3DX8
  Set d3dx = New D3DX8
  
  Dim tmpVertexFormat As VertexFormat
  Dim count As Long
  
  VertexSize = Len(tmpVertexFormat)
  'NoOfTriangles = numVertices \ 3
  
  'For count = 0 To 5
  '  Debug.Print count, zVertices(count).x & "/" & zVertices(count).y & "/" & zVertices(count).z, zVertices(count).tu, zVertices(count).tv
  'Next count
  
  If numVertices > 0 Then
    Set VertexBuffer = d3ddevice.CreateVertexBuffer(numVertices * VertexSize, 0, VERTEX_TYPE, D3DPOOL_DEFAULT)
    If VertexBuffer Is Nothing Then MsgBox "Couldn't create Vertex buffer!"

    D3DVertexBuffer8SetData VertexBuffer, 0, (numVertices * VertexSize), 0, zVertices(0)
  
    Set mesh = d3dx.CreateMeshFVF(NoOfTriangles, numVertices, D3DXMESH_MANAGED, VERTEX_TYPE, d3ddevice)
    D3DXMeshVertexBuffer8SetData mesh, 0, (numVertices * VertexSize), 0, zVertices(0)
 
    Debug.Print "Mesh has " & mesh.GetNumVertices & " vertices and " & mesh.GetNumFaces & " faces ( " & NoOfTriangles & " ) "
  
  End If

  'Debug.Print numIndices & " indexes for " & NoOfTriangles & " polys"

  'Set IBuffer = d3ddevice.CreateIndexBuffer(Len(zIndices(0)) * numIndices, 0, D3DFMT_INDEX16, D3DPOOL_DEFAULT)
  'If IBuffer Is Nothing Then MsgBox "Couldn't create Index buffer"
  'D3DIndexBuffer8SetData IBuffer, 0, Len(zIndices(0)) * numIndices, 0, zIndices(0)

  'Set myTexturePool = texturePool
  
  'If myTexturePool.NumTextures > 0 Then
  '  ReDim textures(myTexturePool.NumTextures - 1)
  '  For count = 0 To (myTexturePool.NumTextures - 1)
  '    Set textures(count) = myTexturePool.GetTexture(count)
  '  Next
  'End If
 
End Sub

'Public Sub AddPolygon(textureNo As Long, materialNo As Long)
Public Sub AddPolygon(shaderNo As Integer)

  ReDim Preserve zPolygonInfo(NoOfTriangles)
  'zPolygonInfo(NoOfTriangles).textureNumber = textureNo
  zPolygonInfo(NoOfTriangles).materialNumber = shaderNo
  
  'ReDim Preserve zIndices(numIndices + 2)
  'zIndices(numIndices) = v0
  'zIndices(numIndices + 1) = v1
  'zIndices(numIndices + 2) = v2
  
  NoOfTriangles = NoOfTriangles + 1
  'numIndices = numIndices + 3
End Sub

Public Sub AddVertex(inputVertex As D3DVECTOR, tu As Single, tv As Single, Optional colour As Long = -1)

  'Debug.Print "Adding vertex " & numVertices & ": " & inputVertex.x, inputVertex.y, inputVertex.z
  ReDim Preserve zVertices(numVertices)
  
  If colour = -1 Then
    colour = D3DColorARGB(255, 255, 255, 255)
  End If
  
  'Set zVertices(numVertices) = New clsD3DVertex
  zVertices(numVertices).X = -inputVertex.X
  zVertices(numVertices).Y = inputVertex.Y
  zVertices(numVertices).z = inputVertex.z
  
  zVertices(numVertices).color = colour
  'zVertices(numVertices).specular = D3DColorARGB(255, 255, 255, 255)
  zVertices(numVertices).specular = colour
  zVertices(numVertices).tu = tu
  zVertices(numVertices).tv = tv
  
  numVertices = numVertices + 1
End Sub

Public Sub UpdateVertex(vertNum As Integer, tu As Single, tv As Single)
  zVertices(vertNum).tu = tu
  zVertices(vertNum).tv = tv
End Sub

Public Sub Render(d3ddevice As Direct3DDevice8, ByRef texturePool As clsD3DTexturePool, ByRef shaderPool As clsD3DShaderPool)
  ''Dim matTemp As D3DMATRIX
  'Dim myMatrix As D3DMATRIX
  Dim count As Long
  Dim textureNo As Integer
  Dim i As Integer
  
  'Debug.Print name & ": " & myposition.x & " / " & myposition.y & " / " & myposition.z
  'If renderPosition Is Nothing Then
    'tmpPosition = myposition
  '  renderPosition = myposition
  'End If
  'If UseRenderPos = False Then
  '  Set renderPosition = myposition
  'End If
  'Debug.Print "Setting render position to: "; renderPosition.x & "/" & renderPosition.y & "/" & renderPosition.z
  
  ''D3DXMatrixIdentity myMatrix
  ''D3DXMatrixTranslation matTemp, myPosition.x, myPosition.y, myPosition.z
  ''D3DXMatrixMultiply myMatrix, myMatrix, matTemp
  ''d3ddevice.SetTransform D3DTS_WORLD, myMatrix
  d3ddevice.SetVertexShader VERTEX_TYPE
  
  d3ddevice.SetRenderState D3DRS_FILLMODE, qualityType
  
  If qualityType = D3DFILL_WIREFRAME Then
    d3ddevice.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
  End If
  
  'd3ddevice.SetTexture 0, myTexture
  'If useMaterial = True Then
  '  d3ddevice.SetMaterial material
  'End If
  
  'd3ddevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_ONE
  'd3ddevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
  'd3ddevice.SetRenderState D3DRS_ALPHABLENDENABLE, True
  
  ' Vertex Buffers
  If numVertices > 0 Then
    d3ddevice.SetStreamSource 0, VertexBuffer, VertexSize
  End If
  'd3ddevice.SetIndices IBuffer, 0
  
  'd3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 9
  'd3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, 9, 18
  'd3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, 18, 27
  
  'd3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, (NoOfTriangles \ 2), NoOfTriangles \ 2
  
  'd3ddevice.DrawPrimitiveUP D3DPT_TRIANGLELIST, NoOfTriangles, zVertices(0), Len(zVertices(0))
  
  'If useMaterialOverride = True Then
  '  d3ddevice.SetMaterial materialOverride
  'Else
  ' d3ddevice.SetMaterial material
  'End If
  
  'd3ddevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
  'd3ddevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCCOLOR
  'd3ddevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_DESTCOLOR
  
  textureNo = -1
  For count = 0 To (NoOfTriangles - 1)
    
    If qualityType = D3DFILL_SOLID Then
    
      If texturePool.NumTextures > 0 Then
        If zPolygonInfo(count).materialNumber <> textureNo Then
          textureNo = zPolygonInfo(count).materialNumber
          'Debug.Print "Texture count is: " & shaderPool.shader(textureNo).TextureCount
          For i = shaderPool.shader(textureNo).TextureCount To 1 Step -1
            'Debug.Print "  Texture " & i & ": " & shaderPool.shader(textureNo).Texture(i).texType
            Select Case shaderPool.shader(textureNo).Texture(i).texType
            Case texDiffuse:
              'Debug.Print "    Setting diffuse..."
              d3ddevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
              d3ddevice.SetTexture 0, texturePool.GetTexture(shaderPool.shader(textureNo).Texture(i).textureId)
              Call d3ddevice.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
              Call d3ddevice.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
              Call d3ddevice.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_SPECULAR)
              'Call d3ddevice.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_SPECULAR)
            Case texGlow:
            '  'Debug.Print "    Setting glow..."
              d3ddevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
              'd3ddevice.SetTexture 1, texturePool.GetTexture(shaderPool.shader(textureNo).Texture(i).textureId)
              'Call d3ddevice.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_SELECTARG1)
              'Call d3ddevice.SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_MODULATECOLOR_ADDALPHA)
              'Call d3ddevice.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_TEXTURE)
              'Call d3ddevice.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_CURRENT)
              'd3ddevice.SetTextureStageState 1, D3DTSS_COLOROP, D3DTOP_MODULATE
              'd3ddevice.SetTextureStageState 1, D3DTSS_COLORARG1, D3DTA_TEXTURE
              'd3ddevice.SetTextureStageState 1, D3DTSS_COLORARG2, D3DTA_DIFFUSE
            End Select
            'd3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, Count * 3, 1
          Next i
          d3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, count * 3, 1
        Else
          d3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, count * 3, 1
          'd3ddevice.SetTextureStageState textureNo, D3DTSS_RESULTARG, 0
        End If
      Else
        d3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, count * 3, 1
      End If
    
    Else
      d3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, count * 3, 1
    End If
    
    'd3ddevice.DrawPrimitive D3DPT_TRIANGLELIST, Count * 3, 1
    'd3ddevice.DrawPrimitiveUP D3DPT_TRIANGLELIST, 1, zVertices(count), VertexSize
    'd3ddevice.DrawIndexedPrimitive D3DPT_TRIANGLELIST, 0, numIndices, count * 3, 1
  Next

  If qualityType = D3DFILL_WIREFRAME Then
    d3ddevice.SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
  End If


End Sub

Public Sub SetPosition(newPos As D3DVECTOR)
  myPosition = newPos
  Debug.Print "Position is now: " & myPosition.X, myPosition.Y, myPosition.z
End Sub

'Public Property Get Position() As clsD3DVector
'  Set Position = myposition
'End Property

Public Function GetPosition() As D3DVECTOR
  GetPosition = myPosition
End Function

'Public Property Let Position(newPos As D3DVECTOR)
'  myposition = newPos
'  Debug.Print "PLet: " & myposition.x, myposition.y, myposition.Z
'End Property

'Public Sub SetMaterial(myMaterial As D3DMATERIAL8)
'  material = myMaterial
'End Sub

Public Sub highlight(colour As Long)
  ' Go through the Vertex Buffer and change the specular value to the highlighted value
  Dim i As Integer
  
  For i = 0 To (numVertices - 1)
    zVertices(i).specular = colour
  Next i
  
  ' Next, update the vertex buffer
  D3DVertexBuffer8SetData VertexBuffer, 0, (numVertices * VertexSize), D3DLOCK_DISCARD, zVertices(0)
  
End Sub

Public Sub SetColorRGB(red As Integer, green As Integer, blue As Integer)
  Dim i As Integer
  
  For i = 0 To (numVertices - 1)
    zVertices(i).color = D3DColorARGB(255, red, green, blue)
  Next i
  
  ' Next, update the vertex buffer
  D3DVertexBuffer8SetData VertexBuffer, 0, (numVertices * VertexSize), D3DLOCK_DISCARD, zVertices(0)
End Sub

Public Sub SetQuality(quality As CONST_D3DFILLMODE)
  qualityType = quality
End Sub

'Public Sub SetMaterialOverride(m As D3DMATERIAL8)
'    materialOverride = m
'    useMaterialOverride = True
'End Sub

