Attribute VB_Name = "OGLUtils"
Option Explicit

' a couple of declares to work around some deficiencies of the type library
Private Declare Function EnumDisplaySettings Lib "user32" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, lpDevMode As Any) As Boolean
Private Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpDevMode As Any, ByVal dwflags As Long) As Long
Private Declare Function CreateIC Lib "gdi32" Alias "CreateICA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Long) As Long

Private Const CCDEVICENAME = 32
Private Const CCFORMNAME = 32
Private Const DM_BITSPERPEL = &H40000
Private Const DM_PELSWIDTH = &H80000
Private Const DM_PELSHEIGHT = &H100000

Private Type DEVMODE
    dmDeviceName        As String * CCDEVICENAME
    dmSpecVersion       As Integer
    dmDriverVersion     As Integer
    dmSize              As Integer
    dmDriverExtra       As Integer
    dmFields            As Long
    dmOrientation       As Integer
    dmPaperSize         As Integer
    dmPaperLength       As Integer
    dmPaperWidth        As Integer
    dmScale             As Integer
    dmCopies            As Integer
    dmDefaultSource     As Integer
    dmPrintQuality      As Integer
    dmColor             As Integer
    dmDuplex            As Integer
    dmYResolution       As Integer
    dmTTOption          As Integer
    dmCollate           As Integer
    dmFormName          As String * CCFORMNAME
    dmUnusedPadding     As Integer
    dmBitsPerPel        As Integer
    dmPelsWidth         As Long
    dmPelsHeight        As Long
    dmDisplayFlags      As Long
    dmDisplayFrequency  As Long
End Type

Public Keys(255) As Boolean             ' used to keep track of key_downs

Private hrc As Long
Private fullscreen As Boolean

Private OldWidth As Long
Private OldHeight As Long
Private OldBits As Long
Private OldVertRefresh As Long
Public xrot As GLfloat                      ' Rotates Cube On The X Axis
Public yrot As GLfloat                      ' Rotates Cube On The Y Axis
Public box As GLuint                        ' Storage For The Display List
Public top As GLuint                        ' Storage For The Second Display List
Public xloop As GLuint                      ' Loop For X Axis
Public yloop As GLuint                      ' Loop For Y Axis

Public boxcol(2, 4) As GLfloat           ' Array For Box Colors
'    // Bright:  Red, Orange, Yellow, Green, Blue
'    {1.0f,0.0f,0.0f},{1.0f,0.5f,0.0f},{1.0f,1.0f,0.0f},{0.0f,1.0f,0.0f},{0.0f,1.0f,1.0f}

Public topcol(2, 4) As GLfloat                 ' Array For Top Colors
    ' Dark:  Red, Orange, Yellow, Green, Blue
    '{.5f,0.0f,0.0f},{0.5f,0.25f,0.0f},{0.5f,0.5f,0.0f},{0.0f,0.5f,0.0f},{0.0f,0.5f,0.5f}




Public Texture(0) As GLuint                             ' Storage For One Texture ( NEW )
Private mPointerCount As Integer

Private Sub BuildLists()                  ' Build Box Display List
    box = glGenLists(2)              ' Building Two Lists

    glNewList box, lstCompile          ' New Compiled box Display List

        glBegin bmQuads                            ' Start Drawing Quads
            ' Bottom Face
            glTexCoord2f 1#, 1#: glVertex3f -1#, -1#, -1#              ' Top Right Of The Texture and Quad
            glTexCoord2f 0#, 1#:      glVertex3f 1#, -1#, -1#          ' Top Left Of The Texture and Quad
            glTexCoord2f 0#, 0#: glVertex3f 1#, -1#, 1#                ' Bottom Left Of The Texture and Quad
            glTexCoord2f 1#, 0#: glVertex3f -1#, -1#, 1#               ' Bottom Right Of The Texture and Quad
            ' Front Face
            glTexCoord2f 0#, 0#: glVertex3f -1#, -1#, 1#               ' Bottom Left Of The Texture and Quad
            glTexCoord2f 1#, 0#: glVertex3f 1#, -1#, 1#                ' Bottom Right Of The Texture and Quad
            glTexCoord2f 1#, 1#: glVertex3f 1#, 1#, 1#                 ' Top Right Of The Texture and Quad
            glTexCoord2f 0#, 1#: glVertex3f -1#, 1#, 1#                ' Top Left Of The Texture and Quad
            ' Back Face
            glTexCoord2f 1#, 0#: glVertex3f -1#, -1#, -1#              ' Bottom Right Of The Texture and Quad
            glTexCoord2f 1#, 1#: glVertex3f -1#, 1#, -1#               ' Top Right Of The Texture and Quad
            glTexCoord2f 0#, 1#: glVertex3f 1#, 1#, -1#                ' Top Left Of The Texture and Quad
            glTexCoord2f 0#, 0#: glVertex3f 1#, -1#, -1#               ' Bottom Left Of The Texture and Quad
            ' Right face
            glTexCoord2f 1#, 0#:      glVertex3f 1#, -1#, -1#          ' Bottom Right Of The Texture and Quad
            glTexCoord2f 1#, 1#:      glVertex3f 1#, 1#, -1#           ' Top Right Of The Texture and Quad
            glTexCoord2f 0#, 1#: glVertex3f 1#, 1#, 1#                 ' Top Left Of The Texture and Quad
            glTexCoord2f 0#, 0#: glVertex3f 1#, -1#, 1#                ' Bottom Left Of The Texture and Quad
            ' Left Face
            glTexCoord2f 0#, 0#: glVertex3f -1#, -1#, -1#              ' Bottom Left Of The Texture and Quad
            glTexCoord2f 1#, 0#: glVertex3f -1#, -1#, 1#               ' Bottom Right Of The Texture and Quad
            glTexCoord2f 1#, 1#: glVertex3f -1#, 1#, 1#                ' Top Right Of The Texture and Quad
            glTexCoord2f 0#, 1#: glVertex3f -1#, 1#, -1#               ' Top Left Of The Texture and Quad
        glEnd                                  ' Done Drawing Quads

    glEndList                                      ' Done Building The box List

    top = box + 1                              ' top List Value Is box List Value +1

    glNewList top, lstCompile                          ' New Compiled top Display List

        glBegin bmQuads                            ' Start Drawing Quad
            ' Top Face
            glTexCoord2f 0#, 1#: glVertex3f -1#, 1#, -1#               ' Top Left Of The Texture and Quad
            glTexCoord2f 0#, 0#: glVertex3f -1#, 1#, 1#           ' Bottom Left Of The Texture and Quad
            glTexCoord2f 1#, 0#: glVertex3f 1#, 1#, 1#                 ' Bottom Right Of The Texture and Quad
            glTexCoord2f 1#, 1#: glVertex3f 1#, 1#, -1#                ' Top Right Of The Texture and Quad
        glEnd                                  ' Done Drawing Quad

    glEndList                                      ' Done Building The top Display List

    
    '    // Bright:  Red, Orange, Yellow, Green, Blue
    boxcol(0, 0) = 1#: boxcol(1, 0) = 0#: boxcol(2, 0) = 0#
    boxcol(0, 1) = 1#: boxcol(1, 1) = 0.5: boxcol(2, 1) = 0#
    boxcol(0, 2) = 1#: boxcol(1, 2) = 1#: boxcol(2, 2) = 0#
    boxcol(0, 3) = 0#: boxcol(1, 3) = 1#: boxcol(2, 3) = 0#
    boxcol(0, 4) = 0#: boxcol(1, 4) = 1#: boxcol(2, 4) = 1#
 
    ' Dark:  Red, Orange, Yellow, Green, Blue
    topcol(0, 0) = 0.5: topcol(1, 0) = 0#: topcol(2, 0) = 0#
    topcol(0, 1) = 0.5: topcol(1, 1) = 0.25: topcol(2, 1) = 0#
    topcol(0, 2) = 0.5: topcol(1, 2) = 0.5: topcol(2, 2) = 0#
    topcol(0, 3) = 0#: topcol(1, 3) = 0.5: topcol(2, 3) = 0#
    topcol(0, 4) = 0#: topcol(1, 4) = 0.5: topcol(2, 4) = 0.5
 

End Sub



Private Function LoadBMP(ByVal Filename As String, ByRef Texture() As GLuint, ByRef Height As Long, ByRef Width As Long) As Boolean

    Dim intFileHandle As Integer
    Dim bitmapheight As Long
    Dim bitmapwidth As Long

    ' Open a file.
    ' The file should be BMP with pictures 64x64,128x128,256x256 .....
  
    If Filename = "" Then
        Exit Function
    End If
    If UCase(Right(Filename, 3)) = "BMP" Then
        myFrm.Picture = LoadPicture(App.Path & "\" & Filename)
        CreateMapImage myFrm, Texture(), Height, Width
'    ElseIf UCase(Right(Filename, 3)) = "MOT" Then
'        intFileHandle = FreeFile
'        Open Filename For Binary Access Read Lock Read Write As intFileHandle
'        Get #intFileHandle, , Width
'        Get #intFileHandle, , Height
'        ReDim bitmapImage(2, Height - 1, Width - 1)
'        Get #intFileHandle, , Texture
'        Close intFileHandle
    End If
    LoadBMP = True
End Function

Private Sub CreateMapImage(pict As Object, ByRef TextureImg() As GLbyte, ByRef Height As Long, ByRef Width As Long)
    ' Create the array as needed for the image.
    pict.ScaleMode = 3                  ' Pixels
    Height = pict.ScaleHeight
    Width = pict.ScaleWidth
    
    ReDim TextureImg(2, Height - 1, Width - 1)
    
    ' Fill the array with the bitmap data...  This could take
    ' a while...
    
    Dim X As Long, Y As Long
    Dim c As Long
    
    Dim yloc As Long
    For X = 0 To Width - 1
        For Y = 0 To Height - 1
            c = pict.Point(X, Y)                ' Returns in long format.
            yloc = Height - Y - 1
            TextureImg(0, X, yloc) = c And 255
            TextureImg(1, X, yloc) = (c And 65280) \ 256
            TextureImg(2, X, yloc) = (c And 16711680) \ 65536
        Next Y
    Next X
    
End Sub


Private Function LoadGLTextures() As Boolean
' Load Bitmaps And Convert To Textures
    Dim Status As Boolean
    Dim h As Long
    Dim w As Long
    Dim TextureImage() As GLbyte
    Status = False                         ' Status Indicator

    If LoadBMP("Cube.BMP", TextureImage(), h, w) Then
        ' Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
        Status = True                          ' Set The Status To TRUE

        glGenTextures 1, Texture(0)                 ' Create The Texture

        ' Typical Texture Generation Using Data From The Bitmap
        glBindTexture glTexture2D, Texture(0)

        ' Generate The Texture
        glTexImage2D glTexture2D, 0, 3, w, h, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage(0, 0, 0)
        glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR     ' Linear Filtering
        glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR     ' Linear Filtering
    End If

    Erase TextureImage   ' Free the texture image memory
    LoadGLTextures = Status
End Function



Private Sub HidePointer()
    ' hide the cursor (mouse pointer)
    mPointerCount = ShowCursor(False) + 1
    Do While ShowCursor(False) >= -1
    Loop
    Do While ShowCursor(True) <= -1
    Loop
    ShowCursor False
End Sub

Private Sub ShowPointer()
    ' show the cursor (mouse pointer)
    Do While ShowCursor(False) >= mPointerCount
    Loop
    Do While ShowCursor(True) <= mPointerCount
    Loop
End Sub

Public Sub ReSizeGLScene(ByVal Width As GLsizei, ByVal Height As GLsizei)
' Resize And Initialize The GL Window
    If Height = 0 Then              ' Prevent A Divide By Zero By
        Height = 1                  ' Making Height Equal One
    End If
    glViewport 0, 0, Width, Height  ' Reset The Current Viewport
    glMatrixMode mmProjection       ' Select The Projection Matrix
    glLoadIdentity                  ' Reset The Projection Matrix

    ' Calculate The Aspect Ratio Of The Window
    gluPerspective 45#, Width / Height, 0.1, 100#

    glMatrixMode mmModelView        ' Select The Modelview Matrix
    glLoadIdentity                  ' Reset The Modelview Matrix
End Sub

Public Function InitGL() As Boolean
' All Setup For OpenGL Goes Here
    If Not LoadGLTextures Then          ' Jump To Texture Loading Routine ( NEW )
        InitGL = False                  ' If Texture Didn't Load Return FALSE ( NEW )
        Exit Function
    End If
        
    BuildLists                       ' Jump To The Code That Creates Our Display Lists

    glEnable glcTexture2D               ' Enable Texture Mapping ( NEW )
    glShadeModel smSmooth               ' Enables Smooth Shading

    glClearColor 0#, 0#, 0#, 0#         ' Black Background

    glClearDepth 1#                     ' Depth Buffer Setup
    glEnable glcDepthTest               ' Enables Depth Testing
    glDepthFunc cfLEqual                ' The Type Of Depth Test To Do
    
    glEnable glcLight0                     ' Quick And Dirty Lighting (Assumes Light0 Is Set Up)
    glEnable glcLighting                   ' Enable Lighting
    glEnable glcColorMaterial              ' Enable Material Coloring


    glHint htPerspectiveCorrectionHint, hmNicest    ' Really Nice Perspective Calculations

    InitGL = True                       ' Initialization Went OK
End Function


Public Sub KillGLWindow()
' Properly Kill The Window
    If fullscreen Then                              ' Are We In Fullscreen Mode?
        ResetDisplayMode                            ' If So Switch Back To The Desktop
        ShowPointer                                 ' Show Mouse Pointer
    End If

    If hrc Then                                     ' Do We Have A Rendering Context?
        If wglMakeCurrent(0, 0) = 0 Then             ' Are We Able To Release The DC And RC Contexts?
            MsgBox "Release Of DC And RC Failed.", vbInformation, "SHUTDOWN ERROR"
        End If

        If wglDeleteContext(hrc) = 0 Then           ' Are We Able To Delete The RC?
            MsgBox "Release Rendering Context Failed.", vbInformation, "SHUTDOWN ERROR"
        End If
        hrc = 0                                     ' Set RC To NULL
    End If

    ' Note
    ' The form owns the device context (hDC) window handle (hWnd) and class (RTThundermain)
    ' so we do not have to do all the extra work

End Sub

Private Sub SaveCurrentScreen()
    ' Save the current screen resolution, bits, and Vertical refresh
    Dim ret As Long
    ret = CreateIC("DISPLAY", "", "", 0&)
    OldWidth = GetDeviceCaps(ret, HORZRES)
    OldHeight = GetDeviceCaps(ret, VERTRES)
    OldBits = GetDeviceCaps(ret, BITSPIXEL)
    OldVertRefresh = GetDeviceCaps(ret, VREFRESH)
    ret = DeleteDC(ret)
End Sub

Private Function FindDEVMODE(ByVal Width As Integer, ByVal Height As Integer, ByVal Bits As Integer, Optional ByVal VertRefresh As Long = -1) As DEVMODE
    ' locate a DEVMOVE that matches the passed parameters
    Dim ret As Boolean
    Dim I As Long
    Dim dm As DEVMODE
    I = 0
    Do  ' enumerate the display settings until we find the one we want
        ret = EnumDisplaySettings(0&, I, dm)
        If dm.dmPelsWidth = Width And _
            dm.dmPelsHeight = Height And _
            dm.dmBitsPerPel = Bits And _
            ((dm.dmDisplayFrequency = VertRefresh) Or (VertRefresh = -1)) Then Exit Do ' exit when we have a match
        I = I + 1
    Loop Until (ret = False)
    FindDEVMODE = dm
End Function

Private Sub ResetDisplayMode()
    Dim dm As DEVMODE             ' Device Mode
    
    dm = FindDEVMODE(OldWidth, OldHeight, OldBits, OldVertRefresh)
    dm.dmFields = DM_BITSPERPEL Or DM_PELSWIDTH Or DM_PELSHEIGHT
    If OldVertRefresh <> -1 Then
        dm.dmFields = dm.dmFields Or DM_DISPLAYFREQUENCY
    End If
    ' Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
    If (ChangeDisplaySettings(dm, CDS_FULLSCREEN) <> DISP_CHANGE_SUCCESSFUL) Then
    
        ' If The Mode Fails, Offer Two Options.  Quit Or Run In A Window.
        MsgBox "The Requested Mode Is Not Supported By Your Video Card", , "NeHe GL"
    End If

End Sub

Private Sub SetDisplayMode(ByVal Width As Integer, ByVal Height As Integer, ByVal Bits As Integer, ByRef fullscreen As Boolean, Optional VertRefresh As Long = -1)
    Dim dmScreenSettings As DEVMODE             ' Device Mode
    Dim p As Long
    SaveCurrentScreen                           ' save the current screen attributes so we can go back later
    
    dmScreenSettings = FindDEVMODE(Width, Height, Bits, VertRefresh)
    dmScreenSettings.dmBitsPerPel = Bits
    dmScreenSettings.dmPelsWidth = Width
    dmScreenSettings.dmPelsHeight = Height
    dmScreenSettings.dmFields = DM_BITSPERPEL Or DM_PELSWIDTH Or DM_PELSHEIGHT
    If VertRefresh <> -1 Then
        dmScreenSettings.dmDisplayFrequency = VertRefresh
        dmScreenSettings.dmFields = dmScreenSettings.dmFields Or DM_DISPLAYFREQUENCY
    End If
    ' Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
    If (ChangeDisplaySettings(dmScreenSettings, CDS_FULLSCREEN) <> DISP_CHANGE_SUCCESSFUL) Then
    
        ' If The Mode Fails, Offer Two Options.  Quit Or Run In A Window.
        If (MsgBox("The Requested Mode Is Not Supported By" & vbCr & "Your Video Card. Use Windowed Mode Instead?", vbYesNo + vbExclamation, "NeHe GL") = vbYes) Then
            fullscreen = False                  ' Select Windowed Mode (Fullscreen=FALSE)
        Else
            ' Pop Up A Message Box Letting User Know The Program Is Closing.
            MsgBox "Program Will Now Close.", vbCritical, "ERROR"
'            End                   ' Exit And Return FALSE
        End If
    End If
End Sub

Public Function CreateGLWindow(frm As Object, Width As Integer, Height As Integer, Bits As Integer, fullscreenflag As Boolean) As Boolean
    Dim PixelFormat As GLuint                       ' Holds The Results After Searching For A Match
    Dim pfd As PIXELFORMATDESCRIPTOR                ' pfd Tells Windows How We Want Things To Be


    fullscreen = fullscreenflag                     ' Set The Global Fullscreen Flag


    If (fullscreen) Then                            ' Attempt Fullscreen Mode?
        SetDisplayMode Width, Height, Bits, fullscreen
    End If
    
    If fullscreen Then
        HidePointer                                 ' Hide Mouse Pointer
        frm.WindowState = vbMaximized
    End If

    pfd.cColorBits = Bits
    pfd.cDepthBits = 16
    pfd.dwflags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER Or PFD_TYPE_RGBA
    pfd.iLayerType = PFD_MAIN_PLANE
    pfd.iPixelType = PFD_TYPE_RGBA
    pfd.nSize = Len(pfd)
    pfd.nVersion = 1
    
    PixelFormat = ChoosePixelFormat(frm.hdc, pfd)
    If PixelFormat = 0 Then                     ' Did Windows Find A Matching Pixel Format?
        KillGLWindow                            ' Reset The Display
        MsgBox "Can't Find A Suitable PixelFormat.", vbExclamation, "ERROR"
        CreateGLWindow = False                  ' Return FALSE
    End If

    If SetPixelFormat(frm.hdc, PixelFormat, pfd) = 0 Then ' Are We Able To Set The Pixel Format?
        KillGLWindow                            ' Reset The Display
        MsgBox "Can't Set The PixelFormat.", vbExclamation, "ERROR"
        CreateGLWindow = False                           ' Return FALSE
    End If
    
    hrc = wglCreateContext(frm.hdc)
    If (hrc = 0) Then                           ' Are We Able To Get A Rendering Context?
        KillGLWindow                            ' Reset The Display
        MsgBox "Can't Create A GL Rendering Context.", vbExclamation, "ERROR"
        CreateGLWindow = False                  ' Return FALSE
    End If

    If wglMakeCurrent(frm.hdc, hrc) = 0 Then    ' Try To Activate The Rendering Context
        KillGLWindow                            ' Reset The Display
        MsgBox "Can't Activate The GL Rendering Context.", vbExclamation, "ERROR"
        CreateGLWindow = False                  ' Return FALSE
    End If
    'frm.Show                                    ' Show The Window
    SetForegroundWindow frm.hwnd                ' Slightly Higher Priority
'    frm.SetFocus                                ' Sets Keyboard Focus To The Window
    ReSizeGLScene frm.ScaleWidth, frm.ScaleHeight ' Set Up Our Perspective GL Screen

    If Not InitGL() Then                        ' Initialize Our Newly Created GL Window
        KillGLWindow                            ' Reset The Display
        MsgBox "Initialization Failed.", vbExclamation, "ERROR"
        CreateGLWindow = False                   ' Return FALSE
    End If

    CreateGLWindow = True                       ' Success

End Function

