VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHwPeoObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Public Type peoObject
    'Private zfaces() As clsHwPeoPolygon
    Private colFaces As Collection
    'Private numOfFaces As Long
    
    ' Allows to either specify information via matrix or directly
    Public useMatrix As Boolean
    Public matrix As clsHwMatrix
    Public rotation As clsVector
    Public position As clsVector
    
    'Private zvertexList() As clsHwPeoVertex
    Private colVertices As Collection
    'Private numOfVertices As Long
    
    Private colFaceNormals As Collection
    'Private numOfFaceNormals As Long
    Private colVertexNormals As Collection
    
    'faceNormalList() As D3DVECTOR
    'vertNormalList() As D3DVECTOR
    Public objName As String
    
    Public Mother As clsHwPeoHeirachy
    Public Daughter As clsHwPeoHeirachy
    Public Sister As clsHwPeoHeirachy
    
    Public flags As Long
    Public stats As clsHwPeoStats
    Public madObjNo As Integer ' Index into the MAD objects list
    Public sharedObjNo As Integer ' If this object shares polys/verts/normals
                           ' with another, the sharedObjNo will
                           ' be > -1
    Public saveData As clsHwPeoSaveData ' Only used when saving shared
                              ' data
'End Type

Private Sub Class_Initialize()
  Set stats = New clsHwPeoStats
  Set Mother = New clsHwPeoHeirachy
  Set Daughter = New clsHwPeoHeirachy
  Set Sister = New clsHwPeoHeirachy
  Set matrix = New clsHwMatrix
  Set rotation = New clsVector
  Set position = New clsVector
  
  Set colFaces = New Collection
  Set colVertices = New Collection
  Set colFaceNormals = New Collection
  Set colVertexNormals = New Collection
  
  'numOfFaces = 0
  'numOfVertices = 0
  'numOfFaceNormals = 0
  
End Sub

Private Sub Class_Terminate()
  Set stats = Nothing
  Set Mother = Nothing
  Set Daughter = Nothing
  Set Sister = Nothing
  Set matrix = Nothing
  Set rotation = Nothing
  Set position = Nothing

  Set colFaces = Nothing
  Set colVertices = Nothing
  Set colFaceNormals = Nothing
  Set colVertexNormals = Nothing
  
End Sub


'Public Property Get faces(i As Integer) As clsHwPeoPolygon
'  faces = zfaces(i)
'End Property

'Public Property Get Vertex(i As Integer) As clsHwPeoVertex
'  Set Vertex = zvertexList(i)
'End Property

'Public Sub AddVertex(newVertex As clsHwPeoVertex)
'  ReDim zvertexList(numOfVertices)
'  Set zvertexList(numOfVertices) = newVertex
'  numOfVertices = numOfVertices + 1
'End Sub

Public Function AddVertex(ByVal vKey As String, _
                    Optional ByVal vBefore As Long = 0, _
                    Optional ByVal vAfter As Long = 0) As clsHwPeoVertex
  
  Dim objNewPeoVertex As clsHwPeoVertex
  
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set objNewPeoVertex = New clsHwPeoVertex
    If vBefore > 0 Then 'Provide same functionality as Collection
      colVertices.Add objNewPeoVertex, vKey, vBefore
    ElseIf vAfter > 0 Then
      colVertices.Add objNewPeoVertex, vKey, , vAfter
    Else
      colVertices.Add objNewPeoVertex, vKey
    End If
    Set AddVertex = objNewPeoVertex 'Pass back reference
    Set objNewPeoVertex = Nothing 'Clean up reference
  Else
    Set AddVertex = Nothing 'Signal failure by returning nothing object
  End If
  Exit Function
  
ErrorHandler:
  Set AddVertex = Nothing
  Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description

End Function

Public Function Vertex(ByVal vKey As Variant) As clsHwPeoVertex
' Variant allows for string key or long index
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set Vertex = colVertices.Item(vKey)
  Else
    Set Vertex = Nothing 'signal failure
    Err.Raise vbObjectError + 10000, "MyObjectCollection.MyObjects", "Key value invalid"
  End If
  Exit Function

ErrorHandler:
  If Err.Number = 5 Or Err.Number = 9 Then
    Set Vertex = Nothing 'Item not found
  Else
    Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description
  End If
End Function

Public Function VertexCount() As Long
  VertexCount = colVertices.Count
End Function

Public Function AddFace(ByVal vKey As String, _
                    Optional ByVal vBefore As Long = 0, _
                    Optional ByVal vAfter As Long = 0) As clsHwPeoPolygon
  
  Dim objNewpeoPolygon As clsHwPeoPolygon
  
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set objNewpeoPolygon = New clsHwPeoPolygon
    If vBefore > 0 Then 'Provide same functionality as Collection
      colFaces.Add objNewpeoPolygon, vKey, vBefore
    ElseIf vAfter > 0 Then
      colFaces.Add objNewpeoPolygon, vKey, , vAfter
    Else
      colFaces.Add objNewpeoPolygon, vKey
    End If
    Set AddFace = objNewpeoPolygon 'Pass back reference
    Set objNewpeoPolygon = Nothing 'Clean up reference
  Else
    Set AddFace = Nothing 'Signal failure by returning nothing object
  End If
  Exit Function
  
ErrorHandler:
  Set AddFace = Nothing
  Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description

End Function

Public Function Faces(ByVal vKey As Variant) As clsHwPeoPolygon
' Variant allows for string key or long index
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set Faces = colFaces.Item(vKey)
  Else
    Set Faces = Nothing 'signal failure
    Err.Raise vbObjectError + 10000, "MyObjectCollection.MyObjects", "Key value invalid"
  End If
  Exit Function

ErrorHandler:
  If Err.Number = 5 Or Err.Number = 9 Then
    Set Faces = Nothing 'Item not found
  Else
    Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description
  End If
End Function

Public Function AddFaceNormal(ByVal vKey As String, _
                    Optional ByVal vBefore As Long = 0, _
                    Optional ByVal vAfter As Long = 0) As clsVector
  
  Dim objNewPeoFaceNormal As clsVector
  
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set objNewPeoFaceNormal = New clsVector
    If vBefore > 0 Then 'Provide same functionality as Collection
      colFaceNormals.Add objNewPeoFaceNormal, vKey, vBefore
    ElseIf vAfter > 0 Then
      colFaceNormals.Add objNewPeoFaceNormal, vKey, , vAfter
    Else
      colFaceNormals.Add objNewPeoFaceNormal, vKey
    End If
    Set AddFaceNormal = objNewPeoFaceNormal 'Pass back reference
    Set objNewPeoFaceNormal = Nothing 'Clean up reference
  Else
    Set AddFaceNormal = Nothing 'Signal failure by returning nothing object
  End If
  Exit Function
  
ErrorHandler:
  Set AddFaceNormal = Nothing
  Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description

End Function


Public Function FaceNormalList(ByVal vKey As Variant) As clsVector
' Variant allows for string key or long index
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set FaceNormalList = colFaceNormals.Item(vKey)
  Else
    Set FaceNormalList = Nothing 'signal failure
    Err.Raise vbObjectError + 10000, "MyObjectCollection.MyObjects", "Key value invalid"
  End If
  Exit Function

ErrorHandler:
  If Err.Number = 5 Or Err.Number = 9 Then
    Set FaceNormalList = Nothing 'Item not found
  Else
    Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description
  End If
End Function

Public Function AddVertexNormal(ByVal vKey As String, _
                    Optional ByVal vBefore As Long = 0, _
                    Optional ByVal vAfter As Long = 0) As clsVector
  
  Dim objNewPeoVertexNormal As clsVector
  
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set objNewPeoVertexNormal = New clsVector
    If vBefore > 0 Then 'Provide same functionality as Collection
      colVertexNormals.Add objNewPeoVertexNormal, vKey, vBefore
    ElseIf vAfter > 0 Then
      colVertexNormals.Add objNewPeoVertexNormal, vKey, , vAfter
    Else
      colVertexNormals.Add objNewPeoVertexNormal, vKey
    End If
    Set AddVertexNormal = objNewPeoVertexNormal 'Pass back reference
    Set objNewPeoVertexNormal = Nothing 'Clean up reference
  Else
    Set AddVertexNormal = Nothing 'Signal failure by returning nothing object
  End If
  Exit Function
  
ErrorHandler:
  Set AddVertexNormal = Nothing
  Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description

End Function


Public Function VertexNormalList(ByVal vKey As Variant) As clsVector
' Variant allows for string key or long index
On Error GoTo ErrorHandler:

  If Len(vKey) > 0 And Len(vKey) < 51 Then
    Set VertexNormalList = colVertexNormals.Item(vKey)
  Else
    Set VertexNormalList = Nothing 'signal failure
    Err.Raise vbObjectError + 10000, "MyObjectCollection.MyObjects", "Key value invalid"
  End If
  Exit Function

ErrorHandler:
  If Err.Number = 5 Or Err.Number = 9 Then
    Set VertexNormalList = Nothing 'Item not found
  Else
    Err.Raise Err.Number, "MyObjectCollection.MyObjects", Err.Description
  End If
End Function


