VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShipMeshInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private zFaces() As clsShipMeshFace
Private zVertices() As clsShipMeshVertex
Private zFaceNormals() As clsVector
Private zVertexNormals() As clsVector

Public matrix As clsShipMatrix
Public useMatrix As Boolean
Public rotation As clsVector
Public position As clsVector
Public name As String
Public flags As Long
Public stats As clsShipMeshStats
Public animID As Long
Public sharedID As Long


Private Sub Class_Initialize()
  Set stats = New clsShipMeshStats
  Set matrix = New clsShipMatrix
  Set rotation = New clsVector
  Set position = New clsVector
End Sub

Private Sub Class_Terminate()
  Set stats = Nothing
  Set matrix = Nothing
  Set rotation = Nothing
  Set position = Nothing
  Erase zFaces
  Erase zVertices
  Erase zFaceNormals
  Erase zVertexNormals
End Sub

Public Sub AddVertex(i As Integer)
  stats.vertices = stats.vertices + 1
  ReDim Preserve zVertices(stats.vertices)
  Set zVertices(i) = New clsShipMeshVertex
End Sub

Public Property Get Vertex(i As Integer) As clsShipMeshVertex
  If i > stats.vertices Then Exit Property
  Set Vertex = zVertices(i)
End Property

Public Sub AddFace(i As Integer)
  stats.polygons = stats.polygons + 1
  ReDim Preserve zFaces(stats.polygons)
  Set zFaces(i) = New clsShipMeshFace
End Sub

Public Property Get Face(i As Integer) As clsShipMeshFace
  If i > stats.polygons Then Exit Property
  Set Face = zFaces(i)
End Property

Public Sub AddVertexNormal(i As Integer)
  stats.vertexNormals = stats.vertexNormals + 1
  ReDim Preserve zVertexNormals(stats.vertexNormals)
  Set zVertexNormals(i) = New clsVector
End Sub

Public Property Get VertexNormal(i As Integer) As clsVector
  If i > stats.vertexNormals Then Exit Property
  Set VertexNormal = zVertexNormals(i)
End Property

Public Sub AddFaceNormal(i As Integer)
  stats.faceNormals = stats.faceNormals + 1
  ReDim Preserve zFaceNormals(stats.faceNormals)
  Set zFaceNormals(i) = New clsVector
End Sub

Public Property Get FaceNormal(i As Integer) As clsVector
  If i > stats.faceNormals Then Exit Property
  Set FaceNormal = zFaceNormals(i)
End Property
