Attribute VB_Name = "modHodToHwShip"
Option Explicit
Public Const pi = 3.14159265359
Public texturePath As String
Public objHost As IHostInterface

'---------------------------------------------------------------------------------------
' Procedure : pText
' DateTime  : 13/10/2003 20:28
' Author    : Stuart
' Purpose   : Dual-purpose sub, designed to either output to a textbox (for hodTester.vbp) or for
'           : sending data back through IHostInterface to the calling program for when compiling as a DLL.
'---------------------------------------------------------------------------------------
'
Public Sub pText(message As String)
  ' Comment these lines out when compiling as a plugin
  'frmMain.Text1.SelStart = Len(frmMain.Text1.Text)
  'frmMain.Text1.SelText = message & vbCrLf
  'frmMain.Text1.Refresh
  ' Comment this line out when running standalone
  objHost.DisplayText message
End Sub

Public Sub lText(message As String)
  Open App.path & "\debug.obj" For Append As #7
  Print #7, message
  Close #7
End Sub

'---------------------------------------------------------------------------------------
' Procedure : makeShip
' DateTime  : 11/10/2003 13:00
' Author    : Stuart
' Purpose   : Takes a HOD structure (as per modHW2shipHOD by Pesmontis) and makes a
'           : clsShip structure out of it.
'---------------------------------------------------------------------------------------
'
Public Function makeShip(hodStruct As HODcomp) As clsShip
  Dim i As Integer, j As Integer, k As Integer
  Dim objNo As Integer, heirNo As Integer
  Dim meshNo As Integer
 
  Dim ship As clsShip
  Set ship = New clsShip

  ' Textures first
  ' Nothing here
  
  Dim vertCount As Long, maxVerts As Long
  Dim polyCount As Long, maxPolys As Long
  
  With hodStruct.hvmdFb
  
  pText String(80, "-") & "Heirachy"
  pText "Heirachy objects: " & hodStruct.dtrmFb.hierFb.noHobjects
  For i = 1 To hodStruct.dtrmFb.hierFb.noHobjects
    'pText i & ": " & hodStruct.dtrmFb.hierFb.hObj(i).nO & vbTab & "(Parent: " & hodStruct.dtrmFb.hierFb.hObj(i).nP & ")"
    ' How about adding the objects here instead?
    ' Add object
    heirNo = ship.objects.Add
    'ship.objects.Add heirNo
    ship.objects(heirNo).oName = hodStruct.dtrmFb.hierFb.hObj(i).nO
    ship.objects(heirNo).Parent.Value = 0
    ship.objects(heirNo).Parent.offset = i
    
    ' Add a mesh object too (although it's not always used it's needed)
    ship.mesh.Add
    ' Set the name here, but we'll overwrite later with the correct mesh name
    ship.mesh(heirNo).mName = ship.objects(heirNo).oName
    ship.objects(heirNo).refID = heirNo
    
    pText "Name: " & ship.mesh(heirNo).mName
    
    With hodStruct.dtrmFb.hierFb.hObj(i)
      ship.mesh(heirNo).position.x = .cldPos.x
      ship.mesh(heirNo).position.y = .cldPos.y
      ship.mesh(heirNo).position.z = .cldPos.z
      ship.mesh(heirNo).rotation.x = RadToDeg(.cldRot.x)
      ship.mesh(heirNo).rotation.y = RadToDeg(.cldRot.y)
      ship.mesh(heirNo).rotation.z = RadToDeg(.cldRot.z)
      
      pText "Rotation is: " & .cldRot.x & " / " & .cldRot.y & " / " & .cldRot.z
      pText "CldScl is: " & .cldScl.x & " / " & .cldScl.y & " / " & .cldScl.z
      pText "CldWrl is: " & RadToDeg(.cldWrl.x) & " / " & RadToDeg(.cldWrl.y) & " / " & RadToDeg(.cldWrl.z)
      
      ship.mesh(heirNo).rotationWorld.x = RadToDeg(.cldWrl.x)
      ship.mesh(heirNo).rotationWorld.y = RadToDeg(.cldWrl.y)
      ship.mesh(heirNo).rotationWorld.z = RadToDeg(.cldWrl.z)
    End With
    
    'ship.PEO.Add objNo
    'ship.numObjects = ship.numObjects + 1
    'ship.PEO.object(objNo).objName = hodStruct.dtrmFb.hierFb.hObj(i).nO
    ' Set mother value to 0 for now
    'ship.PEO.object(objNo).Mother.Value = 0
    ' Actual heirachy object number
    'ship.PEO.object(objNo).Mother.offset = i
  Next i
  
  
  pText String(80, "-") & "Shaders"
  
  pText "LMIP"
  
  Dim nDDSNameLength As Long
  Dim sDDSName As String
  
  ' LMIPS run from 0 not 1!
  For i = 0 To UBound(.lmipCh)
    ' first off extract a sensible file name
    nDDSNameLength = Len(.lmipCh(i).lmipFh.nFDN) - InStrRev(.lmipCh(i).lmipFh.nFDN, "/") - 7
    sDDSName = Mid(.lmipCh(i).lmipFh.nFDN, InStrRev(.lmipCh(i).lmipFh.nFDN, "/") + 1, nDDSNameLength) & _
                           Right(.lmipCh(i).lmipFh.nFDN, 3) & ".DDS"
    'pText sDDSName
    
    ship.textures.Add i
    ship.textures(i).Name = sDDSName
    ship.textures(i).MipLevels = .lmipCh(i).lmipFb.lmipBh.noMIPls
    
    exportDDS texturePath & sDDSName, .lmipCh(i).lmipFb
    pText "Texture " & i & " -> " & sDDSName
  Next i
  pText ""
 
  ' Texture/Shaders
  pText "STAT"
  'Dim matCount As Integer
  'Dim highestTexTag As Integer
  For i = 0 To UBound(.statCh)
    pText i & ": " & .statCh(i).statFb.nTgrp & " - " & .statCh(i).statFb.nType
    
    ' Okay, add a "material" - note they should be zero based
    ship.materials.Add i
    ' Set the material type to Shader
    ship.materials(i).matType = matShader
      
    
    For j = 1 To .statCh(i).statFb.noShaders
      pText "  " & j & ": " & .statCh(i).statFb.shader(j).nShad & " - " & .statCh(i).statFb.shader(j).texTag & " ( " & ship.textures(CLng(.statCh(i).statFb.shader(j).texTag)).Name & " ) "         'If .statCh(i).statFb.shader(j).texTag > highestTexTag Then highestTexTag = .statCh(i).statFb.shader(j).texTag
      'pText " " & .statCh(i).statFb.shader(j).unknown1 & " - " & .statCh(i).statFb.shader(j).unknown2
      
      ' Add a texture, 1 base
      ship.materials(i).AddTexture j
      
      ' Check out what shader type it is
      Select Case .statCh(i).statFb.shader(j).nShad
      Case "$diffuse":
        ship.materials(i).Texture(j).texType = texDiffuse
      Case "$glow":
        ship.materials(i).Texture(j).texType = texGlow
      Case "$diffuseOn":
        ship.materials(i).Texture(j).texType = texDiffuseOn
      Case "$diffuseOff":
        ship.materials(i).Texture(j).texType = texDiffuseOff
      Case "$glowOn":
        ship.materials(i).Texture(j).texType = texGlowOn
      Case "$glowOff":
        ship.materials(i).Texture(j).texType = texGlowOff
      Case "$mask":
        ship.materials(i).Texture(j).texType = texMask
      End Select
      
      ' Reference into the texture (LMIP) array
      ship.materials(i).Texture(j).textureId = .statCh(i).statFb.shader(j).texTag
      
    Next j
  Next i
  
  pText String(80, "-") & "Object Info"
  ' Loop through normal objects first
  For i = 1 To UBound(.multCh)
    pText .multCh(i).multFb.nM
    For j = 1 To .multCh(i).multFb.noBMSHs
      pText "Heirachy name: " & .multCh(i).multFb.nO & " Lod: " & .multCh(i).multFb.bmshCh(j).bmshFb.LOD
      
      'For k = 1 To .multCh(i).multFb.bmshCh(j).bmshFb.noMshs
      '  pText "    Vertices: " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noVtcs
      '  pText "    Faces: " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noFcs
      '  pText "    TexTag: " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).texTag
      'Next
    
      If .multCh(i).multFb.bmshCh(j).bmshFb.LOD = CLng(frmConfigure.txtLoD) Then
    
        ' Store the heirachy number in the mother offset for now for later lookup
        meshNo = getHeirachyNo(.multCh(i).multFb.nO, hodStruct.dtrmFb.hierFb)
        ship.objects(meshNo).objType = objMesh
        
        'meshNo = meshNo + 1
        'ship.mesh.Add meshNo
        'ship.objects(heirNo).refID = meshNo
        
        'ship.PEO.object(objNo).Mother.offset = objNo
        pText "Heirachy number: " & meshNo
        ' Build the matrix from the heirachy information
        'Set ship.PEO.object(objNo).matrix = BuildMatrix(.multCh(i).multFb.nO, hodStruct.dtrmFb.hierFb)
        
        ship.mesh(meshNo).useMatrix = False
        'ship.PEO.object(objNo).useMatrix = False
        Set ship.mesh(meshNo).position = GetPosition(.multCh(i).multFb.nO, hodStruct.dtrmFb.hierFb)
        Set ship.mesh(meshNo).rotation = GetRotation(.multCh(i).multFb.nO, hodStruct.dtrmFb.hierFb)

        pText "Rotation: " & ship.mesh(meshNo).rotation.x & " / " & ship.mesh(meshNo).rotation.y & " / " & ship.mesh(meshNo).rotation.z
        'Set ship.PEO.object(objNo).position = GetPosition(.multCh(i).multFb.nO, hodStruct.dtrmFb.hierFb)
        'Set ship.PEO.object(objNo).rotation = GetRotation(.multCh(i).multFb.nO, hodStruct.dtrmFb.hierFb)
        
        ship.mesh(meshNo).mName = .multCh(i).multFb.nM
        'ship.PEO.object(objNo).objName = .multCh(i).multFb.nM
        
        'BuildMatrix .multCh(i).multFb.nO, hodStruct.dtrmFb.hierFb
        
        'pText "  Lod" & Str(.multCh(i).multFb.bmshCh(j).bmshFb.LOD) & " - " & .multCh(i).multFb.bmshCh(j).bmshFb.noMshs
        
        maxVerts = 0: maxPolys = 0
        For k = 1 To .multCh(i).multFb.bmshCh(j).bmshFb.noMshs
          
          'lText "# BMSH ( " & j & " ) ShipMesh ( " & k & " ) " & .multCh(i).multFb.nM
          
          pText "    Vertices: " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noVtcs
          pText "    Faces: " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noFcs
          pText "    TexTag: " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).texTag
          pText "    Dwords: " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).dwordsPerVtx
          
          ' Vertices
          For vertCount = 1 To .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noVtcs
            ship.mesh(meshNo).AddVertex (vertCount + maxVerts)
            'ship.PEO.object(objNo).AddVertex (vertCount + maxVerts)
            ship.mesh(meshNo).Vertex(vertCount + maxVerts).position.x = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(vertCount).vCo.x
            ship.mesh(meshNo).Vertex(vertCount + maxVerts).position.y = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(vertCount).vCo.y
            ship.mesh(meshNo).Vertex(vertCount + maxVerts).position.z = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(vertCount).vCo.z
            
            'lText "v " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(vertCount).vCo.x & " " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(vertCount).vCo.y & " " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(vertCount).vCo.z & " # " & vertCount + maxVerts
            
          Next
          
          'lText "# Vert offset so Far: " & maxVerts & " / No Of Verts " & .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noVtcs
          
          ' Polygons
          For polyCount = 1 To .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noFcs
          
            ship.mesh(meshNo).AddFace (polyCount + maxPolys)
            ' Note, TexTag here is actually an index into the STAT array
            ship.mesh(meshNo).Face(polyCount + maxPolys).material = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).texTag
            ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v0 = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(1) + maxVerts + 1
            ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v1 = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(2) + maxVerts + 1
            ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v2 = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(3) + maxVerts + 1
            
            'lText "f " & ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v0 & " " & ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v1 & " " & ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v2
            
            ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v0u = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(1) + 1).tCo.u
            ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v0v = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(1) + 1).tCo.v
            ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v1u = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(2) + 1).tCo.u
            ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v1v = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(2) + 1).tCo.v
            ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v2u = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(3) + 1).tCo.u
            ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v2v = .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipVtx(.multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).shipFc(polyCount).vtx(3) + 1).tCo.v
          Next
          
          maxPolys = maxPolys + .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noFcs
          maxVerts = maxVerts + .multCh(i).multFb.bmshCh(j).bmshFb.shipmesh(k).noVtcs
          'lText "# " & maxVerts & " verts so far"
          
          pText "Calculated max: " & maxVerts & " / " & maxPolys
          pText "Stored max: " & ship.mesh(meshNo).stats.vertices & " / " & ship.mesh(meshNo).stats.polygons
          
          'ship.PEO.object(objNo).stats.nVertices = maxVerts
          'ship.PEO.object(objNo).stats.nPolygons = maxPolys
          
        Next k
      End If
    Next j
  Next i
  
  ' Now get the Goblin chunk if any
  If GOBGpresence = True Then
    For i = 1 To UBound(.gobgCh)
      pText .gobgCh(i).gobgFb.nG & " (" & .gobgCh(i).gobgFb.bmshFb.noMshs & ")"
      For j = 1 To .gobgCh(i).gobgFb.bmshFb.noMshs
        pText "  " & j & ": " & .gobgCh(i).gobgFb.bmshFb.LOD
        If .gobgCh(i).gobgFb.bmshFb.LOD = frmConfigure.txtLoD Then

          ' Goblins aren't in the heirachy so add object
          pText "Goblin found!"
          'heirNo = ship.objects.Count + 1
          ' Add heirachy
          heirNo = ship.objects.Add
          ship.objects(heirNo).objType = objMesh
          ship.objects(heirNo).oName = .gobgCh(i).gobgFb.nG

          'ship.PEO.Add objNo
          'ship.numObjects = ship.numObjects + 1
          'ship.PEO.object(objNo).objName = .gobgCh(i).gobgFb.nG ' & "_goblin"

          ' dont get objNo from heirachy cuz it wont have one
          'objNo = getHeirachyNo(.gobgCh(i).gobgFb.nO, hodStruct.dtrmFb.hierFb)
          'Set ship.PEO.object(objNo).matrix = BuildMatrix(.gobgCh(i).gobgFb.nO, hodStruct.dtrmFb.hierFb)

          ' Add mesh
          'meshNo = ship.mesh.Count + 1
          meshNo = ship.mesh.Add
          ship.mesh(meshNo).useMatrix = False
          ship.objects(heirNo).refID = meshNo

          'ship.PEO.object(objNo).useMatrix = False
          'Set ship.mesh(meshNo).position = GetPosition(.gobgCh(i).gobgFb.nO, hodStruct.dtrmFb.hierFb)
          'Set ship.mesh(meshNo).rotation = GetRotation(.gobgCh(i).gobgFb.nO, hodStruct.dtrmFb.hierFb)

          ' Store the heirachy number in the mother offset for now for later lookup
          'ship.PEO.object(objNo).Mother.offset = 0
          ship.objects(heirNo).Parent.offset = 0

          pText "  Lod" & Str(.gobgCh(i).gobgFb.bmshFb.LOD) & " - " & .gobgCh(i).gobgFb.bmshFb.noMshs
          maxVerts = 0: maxPolys = 0
          For k = 1 To .gobgCh(i).gobgFb.bmshFb.noMshs
            pText "    Vertices: " & .gobgCh(i).gobgFb.bmshFb.shipmesh(k).noVtcs
            pText "    Faces: " & .gobgCh(i).gobgFb.bmshFb.shipmesh(k).noFcs
            pText "    TexTag: " & .gobgCh(i).gobgFb.bmshFb.shipmesh(k).texTag

            ' Vertices
            For vertCount = 1 To .gobgCh(i).gobgFb.bmshFb.shipmesh(k).noVtcs
              ship.mesh(meshNo).AddVertex (vertCount + maxVerts)
              ship.mesh(meshNo).Vertex(vertCount + maxVerts).position.x = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(vertCount).vCo.x
              ship.mesh(meshNo).Vertex(vertCount + maxVerts).position.y = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(vertCount).vCo.y
              ship.mesh(meshNo).Vertex(vertCount + maxVerts).position.z = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(vertCount).vCo.z
            Next

            ' Polygons
            For polyCount = 1 To .gobgCh(i).gobgFb.bmshFb.shipmesh(k).noFcs
              ship.mesh(meshNo).AddFace (polyCount + maxPolys)
              ship.mesh(meshNo).Face(polyCount + maxPolys).material = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).texTag
              ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v0 = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(1) + maxVerts + 1
              ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v1 = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(2) + maxVerts + 1
              ship.mesh(meshNo).Face(polyCount + maxPolys).Vertex.v2 = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(3) + maxVerts + 1
              ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v0u = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(.gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(1) + 1).tCo.u
              ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v0v = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(.gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(1) + 1).tCo.v
              ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v1u = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(.gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(2) + 1).tCo.u
              ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v1v = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(.gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(2) + 1).tCo.v
              ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v2u = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(.gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(3) + 1).tCo.u
              ship.mesh(meshNo).Face(polyCount + maxPolys).texList.v2v = .gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipVtx(.gobgCh(i).gobgFb.bmshFb.shipmesh(k).shipFc(polyCount).vtx(3) + 1).tCo.v
            Next
            
            maxPolys = maxPolys + .gobgCh(i).gobgFb.bmshFb.shipmesh(k).noFcs
            maxVerts = maxVerts + .gobgCh(i).gobgFb.bmshFb.shipmesh(k).noVtcs
            
          Next k
        End If
      Next j
    Next i
  End If
  
  
  End With
  
  
  ' Bounding box
  With hodStruct.dtrmFb
  For i = 1 To UBound(.bsrmCh)
    objNo = ship.objects.Add
    ship.objects(objNo).oName = "Bounding Box"
    ship.objects(objNo).objType = objMeshExtension
    ship.objects(objNo).refID = i
    
    ship.objects(objNo).Parent.Value = getHeirachyNo(.bsrmCh(i).bsrmFb.descFb.nO, hodStruct.dtrmFb.hierFb)

    heirNo = ship.mex.Add
    ship.mex(heirNo).objectId = ship.objects.Count
    ship.mex(heirNo).mexType = 1
    ship.mex(heirNo).AddPoint 1
    
    pText "Bounding Box:"
    pText "Size 1: " & .bsrmCh(i).bsrmFb.bboxFb.leftLowerCorner.x & " / " & .bsrmCh(i).bsrmFb.bboxFb.leftLowerCorner.y & " / " & .bsrmCh(i).bsrmFb.bboxFb.leftLowerCorner.z
    pText "Size 2: " & .bsrmCh(i).bsrmFb.bboxFb.edgeSizes.x & " / " & .bsrmCh(i).bsrmFb.bboxFb.edgeSizes.y & " / " & .bsrmCh(i).bsrmFb.bboxFb.edgeSizes.z
    
    ship.mex(heirNo).Point(1).position.x = .bsrmCh(i).bsrmFb.bboxFb.leftLowerCorner.x
    ship.mex(heirNo).Point(1).position.y = .bsrmCh(i).bsrmFb.bboxFb.leftLowerCorner.y
    ship.mex(heirNo).Point(1).position.z = .bsrmCh(i).bsrmFb.bboxFb.leftLowerCorner.z
    ship.mex(heirNo).Point(1).Normal.x = .bsrmCh(i).bsrmFb.bboxFb.edgeSizes.x * 2
    ship.mex(heirNo).Point(1).Normal.y = .bsrmCh(i).bsrmFb.bboxFb.edgeSizes.y * 2
    ship.mex(heirNo).Point(1).Normal.z = .bsrmCh(i).bsrmFb.bboxFb.edgeSizes.z * 2
  Next
  
  'i = ship.mex.Count + 1
  objNo = ship.objects.Add
  ship.objects(objNo).oName = "Camera Bounding Box"
  ship.objects(objNo).objType = objMeshExtension
  ship.objects(objNo).refID = i
  
    ship.objects(objNo).Parent.Value = getHeirachyNo(.bndvFb.nO, hodStruct.dtrmFb.hierFb)

    i = ship.mex.Add
    ship.mex(i).objectId = ship.objects.Count
    ship.mex(i).mexType = meshBoundingBox
    ship.mex(i).AddPoint 1
    
    pText "Camera Bounding Box:"
    pText "Size 1: " & .bndvFb.leftLowerCorner.x & " / " & .bndvFb.leftLowerCorner.y & " / " & .bndvFb.leftLowerCorner.z
    pText "Size 2: " & .bndvFb.rightUpperCorner.x & " / " & .bndvFb.rightUpperCorner.y & " / " & .bndvFb.rightUpperCorner.z
    
    ship.mex(i).Point(1).position.x = .bndvFb.leftLowerCorner.x
    ship.mex(i).Point(1).position.y = .bndvFb.leftLowerCorner.y
    ship.mex(i).Point(1).position.z = .bndvFb.leftLowerCorner.z
    ship.mex(i).Point(1).Normal.x = .bndvFb.rightUpperCorner.x * 2
    ship.mex(i).Point(1).Normal.y = .bndvFb.rightUpperCorner.y * 2
    ship.mex(i).Point(1).Normal.z = .bndvFb.rightUpperCorner.z * 2

  End With
  
  'For i = 0 To ship.materials.Count - 1
  '  pText "Material " & i & " -> " & ship.materials(i).nFullAmbient
  'Next i
  
  
  
  pText String(80, "-") & "Parents"
  ' Resolve parental issues =)
  For i = 1 To ship.objects.Count
    If ship.objects(i).Parent.offset > 1 Then
      ship.objects(i).Parent.Value = getParentNo(ship.objects(i).Parent.offset, hodStruct.dtrmFb.hierFb)
      pText ship.objects(i).oName & " has parent: " & ship.objects(ship.objects(i).Parent.Value).oName
    End If
  Next i
    
  Set makeShip = ship
  Set ship = Nothing
  
End Function

Private Function getHeirachyNo(searchName As String, heirachy As hierB) As Long
  Dim i As Integer
  ' First, search the heirachy
  For i = 1 To heirachy.noHobjects
    If heirachy.hObj(i).nO = searchName Then Exit For
  Next i
  
  getHeirachyNo = i
End Function

Private Function getParentNo(heirachyNo As Long, heirachy As hierB) As Long
  Dim i As Integer
  For i = 1 To heirachy.noHobjects
    If heirachy.hObj(i).nO = heirachy.hObj(heirachyNo).nP Then Exit For
  Next
  getParentNo = i
End Function

Private Function GetRotation(searchName As String, heirachy As hierB) As clsVector
  Dim i As Integer
  ' First, search the heirachy
  For i = 1 To heirachy.noHobjects
    If heirachy.hObj(i).nO = searchName Then Exit For
  Next i

  Dim tmpVector As New clsVector

  tmpVector.x = RadToDeg(heirachy.hObj(i).cldRot.x)
  tmpVector.y = RadToDeg(heirachy.hObj(i).cldRot.y)
  tmpVector.z = RadToDeg(heirachy.hObj(i).cldRot.z)
  
  Set GetRotation = tmpVector
  Set tmpVector = Nothing
  
End Function

Private Function GetPosition(searchName As String, heirachy As hierB) As clsVector
  Dim i As Integer
  ' First, search the heirachy
  For i = 1 To heirachy.noHobjects
    If heirachy.hObj(i).nO = searchName Then Exit For
  Next i

  Dim tmpVector As New clsVector

  tmpVector.x = heirachy.hObj(i).cldPos.x
  tmpVector.y = heirachy.hObj(i).cldPos.y
  tmpVector.z = heirachy.hObj(i).cldPos.z
  
  Set GetPosition = tmpVector
  Set tmpVector = Nothing
  
End Function

' Convert from radians to degrees
Function RadToDeg(radians) As Single

  RadToDeg = radians * 180 / pi
  
End Function
