Attribute VB_Name = "modImportHOD"
Option Explicit

Dim HODFile As tagHODFile

Dim DDS_DWMAGIC As String * 4
Dim DDS_DWSIZE As Long
Dim DDS_DWFLAGS As Long
Dim DDS_DWDEPTH As Long
Dim DDS_DWRESERVED As Long
Dim DDS_PIXELFORMAT_DWSIZE As Long
Dim DDS_PIXELFORMAT_DWFLAGS As Long
Dim DDS_PIXELFORMAT_DWRGBBITCOUNT As Long
Dim DDS_PIXELFORMAT_DWRBITMASK As Long
Dim DDS_PIXELFORMAT_DWGBITMASK As Long
Dim DDS_PIXELFORMAT_DWBBITMASK As Long
Dim DDS_PIXELFORMAT_DWRGBALPHABITMASK As Long
Dim DDS_DDSCAPS_DWCAPS1 As Long
Dim DDS_DDSCAPS_DWCAPS2 As Long
Dim DDS_DDSCAPS_DWRESERVED As Long

Public Function ImportHOD(sFile As String, objHost As IHostInterface) As clsHwShip
    
    Dim ship As clsHwShip
    Set ship = New clsHwShip
    
    objHost.DisplayText "Opening " & sFile & "..."
    
    ' read the contents of the .big file populating the tree view
    Dim chunk As Byte
    Dim h As Integer
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim nFilePos As Long
    Dim sID As String * 4
    Dim nMaxIndex As Long
    Dim nGroupMax As Long
    Dim nLoop As Integer
    Dim nBMSH As Integer
    Dim nPOLY As Integer
    Dim nVNT As Integer
    Dim nGroups As Integer
    Dim nLoD As Integer
    Dim sDDSName As String
    Dim sDDSLongName As String
    Dim nDDSNameLength As Integer
    Dim sFirstTexture As String
    Dim LMIPGroup() As tagLMIPGroup
    Dim sFileShortName As String
    Dim nETSH As Integer
    Dim nBURN As Integer
    
    nGroupMax = 0
    
    ' reset the treeview
    'tvwHOD.Nodes.Clear
    'tvwHOD.LineStyle = tvwRootLines
    'tvwHOD.Style = tvwTreelinesPlusMinusText
    'tvwHOD.Indentation = 80
    
    ' open the input file
    Open sFile For Binary As #1
    
    'txtDebug.Text = ""
    'StatusBar1.SimpleText = sFile
    
    'tvwHOD.Nodes.Clear
    'tvwHOD.LineStyle = tvwRootLines
    'tvwHOD.Style = tvwTreelinesPlusMinusText
    'tvwHOD.Indentation = 80
    
    'prgBar.Min = 0
    'prgBar.Max = 1
    'prgBar.Value = 0

    With HODFile.VERS
        Get #1, , .sFORM
        Get #1, , .nVERSLength
        Get #1, , .sVERS
        Get #1, , .nVERS
    
        sText (.sFORM & " Length=" & ReverseLong(.nVERSLength))
        sText (.sVERS & "= " & .nVERS)
    End With
    
    With HODFile.NAME
        Get #1, , .sFORM
        Get #1, , .nNameLength
        Get #1, , .sName
    
        .sNAMEFileType = ""
            
        For i = 1 To ReverseLong(.nNameLength) - 4
            Get #1, , chunk
            If Val(chunk) > 0 Then
                .sNAMEFileType = .sNAMEFileType & Chr$(chunk)
            End If
        Next i
    
        sText (.sFORM & " Length=" & ReverseLong(.nNameLength))
        sText (.sName & "= " & .sNAMEFileType)
    End With
        
    With HODFile.HVMD
        Get #1, , .sFORM
        Get #1, , .nHVMDLength
        Get #1, , .sHVMD
        
        sText (.sFORM & " Length=" & ReverseLong(.nHVMDLength))
        sText (.sHVMD)
        
        ReDim .NRMLSTAT(1 To 1)
        j = 0
        Do
            Get #1, , sID
            
            If sID <> "NRML" Then Exit Do
            
            j = j + 1
            ReDim Preserve .NRMLSTAT(1 To j)
            
            .NRMLSTAT(j).sNRML = sID
            Get #1, , .NRMLSTAT(j).nSTATLength
            Get #1, , .NRMLSTAT(j).sSTAT
            
            sText (.NRMLSTAT(j).sNRML & j)
            sText (.NRMLSTAT(j).sSTAT & " Length=" & ReverseLong(.NRMLSTAT(j).nSTATLength))
            
            .NRMLSTAT(j).sSTATdata = ""
                
            For i = 1 To ReverseLong(.NRMLSTAT(j).nSTATLength) - 4
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .NRMLSTAT(j).sSTATdata = .NRMLSTAT(j).sSTATdata & Chr$(chunk)
                End If
            Next i
        Loop
        
        sID = ""
        
        nFilePos = Seek(1) - 4
        Seek #1, nFilePos
        
        ReDim .LMIP(1 To 1)
        
        j = 0
        Do
            Get #1, , sID
            
            If sID <> "LMIP" Then Exit Do

            j = j + 1
            ReDim Preserve .LMIP(1 To j)

            .LMIP(j).sLMIP = sID
            Get #1, , .LMIP(j).nLMIPLength
            Get #1, , .LMIP(j).nLMIPNameLength

            .LMIP(j).sLMIPName = ""

            For i = 1 To .LMIP(j).nLMIPNameLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .LMIP(j).sLMIPName = .LMIP(j).sLMIPName & Chr$(chunk)
                End If
            Next i

            Get #1, , .LMIP(j).sDXT5
            Get #1, , .LMIP(j).nNumMipLevels
            Get #1, , .LMIP(j).nWidth
            Get #1, , .LMIP(j).nHeight

            sText (Seek(1))

            ReDim .LMIP(j).dImage(1 To ReverseLong(.LMIP(j).nLMIPLength) - 20 - .LMIP(j).nLMIPNameLength)
            Get #1, , .LMIP(j).dImage

            .LMIP(j).nLMIPNameSequence = Mid(.LMIP(j).sLMIPName, InStrRev(.LMIP(j).sLMIPName, "[") + 1, 1)
            
            sText (.LMIP(j).sLMIP & " Length=" & ReverseLong(.LMIP(j).nLMIPLength))
            sText ("Name Length=" & .LMIP(j).nLMIPNameLength)
            sText (.LMIP(j).sLMIPName)
            sText ("Sequence Num=" & .LMIP(j).nLMIPNameSequence)
            sText (.LMIP(j).sDXT5 & " MIP Levels=" & .LMIP(j).nNumMipLevels & ", Size=" & _
                   .LMIP(j).nWidth & " x " & .LMIP(j).nHeight)
        Loop
    
        ' group the textures by name and then sequence correctly
        nDDSNameLength = Len(.LMIP(1).sLMIPName) - InStrRev(.LMIP(1).sLMIPName, "/") - 7
        .LMIP(1).sDDSName = Mid(.LMIP(1).sLMIPName, InStrRev(.LMIP(1).sLMIPName, "/") + 1, nDDSNameLength)
        sDDSName = Mid(.LMIP(1).sLMIPName, InStrRev(.LMIP(1).sLMIPName, "/") + 1, nDDSNameLength)
        .LMIP(1).sDDSLongName = Mid(.LMIP(1).sLMIPName, InStrRev(.LMIP(1).sLMIPName, "/") + 1, nDDSNameLength) & _
                                Right(.LMIP(1).sLMIPName, 3)
        sDDSLongName = Mid(.LMIP(1).sLMIPName, InStrRev(.LMIP(1).sLMIPName, "/") + 1, nDDSNameLength) & _
                       Right(.LMIP(1).sLMIPName, 3)
        sFirstTexture = sDDSName
        
        k = 0
        For i = 1 To j
            nDDSNameLength = Len(.LMIP(i).sLMIPName) - InStrRev(.LMIP(i).sLMIPName, "/") - 7
            .LMIP(i).sDDSName = Mid(.LMIP(i).sLMIPName, InStrRev(.LMIP(i).sLMIPName, "/") + 1, nDDSNameLength)
            sDDSName = Mid(.LMIP(i).sLMIPName, InStrRev(.LMIP(i).sLMIPName, "/") + 1, nDDSNameLength)
            .LMIP(i).sDDSLongName = Mid(.LMIP(i).sLMIPName, InStrRev(.LMIP(i).sLMIPName, "/") + 1, nDDSNameLength) & _
                           Right(.LMIP(i).sLMIPName, 3)
            sDDSLongName = Mid(.LMIP(i).sLMIPName, InStrRev(.LMIP(i).sLMIPName, "/") + 1, nDDSNameLength) & _
                           Right(.LMIP(i).sLMIPName, 3)
            If sFirstTexture = sDDSName Then
                .LMIP(i).nLMIPNameGroup = k
            Else
                k = k + 1
                .LMIP(i).nLMIPNameGroup = k
                sFirstTexture = sDDSName
            End If
            sText ("sDDSLongName" & i & "=" & sDDSLongName & " Group=" & .LMIP(i).nLMIPNameGroup)
        Next i
    
        ReDim LMIPGroup(0 To k)
        LMIPGroup(0).sGroupFileName = .LMIP(1).sDDSName
        LMIPGroup(0).sGroupName = .LMIP(1).sDDSName
        For h = 0 To k
            LMIPGroup(h).nLMIPNameSequence = 100
            For i = 1 To j
                If .LMIP(i).nLMIPNameSequence < LMIPGroup(h).nLMIPNameSequence And h = .LMIP(i).nLMIPNameGroup Then
                    LMIPGroup(h).sGroupFileName = ".\" & .LMIP(i).sDDSLongName & ".BMP"
                    LMIPGroup(h).sGroupName = .LMIP(i).sDDSName
                    LMIPGroup(h).nLMIPNameSequence = .LMIP(i).nLMIPNameSequence
                End If
            Next i
            sText ("Group=" & h & ", Name=" & LMIPGroup(h).sGroupName & _
                   "File Name=" & LMIPGroup(h).sGroupFileName & ", Sequence=" & LMIPGroup(h).nLMIPNameSequence)
        Next h
    
        'If chkExtractTextures.Value = vbChecked Then
            ' write out the files
            ' a standard .DDS header needs to be put at the start of the file
            ' DDS File constants
            DDS_DWMAGIC = "DDS "
            DDS_DWSIZE = 124
            DDS_DWFLAGS = 659463
            DDS_DWDEPTH = 0
            DDS_DWRESERVED = 0
            DDS_PIXELFORMAT_DWSIZE = 32
            DDS_PIXELFORMAT_DWFLAGS = 4
            DDS_PIXELFORMAT_DWRGBBITCOUNT = 0
            DDS_PIXELFORMAT_DWRBITMASK = 0
            DDS_PIXELFORMAT_DWGBITMASK = 0
            DDS_PIXELFORMAT_DWBBITMASK = 0
            DDS_PIXELFORMAT_DWRGBALPHABITMASK = 0
            DDS_DDSCAPS_DWCAPS1 = 4198408
            DDS_DDSCAPS_DWCAPS2 = 0
            DDS_DDSCAPS_DWRESERVED = 0
        
            For i = 1 To j
                ' first off extract a sensible file name
                nDDSNameLength = Len(.LMIP(i).sLMIPName) - InStrRev(.LMIP(i).sLMIPName, "/") - 7
                sDDSName = Mid(.LMIP(i).sLMIPName, InStrRev(.LMIP(i).sLMIPName, "/") + 1, nDDSNameLength) & _
                           Right(.LMIP(i).sLMIPName, 3) & ".DDS"
                
                ship.materials.Add i - 1
                ship.materials(i - 1).texture = i - 1
                ship.textures.Add i - 1
                ship.textures(i - 1).texName = sDDSName
                objHost.DisplayText "Adding texture " & i & ": " & sDDSName
                ship.Files.texturePath = Mid$(sFile, 1, InStrRev(sFile, "\"))
                ship.textures(i - 1).mipLevels = .LMIP(i).nNumMipLevels
                'ship.textures(i - 1).pixelFormat = .LMIP(i).sDXT5
                
                Open ship.Files.texturePath & sDDSName For Binary As #2
                    Put #2, , DDS_DWMAGIC
                    Put #2, , DDS_DWSIZE
                    Put #2, , DDS_DWFLAGS
                    Put #2, , .LMIP(i).nHeight
                    Put #2, , .LMIP(i).nWidth
                    Put #2, , .LMIP(i).nHeight * .LMIP(i).nWidth
                    Put #2, , DDS_DWDEPTH
                    Put #2, , .LMIP(i).nNumMipLevels
                    For k = 1 To 11
                        Put #2, , DDS_DWRESERVED
                    Next k
                    Put #2, , DDS_PIXELFORMAT_DWSIZE
                    Put #2, , DDS_PIXELFORMAT_DWFLAGS
                    Put #2, , .LMIP(i).sDXT5
                    Put #2, , DDS_PIXELFORMAT_DWRGBBITCOUNT
                    Put #2, , DDS_PIXELFORMAT_DWRBITMASK
                    Put #2, , DDS_PIXELFORMAT_DWGBITMASK
                    Put #2, , DDS_PIXELFORMAT_DWBBITMASK
                    Put #2, , DDS_PIXELFORMAT_DWRGBALPHABITMASK
                    Put #2, , DDS_DDSCAPS_DWCAPS1
                    Put #2, , DDS_DDSCAPS_DWCAPS2
                    Put #2, , DDS_DDSCAPS_DWRESERVED
                    Put #2, , DDS_DDSCAPS_DWRESERVED
                    Put #2, , DDS_DWRESERVED
                    Put #2, , .LMIP(i).dImage
                Close #2
            Next i
        'End If
    
        sID = ""
        
        nFilePos = Seek(1) - 4
        Seek #1, nFilePos
        sText (nFilePos)
        
        Dim objNo As Long
        Dim maxVerts As Long
        Dim maxPolys As Long
        
        j = 0
        Do
            Get #1, , sID
            
            If sID <> "NRML" Then Exit Do

            j = j + 1

            ReDim Preserve .NRMLMULT(1 To j)

            .NRMLMULT(j).sNRML = sID
            Get #1, , .NRMLMULT(j).nNRMLLength
            Get #1, , .NRMLMULT(j).sMULT
            Get #1, , .NRMLMULT(j).nMULTLength
            Get #1, , .NRMLMULT(j).nMULTNameLength

            If .NRMLMULT(j).sMULT = "GOBG" Then Exit Do

            .NRMLMULT(j).sMULTName = ""

            For i = 1 To .NRMLMULT(j).nMULTNameLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .NRMLMULT(j).sMULTName = .NRMLMULT(j).sMULTName & Chr$(chunk)
                End If
            Next i

            Get #1, , .NRMLMULT(j).nNameLength
            
            .NRMLMULT(j).sName = ""
            
            For i = 1 To .NRMLMULT(j).nNameLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .NRMLMULT(j).sName = .NRMLMULT(j).sName & Chr$(chunk)
                End If
            Next i
            
                'If nLoD = frmConfigure.txtLoD.Text Then
                  objNo = objNo + 1
                  ship.PEO.Add objNo
                  ship.numObjects = ship.numObjects + 1
                  ship.PEO.object(objNo).objName = .NRMLMULT(j).sName & "_lod" & frmConfigure.txtLoD.Text
                  objHost.DisplayText "Adding object " & objNo & ": " & .NRMLMULT(j).sName & "_lod" & frmConfigure.txtLoD.Text
                
                  ' Add a new object
                  maxVerts = 0
                  maxPolys = 0
                
                'End If
            

            'If chkExtractObjects.Value = vbChecked Then
                Open Left(sFile, Len(sFile) - 4) & "_" & .NRMLMULT(j).sName & "_lod" & frmConfigure.txtLoD.Text & _
                     ".obj" For Output As #10
                     
                objHost.DisplayText Left(sFile, Len(sFile) - 4) & "_" & .NRMLMULT(j).sName & "_lod" & frmConfigure.txtLoD.Text & ".obj"
                     
                Open Left(sFile, Len(sFile) - 4) & "_" & .NRMLMULT(j).sName & "_lod" & frmConfigure.txtLoD.Text & _
                     ".mtl" For Output As #11
                     
                dText ("#")
                dText ("# Wavefront OBJ File")
                dText ("# Created by Spooky's HOD Viewer Tool v" & App.Major & "." & App.Minor & "." & App.Revision)
                dText ("# http://www.b5mods.com")
                dText ("#")
                dText ("")
                dText ("mtllib " & Mid(sFile, InStrRev(sFile, "\") + 1, _
                        InStrRev(sFile, ".") - 1 - InStrRev(sFile, "\")) & "_" & _
                        .NRMLMULT(j).sName & "_lod" & frmConfigure.txtLoD.Text & ".mtl")
                dText ("")
            
                Print #11, "#"
                Print #11, "# Wavefront MTL File"
                Print #11, "# Created by Spooky's HOD Viewer Tool v" & App.Major & "." & App.Minor & "." & App.Revision
                Print #11, "# http://www.b5mods.com"
                Print #11, "#"
                Print #11, ""
            'End If
            
            sText (.NRMLMULT(j).sNRML & " Length=" & ReverseLong(.NRMLMULT(j).nNRMLLength))
            sText (.NRMLMULT(j).sMULT & " Length=" & ReverseLong(.NRMLMULT(j).nMULTLength))
            sText ("MULT Name Length=" & .NRMLMULT(j).nMULTNameLength)
            sText (.NRMLMULT(j).sMULTName)
            sText ("Name Length=" & .NRMLMULT(j).nNameLength)
            sText (.NRMLMULT(j).sName)
            
            Get #1, , .NRMLMULT(j).nNumNRMLBMSH
            sText ("Num BMSH=" & .NRMLMULT(j).nNumNRMLBMSH)
            
            ReDim .NRMLMULT(j).NRMLBMSH(1 To .NRMLMULT(j).nNumNRMLBMSH)
        
            For nBMSH = 1 To .NRMLMULT(j).nNumNRMLBMSH
            
                Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).sNRML
                Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nNRMLLength
                Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).sBMSH
                Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nBMSHLength
    
                sText (.NRMLMULT(j).NRMLBMSH(nBMSH).sNRML & " Length=" & ReverseLong(.NRMLMULT(j).NRMLBMSH(nBMSH).nNRMLLength))
                sText (.NRMLMULT(j).NRMLBMSH(nBMSH).sBMSH & " Length=" & ReverseLong(.NRMLMULT(j).NRMLBMSH(nBMSH).nBMSHLength))
            
                Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nLoD
                Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nObjectTextureGroups
                nLoD = .NRMLMULT(j).NRMLBMSH(nBMSH).nLoD
                sText ("LoD=" & .NRMLMULT(j).NRMLBMSH(nBMSH).nLoD & " | " & _
                       "Texture Groups=" & .NRMLMULT(j).NRMLBMSH(nBMSH).nObjectTextureGroups)
                
                For nGroups = 1 To .NRMLMULT(j).NRMLBMSH(nBMSH).nObjectTextureGroups
                    Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex
                    Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown1
                    Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nNumVNT
                
                    If .NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex > .NRMLMULT(j).NRMLBMSH(nBMSH).nObjectTextureGroups Then
                        .NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex = .NRMLMULT(j).NRMLBMSH(nBMSH).nObjectTextureGroups
                    End If
                
                    'If chkExtractObjects.Value = vbChecked Then
                        If nLoD = frmConfigure.txtLoD.Text Then
                            dText ("g group" & nGroups)
                            
                            dText ("usemtl " & LMIPGroup(.NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex - frmConfigure.txtCount.Text).sGroupName)
                        
                            Print #11, "newmtl " & LMIPGroup(.NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex - frmConfigure.txtCount.Text).sGroupName
                            Print #11, "Ka 0.200000 0.200000 0.200000"
                            Print #11, "Kd 0.800000 0.800000 0.800000"
                            Print #11, "Ks 0.000000 0.000000 0.000000"
                            Print #11, "Ns 0.000000"
                            Print #11, "map_Kd " & LMIPGroup(.NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex - frmConfigure.txtCount.Text).sGroupFileName
                            Print #11, ""
                        End If
                    'End If
                    
                    sText ("Texture=" & .NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex & " | " & _
                           .NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown1 & " | " & _
                           "Vertex Indexes=" & .NRMLMULT(j).NRMLBMSH(nBMSH).nNumVNT)
                    
                    ReDim Preserve .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(.NRMLMULT(j).NRMLBMSH(nBMSH).nNumVNT + maxVerts)
                    If nLoD = frmConfigure.txtLoD.Text Then objHost.DisplayText "Adding " & .NRMLMULT(j).NRMLBMSH(nBMSH).nNumVNT & " vertices"
                    For nVNT = 1 To .NRMLMULT(j).NRMLBMSH(nBMSH).nNumVNT
                        Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT)
                        'If chkExtractObjects.Value = vbChecked Then
                            If nLoD = frmConfigure.txtLoD.Text Then
                                dText ("v " & .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.x & " " & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.y & " " & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.Z)
                                dText ("vn " & .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).VN.x & " " & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).VN.y & " " & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).VN.Z)
                                dText ("vt " & .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).S & " " & _
                                               .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).T)
                                               
                                'objHost.DisplayText objNo & ": Adding vertex " & (nVNT + maxVerts)
                                ship.PEO.object(objNo).AddVertex (nVNT + maxVerts)
                                'objHost.DisplayText " " & .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.X
                                ship.PEO.object(objNo).Vertex(nVNT + maxVerts).x = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.x
                                'objHost.DisplayText " " & .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.Y
                                ship.PEO.object(objNo).Vertex(nVNT + maxVerts).y = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.y
                                'objHost.DisplayText " " & .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.Z
                                ship.PEO.object(objNo).Vertex(nVNT + maxVerts).Z = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(nVNT).V.Z
                                'objHost.DisplayText "Added!"
                            End If
                        'End If
                    Next nVNT
                    If nLoD = frmConfigure.txtLoD.Text Then maxVerts = maxVerts + (nVNT - 1)
                    
                    Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown2
                    Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown3
                    Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown4
                    Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).nNumIndexes
            
                    sText (.NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown2 & " | " & _
                           .NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown3 & " | " & _
                           .NRMLMULT(j).NRMLBMSH(nBMSH).nUnknown4 & " | " & _
                           .NRMLMULT(j).NRMLBMSH(nBMSH).nNumIndexes)
                
                    nMaxIndex = 0
                    If nLoD = frmConfigure.txtLoD.Text Then objHost.DisplayText "Getting " & .NRMLMULT(j).NRMLBMSH(nBMSH).nNumIndexes / 3 & " polygons now..."
            
                    ReDim Preserve .NRMLMULT(j).NRMLBMSH(nBMSH).POLY((.NRMLMULT(j).NRMLBMSH(nBMSH).nNumIndexes / 3) + maxPolys)
                    For nPOLY = 1 To .NRMLMULT(j).NRMLBMSH(nBMSH).nNumIndexes / 3
                        For k = 1 To 3
                            Get #1, , .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(k)
                            
                            If .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(k) > nMaxIndex Then
                                nMaxIndex = .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(k)
                            End If
                            .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(k) = .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(k) + nGroupMax + 1
                        Next k
                            
                        'if chkExtractObjects.Value = vbChecked Then
                            If nLoD = frmConfigure.txtLoD.Text Then
                            
                                'objHost.DisplayText objNo & ": Adding poly " & (nPOLY + maxPolys)
                            
                                ship.PEO.object(objNo).AddFace (nPOLY + maxPolys)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).material = .NRMLMULT(j).NRMLBMSH(nBMSH).nTextureIndex - frmConfigure.txtCount.Text
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).Vertex.v0 = .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(1)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).Vertex.v1 = .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(2)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).Vertex.v2 = .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(3)
                                'objHost.DisplayText "Adding tex coords J: " & j & " nBMSH: " & nBMSH & " nPOLY: " & nPOLY & " Index:" & .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(1) & " - UBPoly: " & UBound(.NRMLMULT(j).NRMLBMSH(nBMSH).POLY) & " - UBVNT: " & UBound(.NRMLMULT(j).NRMLBMSH(nBMSH).VNT)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v0t = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(.NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(1)).S
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v0u = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(.NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(1)).T
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v1t = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(.NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(2)).S
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v1u = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(.NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(2)).T
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v2t = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(.NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(3)).S
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v2u = .NRMLMULT(j).NRMLBMSH(nBMSH).VNT(.NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(3)).T
                                
                                dText ("f " & .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(1) & "/" & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(1) & "/" & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(1) & " " & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(2) & "/" & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(2) & "/" & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(2) & " " & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(3) & "/" & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(3) & "/" & _
                                              .NRMLMULT(j).NRMLBMSH(nBMSH).POLY(nPOLY).Index(3) & " # " & (nPOLY + maxPolys))
                            End If
                        'End If
                    Next nPOLY
                    nGroupMax = nGroupMax + nMaxIndex + 1
                    If nLoD = frmConfigure.txtLoD.Text Then maxPolys = maxPolys + (nPOLY - 1)
                    
                    nFilePos = Seek(1)
                    sText (nFilePos)
                Next nGroups
                nGroupMax = 0
                nMaxIndex = 0
                
                If nLoD = frmConfigure.txtLoD.Text Then
                  ship.PEO.object(objNo).stats.nPolygons = maxPolys
                  ship.PEO.object(objNo).stats.nVertices = maxVerts
                End If
                
            Next nBMSH
    
            'If chkExtractObjects.Value = vbChecked Then
                Close #10
                Close #11
            'End If
        
        Loop
    
        maxVerts = 0
        maxPolys = 0
    
        If .NRMLMULT(j).sMULT = "GOBG" Then
            ' go back before the start of the goblins
            Seek #1, Seek(1) - 20
            nFilePos = Seek(1)
            sText (nFilePos)
            
            ' GOBG
            j = 0
            Do
                Get #1, , sID
                
                If sID <> "NRML" Then Exit Do
    
                j = j + 1
    
                ReDim Preserve .NRMLGOBG(1 To j)
    
                .NRMLGOBG(j).sNRML = sID
                Get #1, , .NRMLGOBG(j).nNRMLLength
                Get #1, , .NRMLGOBG(j).sGOBG
                Get #1, , .NRMLGOBG(j).nGOBGLength
                Get #1, , .NRMLGOBG(j).nGOBGNameLength
                
                .NRMLGOBG(j).sGOBGName = ""
        
                For i = 1 To .NRMLGOBG(j).nGOBGNameLength
                    Get #1, , chunk
                    If Val(chunk) > 0 Then
                        .NRMLGOBG(j).sGOBGName = .NRMLGOBG(j).sGOBGName & Chr$(chunk)
                    End If
                Next i
        
                Get #1, , .NRMLGOBG(j).nNameLength
                
                .NRMLGOBG(j).sName = ""
                
                For i = 1 To .NRMLGOBG(j).nNameLength
                    Get #1, , chunk
                    If Val(chunk) > 0 Then
                        .NRMLGOBG(j).sName = .NRMLGOBG(j).sName & Chr$(chunk)
                    End If
                Next i
        
                  
                objNo = objNo + 1
                ship.PEO.Add objNo
                ship.numObjects = ship.numObjects + 1
                ship.PEO.object(objNo).objName = .NRMLGOBG(j).sName & "_gobg"
                objHost.DisplayText "Adding object " & objNo & ": " & .NRMLMULT(j).sName & "_gobg"
                ' Add a new object
                maxVerts = 0
                maxPolys = 0
        
        
                'If chkExtractObjects.Value = vbChecked Then
                    Open Left(sFile, Len(sFile) - 4) & "_" & .NRMLGOBG(j).sName & "_gobg" & _
                         ".obj" For Output As #12
                    
                    Print #12, "#"
                    Print #12, "# Wavefront OBJ File"
                    Print #12, "# Created by Spooky's HOD Viewer Tool v" & App.Major & "." & App.Minor & "." & App.Revision
                    Print #12, "# http://www.b5mods.com"
                    Print #12, "#"
                    Print #12, ""
                    Print #12, "mtllib " & Mid(sFile, InStrRev(sFile, "\") + 1, _
                            InStrRev(sFile, ".") - 1 - InStrRev(sFile, "\")) & "_" & _
                            .NRMLGOBG(j).sName & "_lod" & frmConfigure.txtLoD.Text & ".mtl"
                    Print #12, ""
                
                'End If
                
                sText (.NRMLGOBG(j).sNRML & " Length=" & ReverseLong(.NRMLGOBG(j).nNRMLLength))
                sText (.NRMLGOBG(j).sGOBG & " Length=" & ReverseLong(.NRMLGOBG(j).nGOBGLength))
                sText ("GOBG Name Length=" & .NRMLGOBG(j).nGOBGNameLength)
                sText (.NRMLGOBG(j).sGOBGName)
                sText ("Name Length=" & .NRMLGOBG(j).nNameLength)
                sText (.NRMLGOBG(j).sName)
                
                Get #1, , .NRMLGOBG(j).NRMLBMSH.sNRML
                Get #1, , .NRMLGOBG(j).NRMLBMSH.nNRMLLength
                Get #1, , .NRMLGOBG(j).NRMLBMSH.sBMSH
                Get #1, , .NRMLGOBG(j).NRMLBMSH.nBMSHLength
        
                sText (.NRMLGOBG(j).NRMLBMSH.sNRML & " Length=" & ReverseLong(.NRMLGOBG(j).NRMLBMSH.nNRMLLength))
                sText (.NRMLGOBG(j).NRMLBMSH.sBMSH & " Length=" & ReverseLong(.NRMLGOBG(j).NRMLBMSH.nBMSHLength))
            
                Get #1, , .NRMLGOBG(j).NRMLBMSH.nLoD
                Get #1, , .NRMLGOBG(j).NRMLBMSH.nObjectTextureGroups
                nLoD = .NRMLGOBG(j).NRMLBMSH.nLoD
                sText ("LoD=" & .NRMLGOBG(j).NRMLBMSH.nLoD & " | " & _
                       "Texture Groups=" & .NRMLGOBG(j).NRMLBMSH.nObjectTextureGroups)
                
                For nGroups = 1 To .NRMLGOBG(j).NRMLBMSH.nObjectTextureGroups
                    Get #1, , .NRMLGOBG(j).NRMLBMSH.nTextureIndex
                    Get #1, , .NRMLGOBG(j).NRMLBMSH.nUnknown1
                    Get #1, , .NRMLGOBG(j).NRMLBMSH.nNumVNT
                
                    If .NRMLGOBG(j).NRMLBMSH.nTextureIndex > UBound(LMIPGroup) Then
                        .NRMLGOBG(j).NRMLBMSH.nTextureIndex = .NRMLGOBG(j).NRMLBMSH.nTextureIndex - UBound(LMIPGroup)
                    End If
                
                    'If chkExtractObjects.Value = vbChecked Then
                        If nLoD = frmConfigure.txtLoD.Text Then
                            Print #12, "g group" & nGroups
                            Print #12, "usemtl " & LMIPGroup(.NRMLGOBG(j).NRMLBMSH.nTextureIndex - frmConfigure.txtCount.Text).sGroupName
                        End If
                    'End If
                
                    sText ("Texture=" & .NRMLGOBG(j).NRMLBMSH.nTextureIndex & " | " & _
                           .NRMLGOBG(j).NRMLBMSH.nUnknown1 & " | " & _
                           "Vertex Indexes=" & .NRMLGOBG(j).NRMLBMSH.nNumVNT)
                    
                    If nLoD = frmConfigure.txtLoD.Text Then objHost.DisplayText "Adding " & .NRMLGOBG(j).NRMLBMSH.nNumVNT & " vertices"
                    ReDim Preserve .NRMLGOBG(j).NRMLBMSH.VNT(.NRMLGOBG(j).NRMLBMSH.nNumVNT + maxVerts)
                    For nVNT = 1 To .NRMLGOBG(j).NRMLBMSH.nNumVNT
                        Get #1, , .NRMLGOBG(j).NRMLBMSH.VNT(nVNT)
                        'If chkExtractObjects.Value = vbChecked Then
                            If nLoD = frmConfigure.txtLoD.Text Then
                                Print #12, "v " & .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).V.x & " " & _
                                                  .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).V.y & " " & _
                                                  .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).V.Z
                                Print #12, "vn " & .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).VN.x & " " & _
                                                   .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).VN.y & " " & _
                                                   .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).VN.Z
                                Print #12, "vt " & .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).S & " " & _
                                                   .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).T
                                ship.PEO.object(objNo).AddVertex (nVNT + maxVerts)
                                ship.PEO.object(objNo).Vertex(nVNT + maxVerts).x = .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).V.x
                                ship.PEO.object(objNo).Vertex(nVNT + maxVerts).y = .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).V.y
                                ship.PEO.object(objNo).Vertex(nVNT + maxVerts).Z = .NRMLGOBG(j).NRMLBMSH.VNT(nVNT).V.Z
                            End If
                        'End If
                    Next nVNT
                    If nLoD = frmConfigure.txtLoD.Text Then maxVerts = maxVerts + (nVNT - 1)
                    
                    Get #1, , .NRMLGOBG(j).NRMLBMSH.nUnknown2
                    Get #1, , .NRMLGOBG(j).NRMLBMSH.nUnknown3
                    Get #1, , .NRMLGOBG(j).NRMLBMSH.nUnknown4
                    Get #1, , .NRMLGOBG(j).NRMLBMSH.nNumIndexes
            
                    sText (.NRMLGOBG(j).NRMLBMSH.nUnknown2 & " | " & _
                           .NRMLGOBG(j).NRMLBMSH.nUnknown3 & " | " & _
                           .NRMLGOBG(j).NRMLBMSH.nUnknown4 & " | " & _
                           .NRMLGOBG(j).NRMLBMSH.nNumIndexes)
                
                    nMaxIndex = 0
            
                    If nLoD = frmConfigure.txtLoD.Text Then objHost.DisplayText "Getting " & .NRMLGOBG(j).NRMLBMSH.nNumIndexes / 3 & " polygons now..."
                    ReDim Preserve .NRMLGOBG(j).NRMLBMSH.POLY((.NRMLGOBG(j).NRMLBMSH.nNumIndexes / 3) + maxPolys)
                    For nPOLY = 1 To .NRMLGOBG(j).NRMLBMSH.nNumIndexes / 3
                        For k = 1 To 3
                            Get #1, , .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(k)
                            
                            If .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(k) > nMaxIndex Then
                                nMaxIndex = .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(k)
                            End If
                            .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(k) = .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(k) + nGroupMax + 1
                        Next k
                            
                        'If chkExtractObjects.Value = vbChecked Then
                            If nLoD = frmConfigure.txtLoD.Text Then
                            
                                'objHost.DisplayText " Adding poly " & (nPOLY + maxPolys)
                                ship.PEO.object(objNo).AddFace (nPOLY + maxPolys)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).material = .NRMLGOBG(j).NRMLBMSH.nTextureIndex - frmConfigure.txtCount.Text
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).Vertex.v0 = .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(1)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).Vertex.v1 = .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(2)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).Vertex.v2 = .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(3)
                                'objHost.DisplayText "Adding tex coords J: " & j & " nBMSH: " & nBMSH & " nPOLY: " & nPOLY & " Index:" & .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(1) & " - UBPoly: " & UBound(.NRMLGOBG(j).NRMLBMSH.POLY) & " - UBVNT: " & UBound(.NRMLGOBG(j).NRMLBMSH.VNT)
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v0t = .NRMLGOBG(j).NRMLBMSH.VNT(.NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(1)).S
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v0u = .NRMLGOBG(j).NRMLBMSH.VNT(.NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(1)).T
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v1t = .NRMLGOBG(j).NRMLBMSH.VNT(.NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(2)).S
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v1u = .NRMLGOBG(j).NRMLBMSH.VNT(.NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(2)).T
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v2t = .NRMLGOBG(j).NRMLBMSH.VNT(.NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(3)).S
                                ship.PEO.object(objNo).Faces(nPOLY + maxPolys).TexList.v2u = .NRMLGOBG(j).NRMLBMSH.VNT(.NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(3)).T
                            
                                 Print #12, "f " & .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(1) & "/" & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(1) & "/" & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(1) & " " & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(2) & "/" & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(2) & "/" & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(2) & " " & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(3) & "/" & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(3) & "/" & _
                                              .NRMLGOBG(j).NRMLBMSH.POLY(nPOLY).Index(3)
                            End If
                        'End If
                    Next nPOLY
                    nGroupMax = nGroupMax + nMaxIndex + 1
                    If nLoD = frmConfigure.txtLoD.Text Then maxPolys = maxPolys + (nPOLY - 1)
                
                Next nGroups
                nGroupMax = 0
                nMaxIndex = 0
            
                If nLoD = frmConfigure.txtLoD.Text Then
                  ship.PEO.object(objNo).stats.nPolygons = maxPolys
                  ship.PEO.object(objNo).stats.nVertices = maxVerts
                End If
                'If chkExtractObjects.Value = vbChecked Then
                    Close #12
                'End If
            Loop
        End If
    End With
    
    ' FORM DTRM
    With HODFile.DTRM
        ' HIER
        Seek #1, Seek(1) - 4
        nFilePos = Seek(1)
        sText (nFilePos)
        
        Get #1, , .sFORM
        Get #1, , .nDTRMLength
        Get #1, , .sDTRM
        Get #1, , .sHIER
        Get #1, , .nHIERLength
        Get #1, , .nNumHIER
        
        sText (.sFORM & " Length=" & ReverseLong(.nDTRMLength))
        sText (.sDTRM)
        sText (.sHIER & " Length=" & ReverseLong(.nHIERLength))
        sText ("Num HIER=" & .nNumHIER)
        
        sFileShortName = StrConv(Mid(sFile, InStrRev(sFile, "\") + 1, InStrRev(sFile, ".") - (InStrRev(sFile, "\") + 1)), vbUpperCase)
        
        ReDim .HIER(1 To .nNumHIER)
        For i = 1 To .nNumHIER
            Get #1, , .HIER(i).nNameLength
    
            .HIER(i).sName = ""
    
            For j = 1 To .HIER(i).nNameLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .HIER(i).sName = .HIER(i).sName & Chr$(chunk)
                End If
            Next j
            
            sText ("Name Length=" & .HIER(i).nNameLength)
            sText ("Name=" & .HIER(i).sName)
            
            Get #1, , .HIER(i).nParentLength
            sText ("Parent Length=" & .HIER(i).nParentLength)
            
            If .HIER(i).nParentLength > 0 Then
                .HIER(i).sParent = ""
        
                For j = 1 To .HIER(i).nParentLength
                    Get #1, , chunk
                    If Val(chunk) > 0 Then
                        .HIER(i).sParent = .HIER(i).sParent & Chr$(chunk)
                    End If
                Next j
            
                sText ("Parent=" & .HIER(i).sParent)
            End If
        
            ' Need to convert this to MDS type sometime
            ' add the entries to the treeview
            'If i = 1 Then
            '    tvwHOD.Nodes.Add , tvwFirst, "Root", sFileShortName
            'Else
            '    tvwHOD.Nodes.Add .HIER(i).sParent, tvwChild, .HIER(i).sName, .HIER(i).sName
            'End If
            
            Get #1, , .HIER(i).oOffset
            Get #1, , .HIER(i).oRotation
            Get #1, , .HIER(i).nLocalMatrix
            
            sText ("Offset= " & .HIER(i).oOffset.x & " | " & .HIER(i).oOffset.y & " | " & .HIER(i).oOffset.Z)
            sText ("Rotation=  " & .HIER(i).oRotation.x & " | " & .HIER(i).oRotation.y & " | " & .HIER(i).oRotation.Z)
            sText ("Scale= " & .HIER(i).nLocalMatrix(1) & " | " & _
                               .HIER(i).nLocalMatrix(2) & " | " & _
                               .HIER(i).nLocalMatrix(3))
            sText ("Shear?= " & .HIER(i).nLocalMatrix(4) & " | " & _
                                .HIER(i).nLocalMatrix(5) & " | " & _
                                .HIER(i).nLocalMatrix(6))
        
            Get #1, , .HIER(i).dData
            sText ("Byte Data= " & .HIER(i).dData(1) & " | " & .HIER(i).dData(2) & " | " & .HIER(i).dData(3))
        Next i
    
        nFilePos = Seek(1)
        sText (nFilePos)
    
        ' Expand the treeview entries
        'For i = 1 To HODFile.DTRM.nNumHIER
        '    tvwHOD.Nodes.Item(i).Expanded = True
        'Next i
        
        ' ETSH (where present)
        nETSH = 0
        Do
            Get #1, , sID
            
            If sID <> "ETSH" Then Exit Do
        
            nETSH = nETSH + 1
            ReDim Preserve .ETSH(1 To nETSH)
        
            .ETSH(nETSH).sETSH = sID
            Get #1, , .ETSH(nETSH).nETSHLength
            Get #1, , .ETSH(nETSH).nNameLength
            
            sText (.ETSH(nETSH).sETSH)
            sText ("ETSH Length=" & ReverseLong(.ETSH(nETSH).nETSHLength))
            sText ("Name Length=" & .ETSH(nETSH).nNameLength)
            
            .ETSH(nETSH).sName = ""
    
            For i = 1 To .ETSH(nETSH).nNameLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .ETSH(nETSH).sName = .ETSH(nETSH).sName & Chr$(chunk)
                End If
            Next i
            sText ("Name=" & .ETSH(nETSH).sName)
            
            Get #1, , .ETSH(nETSH).nParentLength
            sText ("Parent Length=" & .ETSH(nETSH).nParentLength)
            
            .ETSH(nETSH).sParent = ""
    
            For i = 1 To .ETSH(nETSH).nParentLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .ETSH(nETSH).sParent = .ETSH(nETSH).sParent & Chr$(chunk)
                End If
            Next i
            sText ("Parent=" & .ETSH(nETSH).sParent)
            
            Get #1, , .ETSH(nETSH).nNumCoords
            ReDim .ETSH(nETSH).Coords(1 To .ETSH(nETSH).nNumCoords)
            Get #1, , .ETSH(nETSH).Coords
        
            sText ("Num Coords=" & .ETSH(nETSH).nNumCoords)
            
            For i = 1 To .ETSH(nETSH).nNumCoords
                sText ("#" & i & "= " & .ETSH(nETSH).Coords(i).x & " | " & .ETSH(nETSH).Coords(i).y & " | " & .ETSH(nETSH).Coords(i).Z)
            Next i
            
            ' TO-DO
            'tvwHOD.Nodes.Add .ETSH(nETSH).sParent, tvwChild, .ETSH(nETSH).sName, .ETSH(nETSH).sName
            'tvwHOD.Nodes.Item(HODFile.DTRM.nNumHIER + nETSH).Expanded = True
        Loop
        
        Seek #1, Seek(1) - 4
        nFilePos = Seek(1)
        sText (nFilePos)
        
        ' BURN (where present)
        nBURN = 0
        Do
            Get #1, , sID
            
            If sID <> "BURN" Then Exit Do
        
            nBURN = nBURN + 1
            ReDim Preserve .BURN(1 To nBURN)
        
            .BURN(nBURN).sBURN = sID
            Get #1, , .BURN(nBURN).nBURNLength
            Get #1, , .BURN(nBURN).nNameLength
            
            sText (.BURN(nBURN).sBURN)
            sText ("BURN Length=" & ReverseLong(.BURN(nBURN).nBURNLength))
            sText ("Name Length=" & .BURN(nBURN).nNameLength)
            
            .BURN(nBURN).sName = ""
    
            For i = 1 To .BURN(nBURN).nNameLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .BURN(nBURN).sName = .BURN(nBURN).sName & Chr$(chunk)
                End If
            Next i
            sText ("Name=" & .BURN(nBURN).sName)
            
            Get #1, , .BURN(nBURN).nParentLength
            sText ("Parent Length=" & .BURN(nBURN).nParentLength)
            
            .BURN(nBURN).sParent = ""
    
            For i = 1 To .BURN(nBURN).nParentLength
                Get #1, , chunk
                If Val(chunk) > 0 Then
                    .BURN(nBURN).sParent = .BURN(nBURN).sParent & Chr$(chunk)
                End If
            Next i
            sText ("Parent=" & .BURN(nBURN).sParent)
            
            Get #1, , .BURN(nBURN).nNumCoords
            ReDim .BURN(nBURN).Coords(1 To .BURN(nBURN).nNumCoords)
            Get #1, , .BURN(nBURN).Coords
            Get #1, , .BURN(nBURN).nUnknown1
        
            sText ("Num Coords=" & .BURN(nBURN).nNumCoords)
            sText ("Unknown1=" & .BURN(nBURN).nUnknown1)
            
            For i = 1 To .BURN(nBURN).nNumCoords
                sText ("#" & i & "= " & .BURN(nBURN).Coords(i).x & " | " & .BURN(nBURN).Coords(i).y & " | " & .BURN(nBURN).Coords(i).Z)
            Next i
            
            ' TO-DO
            'tvwHOD.Nodes.Add .BURN(nBURN).sParent, tvwChild, .BURN(nBURN).sName, .BURN(nBURN).sName
            'tvwHOD.Nodes.Item(HODFile.DTRM.nNumHIER + nETSH + nBURN).Expanded = True
        Loop
        
        nFilePos = Seek(1)
        sText (nFilePos & " - " & sID)
        
        'tvwHOD.Refresh
        
    End With
    
    sText ("EOF")
    
    Close #1
    
    Set ImportHOD = ship
    
End Function

Public Sub dText(sText As String)
    ' txtDebug.Text = txtDebug.Text & sText & vbCrLf
    'If chkExtractObjects.Value = vbChecked Then
        Print #10, sText
    'End If
End Sub

Public Sub sText(sText As String)
    frmConfigure.Text1.Text = frmConfigure.Text1.Text & sText & vbCrLf
    Open App.Path & "\hodimport.log" For Append As #29
    Print #29, sText
    Close #29
End Sub

