Attribute VB_Name = "modQuickLoadLif"
Option Explicit

Dim myCore As clsCore
Dim myObjHost As hwseCore.IHostInterface

'Type lifCorrupt
'  header As Boolean
'  threedex As Boolean
'End Type
'
Type hwColourType
    r As Byte
    g As Byte
    b As Byte
    a As Byte
End Type
'

Public Type lifCorrupt
  header As Boolean
  threedex As Boolean
End Type

Public Type LiFType
    identifier As String * 8
    version As Long
    flags As Long
    lType(3) As Boolean
    corrupt As lifCorrupt
    Width As Long
    Height As Long
    PalletteCRC As Long
    ImageCRC As Long
    data As Long
    Palette As Long
    Team0 As Long
    Team1 As Long
End Type

' API functions for drawing pixels
'Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
'Private Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal Color As Long) As Long
Private Declare Function SetPixelV Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal Color As Long) As Byte

Private bmpFile As String

'Public Body As D3DCOLORVALUE

Public Function getLif(File As String, objHost As hwseCore.IHostInterface)

  ' Move this to the Plugin Init code!
  Set myCore = New clsCore
  Set myObjHost = objHost
  
  myCore.errModule = "modLif"
  myCore.errFunction = "importLif"
  myCore.errParms = File
    
  Dim NumPoints As Long
  Dim x As Integer
  Dim ImagePalette(1 To 256) As hwColourType
  Dim TeamEffect0(1 To 256) As Byte
  Dim TeamEffect1(1 To 256) As Byte

  Dim lifHeader As LiFType
  Dim Pixel As hwColourType
  Dim lifData() As hwColourType
  Dim toolTip As String
  
  If Dir(File) = "" Then
    objHost.DisplayText "File doesn't exist! Creating blank texture"
    frmConfigure.Picture1.ScaleMode = 3 '3 = pixel 1 = twips 0 = user
  
    frmConfigure.Picture1.Height = (1 * Screen.TwipsPerPixelY)
    frmConfigure.Picture1.Width = (1 * Screen.TwipsPerPixelX)
    frmConfigure.Picture1.ScaleHeight = 1
    frmConfigure.Picture1.ScaleWidth = 1
    frmConfigure.Picture1.Cls
    bmpFile = Mid$(File, 1, InStrRev(File, ".")) & "bmp"
    SavePicture frmConfigure.Picture1.Image, bmpFile
    'Set loadLif = d3dx.CreateTextureFromFile(d3ddevice, bmpFile)
    'Set loadLif = d3ddevice.loadTexture(bmpFile)
    Exit Function
  End If
    
  For x = 0 To 3
    lifHeader.lType(x) = False
  Next x
      
  Dim lifFile As Integer
  lifFile = FreeFile
    
  Open File For Binary As #lifFile
    
  Get #lifFile, , lifHeader.identifier
  Get #lifFile, , lifHeader.version
  Get #lifFile, , lifHeader.flags
  Get #lifFile, , lifHeader.Width
  Get #lifFile, , lifHeader.Height
  Get #lifFile, , lifHeader.PalletteCRC
  Get #lifFile, , lifHeader.ImageCRC
  Get #lifFile, , lifHeader.data
  Get #lifFile, , lifHeader.Palette
  Get #lifFile, , lifHeader.Team0
  Get #lifFile, , lifHeader.Team1
  'dText ("Version: " & lifHeader.version)
  'dText ("Flags: " & lifHeader.flags)
  
  objHost.DisplayText "Lif Size is " & lifHeader.Height & "x" & lifHeader.Width
   
  'toolTip = File
  'toolTip = toolTip & "Size: " & lifHeader.Width & "x" & lifHeader.Height & vbCrLf
    
  Dim flagBits As String, tmpLong As Long, j As Integer
  ' Convert material.Flags to Long for the flagBits
  tmpLong = lifHeader.flags
  flagBits = DecToBin(tmpLong)
  For j = 17 To 1 Step -1
  If Mid$(flagBits, j, 1) = "1" Then
    Select Case j
    Case 16:
      ' 2 - Palette
      lifHeader.lType(0) = True
    Case 14:
      ' 8 - Alpha
      lifHeader.lType(1) = True
    Case 13:
      ' 16 - Team0
      lifHeader.lType(2) = True
    Case 12:
      ' 32 - Team1
      lifHeader.lType(3) = True
    End Select
  End If
  Next j
    
  With lifHeader.corrupt
    .header = False
    .threedex = False
  End With
  
  If lifHeader.flags = 0 Then
    lifHeader.corrupt.header = True
  End If
  If LOF(lifFile) <> (((lifHeader.Width * lifHeader.Height) + 48) + 1024 + 512) Then
    If lifHeader.lType(1) = False Then
      If LOF(lifFile) <> (((lifHeader.Width * lifHeader.Height) + 48) + 1024) Then
        lifHeader.corrupt.threedex = True
      End If
    End If
  End If
    
  NumPoints = lifHeader.Width * lifHeader.Height
  If LOF(lifFile) = (NumPoints * 4) + 48 Then
    If lifHeader.Palette = 0 Then
      lifHeader.lType(1) = True
    End If
  End If
    
    If NumPoints = 0 Then
      Close #lifFile
      Exit Function
    End If
    ReDim lifData(1 To NumPoints)
    Dim i As Long
    Dim FilePos As Long
  
    FilePos = lifHeader.data
    Seek #lifFile, FilePos + 1
    If lifHeader.lType(1) = True Then
      ' It's an Alpha LIF
      For i = 1 To NumPoints
        Get #lifFile, , lifData(i)
      Next i
    Else
      If lifHeader.corrupt.threedex = False Then
        For i = 1 To NumPoints
          Get #lifFile, , lifData(i).r
        Next i
      Else
        For i = 1 To NumPoints
          Get #lifFile, , lifData(i).r
          Get #lifFile, , lifData(i).g
          Get #lifFile, , lifData(i).b
        Next i
      End If
    End If
 
    FilePos = lifHeader.Palette
    If FilePos > 0 Then
      Seek #lifFile, FilePos + 1
      'dText ("Palette pos: " & Seek(6))
      For i = 1 To 256
        Get #lifFile, , ImagePalette(i).r ' normal / base palette Red value for this index
        Get #lifFile, , ImagePalette(i).g ' normal / base palette Green value for this index
        Get #lifFile, , ImagePalette(i).b ' normal / base palette Blue value for this index
        Get #lifFile, , ImagePalette(i).a ' normal / base palette Alpha/Reserved value for this index
      Next i
    End If

    FilePos = lifHeader.Team0
    If FilePos > 0 Then
      Seek #lifFile, FilePos + 1
      'dText ("Team 0 pos: " & Seek(6))
      For i = 1 To 256
        Get #lifFile, , TeamEffect0(i) ' the team effect body multipliers ..
      Next i
    End If
    
    FilePos = lifHeader.Team1
    If FilePos > 0 Then
      Seek #lifFile, FilePos + 1
      'dText ("Team 1 pos: " & Seek(6))
      For i = 1 To 256
        Get #lifFile, , TeamEffect1(i)
      Next i
    End If
  
  Close #lifFile

  'myPicBox.ToolTipText = toolTip
  ' -------------------------------------------------------

  Dim DataIndex As Long
  Dim Index As Long
  Dim XPos As Long, YPos As Long
   
  'Screen.MousePointer = vbHourglass
   
  frmConfigure.Picture1.ScaleMode = 3 '3 = pixel 1 = twips 0 = user
  
  frmConfigure.Picture1.Height = (lifHeader.Height * Screen.TwipsPerPixelY)
  frmConfigure.Picture1.Width = (lifHeader.Width * Screen.TwipsPerPixelX)
  'If lifHeader.Height <= 4 Or lifHeader.Width <= 4 Then
    'frmConfigure.Picture1.ScaleHeight = myPicBox.Height
    'frmConfigure.Picture1.ScaleWidth = myPicBox.Width
  'Else
    frmConfigure.Picture1.ScaleHeight = lifHeader.Height
    frmConfigure.Picture1.ScaleWidth = lifHeader.Width
  'End If
  
  frmConfigure.Picture1.Cls
  
  Index = 1
  For YPos = 0 To lifHeader.Height - 1
    ' let windows do stuff
    'DoEvents
    For XPos = 0 To lifHeader.Width - 1
      If lifHeader.lType(1) = True Then
        ' It's an alpha lif
        Pixel = lifData(Index)
      Else
        If lifHeader.corrupt.threedex = False Then
          DataIndex = lifData(Index).r + 1 ' the actual raw Lif data
          Pixel = ImagePalette(DataIndex)
        Else
          ' As it's corrupt, set the index into TeamEffects
          ' to 1
          DataIndex = 1
          Pixel = lifData(Index)
        End If
      End If
           
      SetPixelV frmConfigure.Picture1.hDC, XPos, YPos, RGB(Pixel.r, Pixel.g, Pixel.b)
      'myLif.SetPixel XPos, YPos, RGB(Pixel.r, Pixel.g, Pixel.b)
     
      'myPicBox.PSet (XPos, YPos), RGB(Pixel.r, Pixel.g, Pixel.b)
            
      Index = Index + 1
    Next XPos
  Next YPos
  '  Debug.Print "Saving " & saveFilename
  
  bmpFile = Mid$(File, 1, InStrRev(File, ".")) & "bmp"
  SavePicture frmConfigure.Picture1.Image, bmpFile
  
  'Screen.MousePointer = vbDefault
  
  'Set loadLif = d3dx.CreateTextureFromFile(d3ddevice, bmpFile)
  'loadLif = True
  Exit Function

errHandler:
  'Debug.Print "LoadFile - " & Err.Number & " (" & Err.Description & ")"

End Function

Public Function loadLif(File As String, objHost As hwseCore.IHostInterface, d3ddevice As Direct3DRM3) As Direct3DRMTexture3
  'On Error GoTo ErrHandler
    
  getLif File, objHost
  Set loadLif = d3ddevice.loadTexture(bmpFile)
  Kill bmpFile
    
End Function

Public Function loadLif2(File As String, objHost As hwseCore.IHostInterface, d3ddevice As Direct3DDevice8) As Direct3DTexture8
  'On Error GoTo ErrHandler
    
  getLif File, objHost
  
  Dim d3dx As D3DX8
  Set d3dx = New D3DX8
  
  Set loadLif2 = d3dx.CreateTextureFromFile(d3ddevice, bmpFile)
  Kill bmpFile
    
End Function

Public Function DecToBin(inputNumber As Long) As String

    Dim Bits As Integer
    Bits = 16 ' a decimal value from 0 to 65535
    
    Do While Bits >= 0
        If (inputNumber >= 2 ^ Bits) Then
            inputNumber = inputNumber - 2 ^ Bits
            DecToBin = DecToBin & "1"
        Else
            DecToBin = DecToBin & "0"
        End If
        Bits = Bits - 1
    Loop

End Function

