Attribute VB_Name = "modObj"
Private Type objUV
  u As Single
  v As Single
End Type
Public textCoords() As objUV

Public Sub importObj(fileName As String)
  errModule = "modObj"
  errFunction = "importObj"
  errParms = fileName
  On Error GoTo standardError

' This sub imports an OBJ file into the hwShip class
' (see peoClassDefs)
Dim objFileNo As Integer
Dim currObj As Integer
Dim currVert As Integer
Dim currNorm As Integer
Dim currTxt As Integer
Dim currFace As Integer
Dim tmpString As String
Dim startObjNo As Integer
Dim noOfObjects As Integer

startObjNo = ship.numObjects
currObj = startObjNo - 1

' Clear text box
newPEO.Text1.text = ""

objFileNo = FreeFile
Open fileName For Input As #objFileNo
pText "Loading " & fileName & " please wait....."
Do
  Line Input #objFileNo, tmpString
  If Len(tmpString) > 2 Then
    Select Case Mid$(tmpString, 1, 2)
    Case "g ":
      noOfObjects = noOfObjects + 1
    End Select
  End If
  DoEvents
Loop Until EOF(objFileNo)
Close #objFileNo

pText "  Number of objects in file: " & noOfObjects
If noOfObjects = 1 Then
  ' Create a blank object first
  currObj = 0
  ReDim Preserve ship.PEO.object(currObj)
End If

objFileNo = FreeFile
Open fileName For Input As #objFileNo
Do
  Line Input #objFileNo, tmpString
  If Len(tmpString) > 2 Then
  Select Case Mid$(tmpString, 1, 2)
    Case "mt":
      ' Material library
    Case "g ":
      ' Group
      If noOfObjects > 1 Then
        currObj = currObj + 1
        ReDim Preserve ship.PEO.object(currObj)
      End If
      If currObj = 0 Then
        ship.PEO.object(currObj).Mother.value = 0
      Else
        ship.PEO.object(currObj).Mother.value = 1
      End If
      ship.PEO.object(currObj).madObjNo = -1
      ship.PEO.object(currObj).objName = Mid$(tmpString, 3)
      ship.PEO.object(currObj).matrix.rc11 = 1
      ship.PEO.object(currObj).matrix.rc22 = 1
      ship.PEO.object(currObj).matrix.rc33 = 1
      ship.PEO.object(currObj).matrix.rc44 = 1
      ship.numObjects = ship.numObjects + 1
      currFace = 0
    Case "v ":
      ' Vertex definition
      ReDim Preserve ship.PEO.object(currObj).vertexList(currVert)
      ship.PEO.object(currObj).vertexList(currVert) = getVert(tmpString)
      getStats currObj, currVert
      currVert = currVert + 1
    Case "vt":
      ' texture coords
      ReDim Preserve textCoords(currTxt)
      textCoords(currText) = getUV(tmpString)
      currTxt = currTxt + 1
    Case "vn":
      ' normals
      ReDim Preserve ship.PEO.object(currObj).vertNormalList(currNorm)
      ship.PEO.object(currObj).vertNormalList(currNorm) = getNorm(tmpString)
      ship.PEO.object(currObj).stats.nVertexNormals = currNorm + 1
      'ReDim Preserve tmpVertNormals(currNorm)
      'tmpVertNormals(currNorm) = getNorm(tmpString)
      currNorm = currNorm + 1
  End Select
  End If
  DoEvents
Loop Until EOF(objFileNo)
Close #objFileNo

currObj = startObjNo - 1

objFileNo = FreeFile
Open fileName For Input As #objFileNo
Do
  Line Input #objFileNo, tmpString
  If Len(tmpString) > 2 Then
  Select Case Mid$(tmpString, 1, 2)
    Case "g ":
      ' Group
      currObj = currObj + 1
      pText "Loading object: " & ship.PEO.object(currObj).objName
      setMaxAxis currObj
      currFace = 0
    Case "f ":
      ' face definition in the format  f v/vt/vn v/vt/vn v/vt/vn
      ReDim Preserve ship.PEO.object(currObj).faces(currFace)
      ReDim Preserve ship.PEO.object(currObj).faceNormalList(currFace)
      With ship.PEO.object(currObj)
        ' Get face data
        .faces(currFace) = getFace(tmpString)
        ' Get normal data
        .faces(currFace).normal = currFace
        .stats.nFaceNormals = currFace
        .faceNormalList(currFace) = calcFaceNormal(ship.PEO.object(currObj), currFace)
      End With
      currFace = currFace + 1
    Case Else:
  End Select
  End If
  DoEvents
Loop Until EOF(objFileNo)
Close #objFileNo

If startObjNo = 0 Then
  ' Show axes
  showAxes
End If

create3dobjects startObjNo

  Exit Sub
standardError:
  frmError.Show vbModal
End Sub
Public Function calcFaceNormal(tmpObject As peoObject, currFace As Integer) As D3DVECTOR

  ' Original code by Spooky.
  ' Modified to hwShip format by Delphy.
  ' Checked & spiffed by Pesmontis.
  
  Dim i As Long
  Dim xv1, xv2, xv3, yv1, yv2, yv3, zv1, zv2, zv3 As Double
  Dim v1x, v1y, v1z, v2x, v2y, v2z As Double
  Dim mag As Double

  With tmpObject
    ' extract the actual vertex values from the triplet pointers
    xv1 = .vertexList(.faces(currFace).Vertex(0)).x
    xv2 = .vertexList(.faces(currFace).Vertex(1)).x
    xv3 = .vertexList(.faces(currFace).Vertex(2)).x
    yv1 = .vertexList(.faces(currFace).Vertex(0)).y
    yv2 = .vertexList(.faces(currFace).Vertex(1)).y
    yv3 = .vertexList(.faces(currFace).Vertex(2)).y
    zv1 = .vertexList(.faces(currFace).Vertex(0)).z
    zv2 = .vertexList(.faces(currFace).Vertex(1)).z
    zv3 = .vertexList(.faces(currFace).Vertex(2)).z
  End With
  ' from these vertices, the vectors are:
  v1x = xv1 - xv2
  v1y = yv1 - yv2
  v1z = zv1 - zv2
  v2x = xv2 - xv3
  v2y = yv2 - yv3
  v2z = zv2 - zv3

  ' Calculate the vector cross product to get the face normal.
  ' Pesmontis: note that it may either point OUTWARD or INWARD!
  ' In a drawing program, the face normal points TOWARDS you if the face 'faces you'.
  ' If you want a face to 'face you', you have to draw it's vertices ANTICLOCKWISE.
  ' The vector cross product follows the righthand rule, so if you turn your right hand
  ' anticlockwise, your thumb (the face normal) points at you,
  ' but ONLY if the vertices above designate the correct plane in the anticlockwise manner,
  ' e.g. vertex0 is below, vertex1 is to the upper right, and vertex2 is to the upper left corner of the face.
  ' Which seems to be correct here.
  calcFaceNormal.x = v1y * v2z - v1z * v2y
  calcFaceNormal.y = v1z * v2x - v1x * v2z
  calcFaceNormal.z = v1x * v2y - v1y * v2x
  
  mag = Sqr(calcFaceNormal.x ^ 2 + calcFaceNormal.y ^ 2 + calcFaceNormal.z ^ 2)
  
  If calcFaceNormal.x <> 0 Then
    calcFaceNormal.x = Round(calcFaceNormal.x / mag, 6)
  End If
  If calcFaceNormal.y <> 0 Then
    calcFaceNormal.y = Round(calcFaceNormal.y / mag, 6)
  End If
  If calcFaceNormal.z <> 0 Then
    calcFaceNormal.z = Round(calcFaceNormal.z / mag, 6)
  End If

End Function

Private Sub pText(textPrint As String)
  newPEO.Text1 = newPEO.Text1 & textPrint & vbCrLf
  Exit Sub
standardError:
  frmError.Show vbModal
End Sub
Private Function getVert(inputLine As String) As peoVertex
  errModule = "modObj"
  errFunction = "getVert"
  errParms = inputLine
  On Error GoTo standardError
  
  Dim tmpString As String
  ' Strip off the first 2 chars (v )
  tmpString = Mid$(inputLine, 3)
  getVert.x = Val(Mid$(tmpString, 1, InStr(tmpString, " ") - 1))
  getVert.y = Val(Mid$(tmpString, InStr(tmpString, " ") + 1, InStrRev(tmpString, " ") - InStr(tmpString, " ") - 1))
  getVert.z = Val(Mid$(tmpString, InStrRev(tmpString, " ") + 1))

  Exit Function
standardError:
  frmError.Show vbModal
End Function

Private Function getUV(inputLine As String) As objUV
  errModule = "modObj"
  errFunction = "getUV"
  errParms = inputLine
  On Error GoTo standardError
  
  Dim tmpString As String
  ' Strip off the first 2 chars (vt)
  tmpString = Mid$(inputLine, 3)
  getUV.u = Val(Mid$(tmpString, 1, InStr(tmpString, " ")))
  getUV.v = Val(Mid$(tmpString, InStr(tmpString, " ") + 1))
  Exit Function
standardError:
  frmError.Show vbModal
End Function

Private Function getNorm(inputLine As String) As D3DVECTOR
  errModule = "modObj"
  errFunction = "getNorm"
  errParms = inputLine
  On Error GoTo standardError

  Dim tmpString As String
  ' Strip off the first 2 chars (vn)
  tmpString = Mid$(inputLine, 3)
  getNorm.x = Val(Mid$(tmpString, 1, InStr(tmpString, " ") - 1))
  getNorm.y = Val(Mid$(tmpString, InStr(tmpString, " ") + 1, InStrRev(tmpString, " ") - InStr(tmpString, " ") - 1))
  getNorm.z = Val(Mid$(tmpString, InStrRev(tmpString, " ") + 1))
  Exit Function
standardError:
  frmError.Show vbModal
End Function

Private Function getFace(inputLine As String) As peoPolygon
  errModule = "modObj"
  errFunction = "getFace"
  errParms = inputLine
  On Error GoTo standardError
  
  ' face definition in the format  f v/vt/vn v/vt/vn v/vt/vn
  Dim tmpString As String
  Dim v0 As String, v1 As String, v2 As String
  ' Strip off the first 2 chars (f )
  tmpString = Mid$(inputLine, 3)
  ' Splits the face into it's component values
  v0 = Mid$(tmpString, 1, InStr(tmpString, " ") - 1)
  v1 = Mid$(tmpString, InStr(tmpString, " ") + 1, InStrRev(tmpString, " ") - InStr(tmpString, " ") - 1)
  v2 = Mid$(tmpString, InStrRev(tmpString, " ") + 1)
  
  With getFace
  ' v is Mid$(v0, 1, InStr(v0, "/") - 1)
    .Vertex(0) = Val(Mid$(v0, 1, InStr(v0, "/") - 1)) - 1
    .Vertex(1) = Val(Mid$(v1, 1, InStr(v1, "/") - 1)) - 1
    .Vertex(2) = Val(Mid$(v2, 1, InStr(v2, "/") - 1)) - 1
  
  ' vt is Mid$(v1, InStr(v1, "/") + 1, InStrRev(v1, "/") - InStr(v1, "/") - 1)
    .texlist(0) = textCoords(Val(Mid$(v0, InStr(v0, "/") + 1, InStrRev(v0, "/") - InStr(v0, "/") - 1)) - 1).u
    .texlist(1) = textCoords(Val(Mid$(v0, InStr(v0, "/") + 1, InStrRev(v0, "/") - InStr(v0, "/") - 1)) - 1).v
    .texlist(2) = textCoords(Val(Mid$(v1, InStr(v1, "/") + 1, InStrRev(v1, "/") - InStr(v1, "/") - 1)) - 1).u
    .texlist(3) = textCoords(Val(Mid$(v1, InStr(v1, "/") + 1, InStrRev(v1, "/") - InStr(v1, "/") - 1)) - 1).v
    .texlist(4) = textCoords(Val(Mid$(v2, InStr(v2, "/") + 1, InStrRev(v2, "/") - InStr(v2, "/") - 1)) - 1).u
    .texlist(5) = textCoords(Val(Mid$(v2, InStr(v2, "/") + 1, InStrRev(v2, "/") - InStr(v2, "/") - 1)) - 1).v
    
  End With

  Exit Function
standardError:
  frmError.Show vbModal
End Function

Private Sub create3dobjects(start As Integer)
  errModule = "modObj"
  errFunction = "create3dobjects"
  errParms = start
  On Error GoTo standardError
  
  'Dim tmpFace As Direct3DRMFace2
  Dim i As Integer

  ReDim Preserve LoadedPeo(ship.numObjects - 1) As SM_PEODATA
  
  For i = start To (ship.numObjects - 1)
    add3dObject i
    If ship.PEO.object(i).Mother.value = 0 Then
      DX_meshframe.AddChild LoadedPeo(i).Frame
    Else
      LoadedPeo(ship.PEO.object(i).Mother.value - 1).Frame.AddChild LoadedPeo(i).Frame
    End If
    LoadedPeo(i).Visible = True
    
  Next i
  
  DX_cam_gimble.SetPosition DX_cam_track.GetParent, 0, 0, DV_MaxMeshAxis * 2
  Exit Sub
standardError:
  frmError.Show vbModal
End Sub
