Attribute VB_Name = "modImageEffects"
Public Enum InterpolationType
    INTERP_PIXEL = 1
    INTERP_BILINEAR = 2
    INTERP_BICUBIC = 3
End Enum
Sub FlipImage(pImage As ImageFile)
    Dim yY As Long
    Dim Buff2() As Byte
    If pImage.ImageBPP = 24 Then
        ReDim Buff2(1 To (pImage.ImageWidth * pImage.ImageHeight) * 3)
        For yY = 1 To pImage.ImageHeight
            CopyMemory Buff2(((pImage.ImageHeight - yY) * (pImage.ImageWidth * 3)) + 1), pImage.ImageData(((yY - 1) * (pImage.ImageWidth * 3)) + 1), pImage.ImageWidth * 3
        Next yY
        CopyMemory pImage.ImageData(1), Buff2(1), UBound(pImage.ImageData)
    ElseIf pImage.ImageBPP = 8 Then
        ReDim Buff2(1 To pImage.ImageWidth * pImage.ImageHeight)
        For yY = 1 To pImage.ImageHeight
            CopyMemory Buff2(((pImage.ImageHeight - yY) * pImage.ImageWidth) + 1), pImage.ImageData(((yY - 1) * pImage.ImageWidth) + 1), pImage.ImageWidth
        Next yY
        CopyMemory pImage.ImageData(1), Buff2(1), UBound(pImage.ImageData)
    End If
    Erase Buff2
End Sub

Sub MirrorImage(pImage As ImageFile)
    Dim xX As Long, yY As Long
    Dim Buff2() As Byte
    If pImage.ImageBPP = 24 Then
        ReDim Buff2(1 To (pImage.ImageWidth * pImage.ImageHeight) * 3)
        For xX = 0 To pImage.ImageWidth - 1
            For yY = 0 To pImage.ImageHeight - 1
                CopyMemory Buff2(((xX * 3) + yY * (pImage.ImageWidth * 3)) + 1), pImage.ImageData(((((pImage.ImageWidth - 1) - xX) * 3) + yY * (pImage.ImageWidth * 3)) + 1), 3
            Next yY
        Next xX
        CopyMemory pImage.ImageData(1), Buff2(1), UBound(pImage.ImageData)
    ElseIf pImage.ImageBPP = 8 Then
        ReDim Buff2(1 To pImage.ImageWidth * pImage.ImageHeight)
        For xX = 0 To pImage.ImageWidth - 1
            For yY = 0 To pImage.ImageHeight - 1
                Buff2((xX + yY * pImage.ImageWidth) + 1) = pImage.ImageData((((pImage.ImageWidth - 1) - xX) + yY * pImage.ImageWidth) + 1)
            Next yY
        Next xX
        CopyMemory pImage.ImageData(1), Buff2(1), UBound(pImage.ImageData)
    End If
    Erase Buff2
End Sub

Sub NegateImage(pImage As ImageFile)
    Dim i As Long
    Dim Table(0 To 255) As Byte
    'Build a negative lookup table
    For i = 0 To 255
        Table(i) = 255 - i
    Next i
    If pImage.ImageBPP = 24 Then
        For i = 1 To UBound(pImage.ImageData)
            pImage.ImageData(i) = Table(pImage.ImageData(i))
        Next i
    ElseIf pImage.ImageBPP = 8 Then
        For i = 0 To 255
            pImage.ImagePalette(i).rgbRed = Table(pImage.ImagePalette(i).rgbRed)
            pImage.ImagePalette(i).rgbGreen = Table(pImage.ImagePalette(i).rgbGreen)
            pImage.ImagePalette(i).rgbBlue = Table(pImage.ImagePalette(i).rgbBlue)
        Next i
    End If
End Sub
Sub BlurImage(ByRef pImage As ImageFile, Radius As Long)

End Sub
Sub MosaicImage(ByRef pImage As ImageFile, Size As Long)
        'Currently only works for 24bpp, 8bpp creates a weird looking mosaic (because of the palette)
        'Possibilty that Palette must be manipulated instead of color value as it would be too slow to
        'perform a palette lookup to check if the colour needed exists in the current palette.
        'This is not a simple thing to do, as changing the colour palette with the average palette
        'will change the palette location used by previously processed palette items, meaning that
        'it will produce similarly weird results =) TO BE FIXED !!!!!
        Dim sumr As Long, sumg As Long, sumb As Long, square As Long
        Dim i As Long, j As Long
        Dim small_dimen As Long, xX As Long, yY As Long
        Dim actualwidth As Long, actualheight As Long
        If Size = 0 Then Exit Sub
        If pImage.ImageWidth > pImage.ImageHeight Then small_dimen = pImage.ImageHeight Else small_dimen = pImage.ImageWidth
        If Size > small_dimen Then Size = small_dimen
        If pImage.ImageBPP = 24 Then
            Do Until yY >= pImage.ImageHeight
                xX = 0
                Do Until xX >= pImage.ImageWidth * 3
                    sumr = 0: sumg = 0: sumb = 0
                    square = 0: i = 0
                    Do Until ((xX + i) >= pImage.ImageWidth * 3) Or (i >= (Size * 3))
                        j = 0
                        Do Until yY + j >= pImage.ImageHeight Or j > Size
                            sumr = sumr + pImage.ImageData(((xX + i) + (yY + j) * (pImage.ImageWidth * 3)) + 1)
                            sumg = sumg + pImage.ImageData(((xX + i) + (yY + j) * (pImage.ImageWidth * 3)) + 2)
                            sumb = sumb + pImage.ImageData(((xX + i) + (yY + j) * (pImage.ImageWidth * 3)) + 3)
                            square = square + 1
                            j = j + 1
                        Loop
                        i = i + 3
                    Loop
                    actualwidth = i - 1
                    actualheight = j - 1
                    For i = 0 To actualwidth - 1 Step 3
                        For j = 0 To actualheight - 1
                            pImage.ImageData(((xX + i) + (yY + j) * (pImage.ImageWidth * 3)) + 1) = sumr / square
                            pImage.ImageData(((xX + i) + (yY + j) * (pImage.ImageWidth * 3)) + 2) = sumg / square
                            pImage.ImageData(((xX + i) + (yY + j) * (pImage.ImageWidth * 3)) + 3) = sumb / square
                        Next j
                    Next i
                    xX = xX + (Size * 3)
                Loop
                yY = yY + Size
            Loop
        ElseIf pImage.ImageBPP = 8 Then
            Do Until yY >= pImage.ImageHeight
                xX = 0
                Do Until xX >= pImage.ImageWidth
                    sumr = 0
                    square = 0: i = 0
                    Do Until xX + i >= pImage.ImageWidth Or i >= Size
                        j = 0
                        Do Until yY + j >= pImage.ImageHeight Or j > Size
                            sumr = sumr + pImage.ImageData(((xX + i) + (yY + j) * pImage.ImageWidth) + 1)
                            square = square + 1
                            j = j + 1
                        Loop
                        i = i + 3
                    Loop
                    actualwidth = i - 1
                    actualheight = j - 1
                    For i = 0 To actualwidth - 1
                        For j = 0 To actualheight - 1
                            pImage.ImageData(((xX + i) + (yY + j) * pImage.ImageWidth) + 1) = sumr / square
                        Next j
                    Next i
                    xX = xX + Size
                Loop
                yY = yY + Size
            Loop
        End If
End Sub
Sub ResizePixel(pImage As ImageFile, NewWidth As Long, NewHeight As Long)
    Dim xX As Long, yY As Long
    Dim xp As Long, yp As Long
    Dim OffsetDes As Long
    Dim des() As Byte
    Dim ScaleX As Double, ScaleY As Double
    Dim FullWidth As Long
    On Error Resume Next
    ScaleX = (pImage.ImageWidth / NewWidth)
    ScaleY = (pImage.ImageHeight / NewHeight)
    If pImage.ImageBPP = 24 Then
        ReDim des(1 To (NewWidth * NewHeight) * 3)
        OffsetDes = 1
        FullWidth = pImage.ImageWidth * 3
        For yY = 0 To NewHeight - 1
           yp = yY * ScaleY
           For xX = 0 To NewWidth - 1
               xp = CLng(xX * ScaleX) * 3
               des(OffsetDes) = pImage.ImageData(1 + (xp + yp * FullWidth))
               des(OffsetDes + 1) = pImage.ImageData(2 + (xp + yp * FullWidth))
               des(OffsetDes + 2) = pImage.ImageData(3 + (xp + yp * FullWidth))
               OffsetDes = OffsetDes + 3
           Next xX
        Next yY
        Erase pImage.ImageData
        ReDim pImage.ImageData(1 To (NewWidth * NewHeight) * 3)
        pImage.ImageWidth = NewWidth
        pImage.ImageHeight = NewHeight
        CopyMemory pImage.ImageData(1), des(1), UBound(des)
        Erase des
    ElseIf pImage.ImageBPP = 8 Then
        ReDim des(1 To NewWidth * NewHeight)
        OffsetDes = 1
        For yY = 0 To NewHeight - 1
           yp = yY * ScaleY
           For xX = 0 To NewWidth - 1
               xp = xX * ScaleX
               des(OffsetDes) = pImage.ImageData(1 + (xp + yp * pImage.ImageWidth))
               OffsetDes = OffsetDes + 1
           Next xX
        Next yY
        Erase pImage.ImageData
        ReDim pImage.ImageData(1 To NewWidth * NewHeight)
        pImage.ImageWidth = NewWidth
        pImage.ImageHeight = NewHeight
        CopyMemory pImage.ImageData(1), des(1), UBound(des)
        Erase des
    End If
End Sub
Sub ResizeBilinear(pImage As ImageFile, NewWidth As Long, NewHeight As Long)

    'Currently Broken, needs working on !!!!
    
    Dim xX As Long, yY As Long
    Dim x As Long, y As Long, DX As Long, DY As Long
    Dim xp As Long, yp As Long
    Dim OffsetDes As Long
    Dim des() As Byte
    Dim ScaleX As Double, ScaleY As Double
    Dim FullWidth As Long
    Dim r00 As Byte, r01 As Byte, r10 As Byte, r11 As Byte
    Dim g00 As Byte, g01 As Byte, g10 As Byte, g11 As Byte
    Dim b00 As Byte, b01 As Byte, b10 As Byte, b11 As Byte
    'On Error Resume Next
    ScaleX = (pImage.ImageWidth / NewWidth)
    ScaleY = (pImage.ImageHeight / NewHeight)
    OffsetDes = 1
    If pImage.ImageBPP = 8 Then Exit Sub '24bpp ONLY
    FullWidth = pImage.ImageWidth * 3
    ReDim des(1 To (NewWidth * NewHeight) * 3)
    For y = 0 To NewHeight - 2
        yY = LShift((y * pImage.ImageHeight), 8) / NewHeight
        yp = RShift(yY, 8) + 1
        'yp = Y * ScaleY
        DY = yY And 255
        For x = 0 To NewWidth - 1
            xX = LShift((x * FullWidth), 8) / NewWidth
            xp = RShift(xX, 8)
            'xp = CLng(X * ScaleX) * 3
            DX = xX And 255
            r00 = pImage.ImageData((xp + yp * FullWidth) + 1)
            r10 = pImage.ImageData((xp + yp + 1 * FullWidth) + 2)
            r01 = pImage.ImageData((xp + yp * FullWidth) + 1)
            r11 = pImage.ImageData((xp + yp * FullWidth) + 2)
            g00 = pImage.ImageData((xp + yp * FullWidth) + 2)
            g10 = pImage.ImageData((xp + yp * FullWidth) + 5)
            g01 = pImage.ImageData((xp + yp * FullWidth) + 2)
            g11 = pImage.ImageData((xp + yp * FullWidth) + 5)
            b00 = pImage.ImageData((xp + yp * FullWidth) + 3)
            b10 = pImage.ImageData((xp + yp * FullWidth) + 6)
            b01 = pImage.ImageData((xp + yp * FullWidth) + 3)
            b11 = pImage.ImageData((xp + yp * FullWidth) + 6)
            des(OffsetDes) = RShift(((r11 * DX + r01 * (256 - DX)) * DY + (r10 * DX + r00 * (256 - DX)) * (256 - DY)), 16)
            des(OffsetDes + 1) = RShift(((g11 * DX + g01 * (256 - DX)) * DY + (g10 * DX + g00 * (256 - DX)) * (256 - DY)), 16)
            des(OffsetDes + 2) = RShift(((b11 * DX + b01 * (256 - DX)) * DY + (b10 * DX + b00 * (256 - DX)) * (256 - DY)), 16)
            OffsetDes = OffsetDes + 3
        Next x
    Next y
    Erase pImage.ImageData
    ReDim pImage.ImageData(1 To (NewWidth * NewHeight) * 3)
    pImage.ImageWidth = NewWidth
    pImage.ImageHeight = NewHeight
    CopyMemory pImage.ImageData(1), des(1), UBound(des)
    Erase des
End Sub
Sub GrayscaleImage(pImage As ImageFile)
    Dim i As Long, gr As Long
    If pImage.ImageBPP = 24 Then
        For i = 1 To (pImage.ImageWidth * pImage.ImageHeight) * 3 Step 3
            gr = ((CLng(pImage.ImageData(i)) * 77 + CLng(pImage.ImageData(i + 1)) * 151 + CLng(pImage.ImageData(i + 2)) * 28) / 256) And 255
            pImage.ImageData(i) = gr
            pImage.ImageData(i + 1) = gr
            pImage.ImageData(i + 2) = gr
        Next i
    ElseIf pImage.ImageBPP = 8 Then
        For i = 0 To 255
            gr = ((CLng(pImage.ImagePalette(i).rgbRed) * 77 + CLng(pImage.ImagePalette(i).rgbGreen) * 151 + CLng(pImage.ImagePalette(i).rgbBlue) * 28) / 256) And 255
            pImage.ImagePalette(i).rgbRed = gr
            pImage.ImagePalette(i).rgbGreen = gr
            pImage.ImagePalette(i).rgbBlue = gr
        Next i
    End If
End Sub
Sub Rotate90(pImage As ImageFile, AntiClockwise As Boolean)
    Dim x As Long, y As Long
    Dim buf() As Byte
    Dim OffsetDes As Long, OffsetSrc As Long, OffsetDes2 As Long
    ReDim buf(1 To UBound(pImage.ImageData))
    OffsetDes = 1
    OffsetSrc = 1
    On Error Resume Next
    If pImage.ImageBPP = 24 Then
        If AntiClockwise = True Then
            For y = 0 To pImage.ImageHeight - 1
                OffsetDes = ((y * 3) + (pImage.ImageWidth - 1) * (pImage.ImageHeight * 3)) + 1
                For x = 0 To pImage.ImageWidth - 1
                    CopyMemory buf(OffsetDes), pImage.ImageData(OffsetSrc), 3
                    OffsetSrc = OffsetSrc + 3
                    OffsetDes = OffsetDes - (pImage.ImageHeight * 3)
                Next x
            Next y
        Else
            For y = 0 To pImage.ImageHeight - 1
                OffsetDes = (((pImage.ImageHeight - 1) - y) * 3) + 1
                For x = 0 To pImage.ImageWidth - 1
                    CopyMemory buf(OffsetDes), pImage.ImageData(OffsetSrc), 3
                    OffsetSrc = OffsetSrc + 3
                    OffsetDes = OffsetDes + (pImage.ImageHeight * 3)
                Next x
            Next y
        End If
    ElseIf pImage.ImageBPP = 8 Then
        If AntiClockwise = True Then
            For y = 0 To pImage.ImageHeight - 1
                OffsetDes = (y + (pImage.ImageWidth - 1) * pImage.ImageHeight) + 1
                For x = 0 To pImage.ImageWidth - 1
                    buf(OffsetDes) = pImage.ImageData(OffsetSrc)
                    OffsetSrc = OffsetSrc + 1
                    OffsetDes = OffsetDes - pImage.ImageHeight
                Next x
            Next y
        Else
            For y = 0 To pImage.ImageHeight - 1
                OffsetDes = ((pImage.ImageHeight - 1) - y) + 1
                For x = 0 To pImage.ImageWidth - 1
                    buf(OffsetDes) = pImage.ImageData(OffsetSrc)
                    OffsetSrc = OffsetSrc + 1
                    OffsetDes = OffsetDes + pImage.ImageHeight
                Next x
            Next y
        End If
    End If
    Erase pImage.ImageData
    ReDim pImage.ImageData(1 To UBound(buf))
    CopyMemory pImage.ImageData(1), buf(1), UBound(buf)
    Erase buf
    x = pImage.ImageWidth
    pImage.ImageWidth = pImage.ImageHeight
    pImage.ImageHeight = x
End Sub
