Attribute VB_Name = "mod3dRoutines"
Option Explicit
Public DV_MaxMeshAxis As Single

'Public objHost As IHostInterface
'Public myCore As clsCore
Public Canvas As RMCanvas
Public texturePool As clsD3DTexturePool
Public RM As Direct3DRM3
Public myShip As clsShip

Public Type SM_PEODATA
    MeshB As Direct3DRMMeshBuilder3
    Frame As Direct3DRMFrame3
    localmatrix As D3DMATRIX
    Interpolator As Direct3DRMFrameInterpolator
    ColourR As Single
    ColourG As Single
    ColourB As Single
    BoundBox As D3DRMBOX
    name As String
    Index As Integer
    Visible As Boolean
End Type

' Mouse pointer and click point
Public DX_MouseX As Single
Public DX_MouseY As Single
Public DX_MouseUp_X As Single
Public DX_MouseUp_Y As Single
Public DeltX As Single
Public DeltY As Single
Public Drag_Timer As Single
Public DV_PosVect As D3DVECTOR

' Other variables
Public RM_DoUpdate As Byte
Public RM_AutoUpdate As Boolean
Public RM_Animate As Byte
Public RM_Anim_ObjectNo As Integer
Public RM_Anim_AnimNo As Integer
Public RM_Anim_time As Single
Public RM_Anim_length As Single
Public DX_Spinner As Direct3DRMFrameInterpolator

Public activeObject As Integer
Public LoadedObject() As SM_PEODATA
Public LoadedMex() As SM_PEODATA
Public grid As Direct3DRMMeshBuilder3

Public Sub createCone(srcObject As clsShipMeshExtensionPoint, meshObject As Direct3DRMMeshBuilder3)
  
  Dim Mesh_Vertices(8) As D3DVECTOR, Tmp_Vertices(8) As D3DVECTOR
  Dim Mesh_Faces((16 * 4)) As Long
  Dim Norm(0) As D3DVECTOR
  Dim tmpRot As D3DVECTOR
  Dim tmpPosition As D3DVECTOR, tmpNormal As D3DVECTOR
  Dim modifier As Single
  Dim offset1 As Single, offset2 As Single
  Dim coneAngle As Single, edgeAngle As Single, length As Single
  Dim Sign As Byte
  Dim totalAngle As Single
  Dim i As Integer

  ' Read ConeAngle and EdgeAngle and convert them from degrees to radians.
  With srcObject
    coneAngle = .coneAngle * pi / 180
    edgeAngle = .edgeAngle * pi / 180
  End With

  ' Test the size of the angle and switch the parameter Sign to 1,2 or 3.
  ' Sign is used to decide, in wich way the angles needs to be calculated.
  
  totalAngle = Abs(coneAngle + edgeAngle)
  ' Slight adjustments for the strange values that sometimes come with the Cataclysm MEX files.
  Select Case totalAngle
  Case Is < 90
    Sign = 1
  Case Is = 90
    Sign = 2
  Case Is > 90
    Sign = 3
  Case Is > 180
    Sign = 1
    coneAngle = 30
    edgeAngle = 5
  End Select
  '  Original code is below (Pesmontis, Jan. 2003).
  
  'If (coneAngle + edgeAngle < 90) Then
  '   Sign = 1
  'ElseIf (coneAngle + edgeAngle = 90) Then
  '       Sign = 2
  '     Else: Sign = 3
  'End If

  ' This section reads the Position- and NormalVector
  tmpPosition.x = srcObject.position.x
  tmpPosition.Y = srcObject.position.Y
  tmpPosition.z = srcObject.position.z
  tmpNormal.x = srcObject.normal.x
  tmpNormal.Y = srcObject.normal.Y
  tmpNormal.z = srcObject.normal.z
  
  ' calculate and scale the Length of the cone
  length = Sqr(tmpNormal.x ^ 2 + tmpNormal.Y ^ 2 + tmpNormal.z ^ 2)
  If (length <= 0.1 * DV_MaxMeshAxis) Then
     length = DV_MaxMeshAxis / 1.5                'scales the overall Length of the cone
     length = Cos(coneAngle + edgeAngle) * length 'scales the edge Length of the cone
  End If

  ' calculate the offset for the main-axis points
  If (Sign <> 2) Then
     offset1 = Abs(length * Sin(coneAngle + edgeAngle) / Cos(coneAngle + edgeAngle))
  Else: offset1 = length
  End If
  
  ' calculate the offset for the rotatet axis-points
  offset2 = 0.707106781 * offset1
  
  ' Every face needs to be build with v0 and two other points.
  ' Create the Vertices of a StandardCone, without rotation and translation.
  
  ' v0
  Tmp_Vertices(0).x = 0
  Tmp_Vertices(0).Y = 0
  Tmp_Vertices(0).z = 0
  
  ' v1
  Tmp_Vertices(1).x = 0 + offset1
  Tmp_Vertices(1).Y = 0
  If (Sign = 1) Then
     Tmp_Vertices(1).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(1).z = 0 - length
      Else: Tmp_Vertices(1).z = 0
  End If
  
  ' v2
  Tmp_Vertices(2).x = 0 + offset2
  Tmp_Vertices(2).Y = 0 + offset2
  If (Sign = 1) Then
     Tmp_Vertices(2).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(2).z = 0 - length
      Else: Tmp_Vertices(2).z = 0
  End If
  
  ' v3
  Tmp_Vertices(3).x = 0
  Tmp_Vertices(3).Y = 0 + offset1
  If (Sign = 1) Then
     Tmp_Vertices(3).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(3).z = 0 - length
      Else: Tmp_Vertices(3).z = 0
  End If
  
  ' v4
  Tmp_Vertices(4).x = 0 - offset2
  Tmp_Vertices(4).Y = 0 + offset2
  If (Sign = 1) Then
     Tmp_Vertices(4).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(4).z = 0 - length
      Else: Tmp_Vertices(4).z = 0
  End If
  
  ' v5
  Tmp_Vertices(5).x = 0 - offset1
  Tmp_Vertices(5).Y = 0
  If (Sign = 1) Then
     Tmp_Vertices(5).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(5).z = 0 - length
      Else: Tmp_Vertices(5).z = 0
  End If
  
  ' v6
  Tmp_Vertices(6).x = 0 - offset2
  Tmp_Vertices(6).Y = 0 - offset2
  If (Sign = 1) Then
     Tmp_Vertices(6).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(6).z = 0 - length
      Else: Tmp_Vertices(6).z = 0
  End If

  ' v7
  Tmp_Vertices(7).x = 0
  Tmp_Vertices(7).Y = 0 - offset1
  If (Sign = 1) Then
     Tmp_Vertices(7).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(7).z = 0 - length
      Else: Tmp_Vertices(7).z = 0
  End If
  
  ' v8
  Tmp_Vertices(8).x = 0 + offset2
  Tmp_Vertices(8).Y = 0 - offset2
  If (Sign = 1) Then
     Tmp_Vertices(8).z = 0 + length
  ElseIf (Sign = 3) Then
         Tmp_Vertices(8).z = 0 - length
      Else: Tmp_Vertices(8).z = 0
  End If
  
  'Transformation of the Vertices.
  ' v0
  Mesh_Vertices(0).x = tmpPosition.x
  Mesh_Vertices(0).Y = tmpPosition.Y
  Mesh_Vertices(0).z = tmpPosition.z
  ' v1..v8
  For i = 1 To 8
      tmpRot = Rotation_XYZ(Tmp_Vertices(i), tmpNormal)
      Mesh_Vertices(i).x = tmpPosition.x + tmpRot.x
      Mesh_Vertices(i).Y = tmpPosition.Y + tmpRot.Y
      Mesh_Vertices(i).z = tmpPosition.z + tmpRot.z
  Next
  
  ' Create the (cone+edge)Angle Faces.
  For i = 0 To 6
      ' Create the (cone+edge)Angle outside Faces.
      Mesh_Faces(i * 4) = 3
      Mesh_Faces(i * 4 + 1) = 0: Mesh_Faces(i * 4 + 2) = i + 1: Mesh_Faces(i * 4 + 3) = i + 2
      ' Create the (cone+edge)Angle inside Faces.
      Mesh_Faces(32 + i * 4) = 3
      Mesh_Faces(33 + i * 4) = 0: Mesh_Faces(34 + i * 4) = i + 2: Mesh_Faces(35 + i * 4) = i + 1
  Next
  Mesh_Faces(28) = 3 'last outside
  Mesh_Faces(29) = 0: Mesh_Faces(30) = 8: Mesh_Faces(31) = 1
  Mesh_Faces(60) = 3 'last inside
  Mesh_Faces(61) = 0: Mesh_Faces(62) = 1: Mesh_Faces(63) = 8
    
  meshObject.AddFaces UBound(Mesh_Vertices) + 1, Mesh_Vertices, 0, Norm, Mesh_Faces
  
End Sub

Public Sub add3dObject(objNo As Integer, ByRef shaderPool As clsD3DShaderPool)
'  errModule = "modPeo"
'  errFunction = "add3dObject"
'  errParms = objNo
'  On Error GoTo standardError
  
  Dim tmpFace As Direct3DRMFace2
  Dim i As Integer

  If LoadedObject(objNo).Visible = True Then
    LoadedObject(objNo).Frame.DeleteVisual LoadedObject(objNo).MeshB
    LoadedObject(objNo).Visible = False
  End If

  'frmHWSE.lblStatus = "Creating 3d object " & myShip.PEO.object(objNo).objName
    
  ' First we have to work out how many faces belong to
  ' the first material
  'Dim fCount As Long, mCount As Long, faceCount As Long
  'fCount = 0
    
  'For mCount = 0 To (myShip.numMaterials - 1)
  '  For faceCount = 0 To UBound(myShip.PEO.object(objNo).faces)
  '    If myShip.PEO.object(objNo).faces(faceCount).material = mCount Then
  '      ' In here we also have to put the actual face data and vertex data
  '      ' into the relevant arrays
  '      fCount = fCount + 1
  '    End If
  '  Next faceCount
  '  If fCount > 0 Then
  '    pLog "  Object " & myShip.PEO.object(objNo).objName & " face count for material " & mCount & " " & myShip.textures(myShip.materials(mCount).texture).texName & ": " & fCount, 2
  '  End If
  '  fCount = 0
  'Next mCount

  resolveMatrices myShip.mesh(objNo).matrix, LoadedObject(objNo).localmatrix
  'resolveMatrices myShip.PEO.object(objNo).matrix, LoadedObject(objNo).localmatrix

  objHost.DisplayText vbCrLf & " Statistics for object " & objNo & " :"
  objHost.DisplayText "  - name = ' " & myShip.mesh(objNo).mName & " '"
  objHost.DisplayText "  - " & myShip.mesh(objNo).Vertex.Count & " vertices"
  objHost.DisplayText "  - " & myShip.mesh(objNo).Faces.Count & " polygons"
  objHost.DisplayText "  - " & myShip.mesh(objNo).FaceNormals.Count & " face normals"
  objHost.DisplayText "  - " & myShip.mesh(objNo).VertexNormals.Count & " vertex normals"
  ' Parent info isn't stored in the mesh
  'If ((objNo - 1) = myShip.mesh(objNo).Parent.Value) And (myShip.mesh(objNo).Mother.Value = 0) Then
  '  objHost.DisplayText "   ( object is it's own parent )"
  'Else
  '  objHost.DisplayText "  - parent object is object " & (myShip.mesh(objNo).Mother.Value)
  'End If
    
  Set LoadedObject(objNo).MeshB = Canvas.D3DRM.CreateMeshBuilder()
    
  'frmHWSE.lblStatus = "Creating 3d preview"
  'If UBound(myShip.mesh(objNo).faces) = 0 Then
  '  frmHWSE.prgStatus2.Max = 1
  'Else
  '  frmHWSE.prgStatus2.Max = UBound(myShip.mesh(objNo).faces)
  'End If
  'frmHWSE.prgStatus2.Value = 0
  
  objHost.DisplayText "Materials: " & myShip.materials.Count
  
  objHost.DisplayText "Adding " & myShip.mesh(objNo).Faces.Count & " polygons...please wait"
  objHost.SetProgressBar 1, myShip.mesh(objNo).Faces.Count
  
  Dim isChild As Boolean
  
  If myShip.mesh(objNo).Faces.Count = 0 Then
    ' Hardpoint
    objHost.DisplayText "..tis hardpoint " & myShip.mesh(objNo).mName
    Dim tmpMex As clsShipMeshExtensionPoint
    Set tmpMex = New clsShipMeshExtensionPoint
    
    If InStr(myShip.mesh(objNo).mName, "_Position") Then
      objHost.DisplayText "...is primary hardpoint"
      isChild = False
    ElseIf InStr(myShip.mesh(objNo).mName, "_Direction") Then
      objHost.DisplayText "...is child hardpoint"
      tmpMex.colour.r = 255
      isChild = True
    ElseIf InStr(myShip.mesh(objNo).mName, "_Rest") Then
      objHost.DisplayText "...is child hardpoint"
      tmpMex.colour.g = 255
      isChild = True
    ElseIf InStr(myShip.mesh(objNo).mName, "_Muzzle") Then
      tmpMex.colour.b = 255
      objHost.DisplayText "...is child hardpoint"
      isChild = True
    End If
    
    If isChild = False Then
      Set tmpMex.position = myShip.mesh(objNo).position
      'Set tmpMex.normal = myShip.mesh(objNo).rotation
      tmpMex.position.Y = -tmpMex.position.Y
      tmpMex.coneAngle = 0.2
      drawSphere tmpMex, LoadedObject(objNo).MeshB
    Else
      Set tmpMex.position = myShip.mesh(getMeshParent(objNo)).position
      Set tmpMex.normal = myShip.mesh(objNo).position
      ' With hardpoints, invert the Y?
      tmpMex.position.Y = -tmpMex.position.Y
      tmpMex.normal.Y = -tmpMex.normal.Y
        
      drawLine tmpMex, LoadedObject(objNo).MeshB
    End If
        
    objHost.DisplayText "Position: " & tmpMex.position.x & " / " & tmpMex.position.Y & " / " & tmpMex.position.z
    objHost.DisplayText "Normal: " & tmpMex.normal.x & " / " & tmpMex.normal.Y & " / " & tmpMex.normal.z
    
    'createCone tmpMex, LoadedObject(objNo).MeshB
    
  End If
    
  Dim textureNo As Integer
  
  Dim polyCount As Integer, vc As Integer
  For polyCount = 1 To myShip.mesh(objNo).Faces.Count
    Set tmpFace = Canvas.D3DRM.CreateFace()
    With myShip.mesh(objNo).Faces(polyCount)
      'Debug.Print polyCount, .Vertex.v0, .Vertex.v1, .Vertex.v2, myShip.mesh(objNo).stats.nPolygons

      tmpFace.AddVertex myShip.mesh(objNo).Vertex(.Vertex.v0).position.x, -myShip.mesh(objNo).Vertex(.Vertex.v0).position.Y, myShip.mesh(objNo).Vertex(.Vertex.v0).position.z
      tmpFace.AddVertex myShip.mesh(objNo).Vertex(.Vertex.v2).position.x, -myShip.mesh(objNo).Vertex(.Vertex.v2).position.Y, myShip.mesh(objNo).Vertex(.Vertex.v2).position.z
      tmpFace.AddVertex myShip.mesh(objNo).Vertex(.Vertex.v1).position.x, -myShip.mesh(objNo).Vertex(.Vertex.v1).position.Y, myShip.mesh(objNo).Vertex(.Vertex.v1).position.z
      
      tmpFace.SetTextureCoordinates 0, myShip.mesh(objNo).Faces(polyCount).texList.v0u, myShip.mesh(objNo).Faces(polyCount).texList.v0v
      tmpFace.SetTextureCoordinates 1, myShip.mesh(objNo).Faces(polyCount).texList.v2u, myShip.mesh(objNo).Faces(polyCount).texList.v2v
      tmpFace.SetTextureCoordinates 2, myShip.mesh(objNo).Faces(polyCount).texList.v1u, myShip.mesh(objNo).Faces(polyCount).texList.v1v
    End With
    If myShip.materials.Count > 0 Then
      If myShip.mesh(objNo).Faces(polyCount).material > -1 Then
        
        textureNo = myShip.mesh(objNo).Faces(polyCount).material
        For i = 1 To shaderPool.shader(textureNo).TextureCount
          Select Case shaderPool.shader(textureNo).Texture(i).texType
          Case texDiffuse:
            tmpFace.SetTexture texturePool.GetTexture(shaderPool.shader(textureNo).Texture(i).textureId)
          Case Else:
          End Select
        Next i
      End If
    End If
    tmpFace.SetColor RGB(255, 255, 255)
    LoadedObject(objNo).MeshB.AddFace tmpFace
    
    ' If there is a second side then add that too
    If myShip.materials.Count > 0 Then
      If myShip.mesh(objNo).Faces(polyCount).material > -1 And myShip.mesh(objNo).Faces(polyCount).material < myShip.materials.Count Then
        If myShip.materials(myShip.mesh(objNo).Faces(polyCount).material).flags.twoSided = True Then
          Set tmpFace = Canvas.D3DRM.CreateFace()
          With myShip.mesh(objNo).Faces(polyCount)
            tmpFace.AddVertex myShip.mesh(objNo).Vertex(.Vertex.v0).position.x, myShip.mesh(objNo).Vertex(.Vertex.v0).position.Y, myShip.mesh(objNo).Vertex(.Vertex.v0).position.z
            tmpFace.AddVertex myShip.mesh(objNo).Vertex(.Vertex.v2).position.x, myShip.mesh(objNo).Vertex(.Vertex.v2).position.Y, myShip.mesh(objNo).Vertex(.Vertex.v2).position.z
            tmpFace.AddVertex myShip.mesh(objNo).Vertex(.Vertex.v1).position.x, myShip.mesh(objNo).Vertex(.Vertex.v1).position.Y, myShip.mesh(objNo).Vertex(.Vertex.v1).position.z
            tmpFace.SetTextureCoordinates 0, myShip.mesh(objNo).Faces(polyCount).texList.v0u, myShip.mesh(objNo).Faces(polyCount).texList.v0v
            tmpFace.SetTextureCoordinates 1, myShip.mesh(objNo).Faces(polyCount).texList.v2u, myShip.mesh(objNo).Faces(polyCount).texList.v2v
            tmpFace.SetTextureCoordinates 2, myShip.mesh(objNo).Faces(polyCount).texList.v1u, myShip.mesh(objNo).Faces(polyCount).texList.v1v
          End With
          ''If myShip.Textures(myShip.materials(myShip.mesh(objNo).Faces(polyCount).material).textureId).loaded = True Then
            'tmpFace.SetTexture myShip.textures(myShip.materials(myShip.mesh(objNo).Faces(polyCount).material).texture).main
          ''  tmpFace.SetTexture texturePool.GetTexture(myShip.materials(myShip.mesh(objNo).Faces(polyCount).material).textureId)
            'tmpFace.SetMaterial myShip.materials(myShip.mesh(objNo).Faces(polyCount).material).material
          ''End If
          tmpFace.SetColor RGB(255, 255, 255)
          LoadedObject(objNo).MeshB.AddFace tmpFace
        End If
      End If
    End If
    
    'frmHWSE.prgStatus2.Value = polyCount
    objHost.UpdateProgressBar CLng(polyCount)
    DoEvents
  Next polyCount
   
  objHost.DisplayText "Done!"
   
  With LoadedObject(objNo)
    If myShip.mesh(objNo).Faces.Count = 0 Then
      .MeshB.SetQuality D3DRMRENDER_WIREFRAME
    Else
      .MeshB.SetQuality D3DRMRENDER_FLAT Or D3DRMLIGHT_OFF
    End If
    'frmHWSE.lblStatus = "Optimizing mesh"
    'frmHWSE.lblStatus.Refresh
     
    '.MeshB.Optimize
    '.MeshB.GenerateNormals 2#, D3DRMGENERATENORMALS_PRECOMPACT
    .MeshB.SetPerspective D_TRUE
      
    'Dim ScaledCol As Single
    'ScaledCol = 1 / myShip.mesh.Count * objNo

    .ColourR = 255
    .ColourG = 255
    .ColourB = 255
    
    ' This line needed for my Radeon 9200, but wasn't needed for a GF2 MX 400
    .MeshB.SetColor Canvas.dx.CreateColorRGBA(.ColourR, .ColourG, .ColourB, 1)
    
    .name = myShip.mesh(objNo).mName
  End With
    
  Set LoadedObject(objNo).Frame = Canvas.D3DRM.CreateFrame(Nothing)
  LoadedObject(objNo).Frame.AddVisual LoadedObject(objNo).MeshB
  LoadedObject(objNo).Frame.SetName "peo_" & myShip.mesh(objNo).mName

  ' Add in later
  'setMaxAxis objNo

  ' Add in later
  'LoadedObject(objNo).BoundBox.Max.x = myShip.mesh(objNo).stats.Size.x
  'LoadedObject(objNo).BoundBox.Max.y = myShip.mesh(objNo).stats.Size.y
  'LoadedObject(objNo).BoundBox.Max.z = myShip.mesh(objNo).stats.Size.z

End Sub


'---------------------------------------------------------------------------------------
' Procedure : HitTest
' DateTime  : 12/10/2003 16:28
' Author    : Stuart
' Purpose   : Generates the ID of the clicked upon 3d object
'---------------------------------------------------------------------------------------
'
Public Function HitTest(x As Single, Y As Single) As Long
  
  Dim PickArray As Direct3DRMPickArray
  Dim desc As D3DRMPICKDESC
  Dim pickString As String, pickNumber As Long, tmpString As String
  Dim k As Integer, i As Integer
  
  Set PickArray = Canvas.Viewport.Pick(CLng(x), CLng(Y))
  Debug.Print x, Y, PickArray.GetSize
  If PickArray.GetSize() = 0 Then
    label2text = "Nothing selected"
    If activeObject > 0 Then
      resetPreviousObject activeObject
    End If
    'lblKey = ""
    activeObject = 0
    HitTest = 0
    'Dx_Label1.Caption = "Nothing selected"
    'cmdApplyMatrix.Enabled = False
    'cmdKeyfApply.Enabled = False
    'cmdAdvancedObjProps.Enabled = False
  Else
    'Debug.Print "PickArray size: " & PickArray.GetSize
    For k = 0 To (PickArray.GetSize - 1)
      For i = 0 To (PickArray.GetPickFrame(k, desc).GetSize - 1)
        tmpString = PickArray.GetPickFrame(k, desc).GetElement(i).GetName
        If Len(tmpString) > 4 Then
          If Mid$(tmpString, 1, 4) = "peo_" Then
            If pickNumber < i Then
              pickNumber = i
              pickString = Mid$(tmpString, 5)
            End If
          End If
        End If
      Next i
    Next k
    
    If activeObject > 0 Then
      resetPreviousObject activeObject
    End If
    
    ' Now get the object stats based on the name
    For k = 1 To myShip.mesh.Count
      With myShip.mesh(k)
        If .mName = pickString Then
          If .useMatrix = True Then
            label2text = "Selected object: " & pickString & " (X: " & .matrix.rc14 & " Y: " & .matrix.rc24 & " Z: " & .matrix.rc34 & ")"
          Else
            label2text = "Selected object: " & pickString & " (X: " & .position.x & " Y: " & .position.Y & " Z: " & .position.z & ")"
          End If
          activeObject = k
          HitTest = k
           ' Update the 3d preview to show the active object
          If LoadedObject(k).Visible = True Then
            LoadedObject(k).MeshB.SetColorRGB 255, 0, 0
              'If frmHWSE.mnuRenderFlat.Checked = True Then
              '  .MeshB.SetQuality D3DRMRENDER_UNLITFLAT
              'Else
              '  .MeshB.SetQuality D3DRMRENDER_WIREFRAME
              'End If
            'showLocalAxes LoadedObject(k)
          End If
          
        End If
      End With
    Next k
    
    'Dx_Label1.Caption = "Selected object: " & pickString
    'cmdApplyMatrix.Enabled = True
    'cmdKeyfApply.Enabled = True
    'cmdAdvancedObjProps.Enabled = True
    
    'Debug.Print "Picked: " & pickString
    'For i = 1 To UBound(LoadedObject)
    '  If LoadedObject(i).name = pickString Then
    '    'Debug.Print "PEO Object number: " & i
        'If activeObject > 0 Then
        '  resetPreviousObject activeObject
        'End If
    '    lblKey = "o" & i
    '    activeObject = i
    '    getObjectDetails activeObject
    '    ' Automatically change tabs
    '    If SSTab1.Tab < 5 And SSTab2.Tab <> 2 Then
    '      SSTab1.Tab = 2
    '      SSTab2.Tab = 1
    '    End If

    '    Dim myNode As Node
    '    For Each myNode In treeHeirachy.Nodes
    '      If myNode.Text = ship.PEO.object(i).objName Then
    '        Set treeHeirachy.SelectedItem = treeHeirachy.Nodes(myNode.Index)
    '      End If
    '    Next myNode
        
    '  End If
    'Next i
  End If
  
End Function


'Private Sub HitTest2(x As Single, y As Single)
'
'  Dim PickArray As Direct3DRMPick2Array
'  Dim desc As D3DRMPICKDESC2
'  Dim ray As D3DRMRAY
'  Dim k As Integer
'
'  Canvas.CameraFrame.GetPosition Nothing, ray.pos
'  Canvas.CameraFrame.GetRotation Nothing, ray.Dir, 0
'
'  objHost.DisplayText "Camera Position: " & ray.pos.x & " / " & ray.pos.y & " / " & ray.pos.z
'  objHost.DisplayText "Camera Rotation: " & ray.Dir.x & " / " & ray.Dir.y & " / " & ray.Dir.z
'
'  Set PickArray = Canvas.CameraFrame.RayPick(Nothing, ray, D3DRMRAYPICK_IGNOREFURTHERPRIMITIVES)
'  objHost.DisplayText "Pick Array Size: " & PickArray.GetSize
'
'End Sub

Public Sub createMexObject(meshInfo As clsShipMeshExtension, objNo As Integer)

  Set LoadedMex(objNo).MeshB = Canvas.D3DRM.CreateMeshBuilder()
  Set LoadedMex(objNo).Frame = Canvas.D3DRM.CreateFrame(Nothing)

  Select Case meshInfo.mexType
  Case 1:
    meshInfo.Point(1).colour.r = 255
    meshInfo.Point(1).colour.g = 255
    meshInfo.Point(1).colour.b = 255
    createBox meshInfo.Point(1), LoadedMex(objNo)
    'LoadedMex(objNo).MeshB.SetColorRGB 255, 255, 255
    LoadedMex(objNo).MeshB.SetQuality D3DRMRENDER_WIREFRAME
  End Select
  
  LoadedMex(objNo).Frame.AddVisual LoadedMex(objNo).MeshB
  LoadedMex(objNo).Visible = True
  'LoadedMex(.myShip.objects(objNo).refID).Frame.SetPosition LoadedObject(myShip.objects(objNo).refID).Frame.GetParent, myShip.mesh(.refID).position.x, myShip.mesh(.refID).position.y, myShip.mesh(.refID).position.z
  
  'MsgBox meshInfo.objectID & " - " & myShip.objects(meshInfo.objectID).refID
  
  LoadedObject(myShip.objects(meshInfo.objectID).Parent.Value).Frame.AddChild LoadedMex(objNo).Frame

End Sub

Public Sub createBox(meshPoint As clsShipMeshExtensionPoint, mesh As SM_PEODATA)
    
    Dim tmpFace As Direct3DRMFace2
    Dim tmpMat As Direct3DRMMaterial2
    
    Set tmpMat = Canvas.dx.Direct3DRMCreate.CreateMaterial(0)
    tmpMat.SetEmissive meshPoint.colour.r, meshPoint.colour.g, meshPoint.colour.b
    
    'meshPoint.normal.x = meshPoint.normal.x * 2
    'meshPoint.normal.y = meshPoint.normal.y * 2
    'meshPoint.normal.z = meshPoint.normal.z * 2
    
    ' Top
    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), meshPoint.position.Y, meshPoint.position.z
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), (meshPoint.position.Y + meshPoint.normal.Y), meshPoint.position.z
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), (meshPoint.position.Y + meshPoint.normal.Y), (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), meshPoint.position.Y, (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.SetColorRGB meshPoint.colour.r, meshPoint.colour.g, meshPoint.colour.b
    tmpFace.SetMaterial tmpMat
    mesh.MeshB.AddFace tmpFace
    
    ' Bottom
    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    tmpFace.AddVertex meshPoint.position.x, (meshPoint.position.Y + meshPoint.normal.Y), meshPoint.position.z
    tmpFace.AddVertex meshPoint.position.x, meshPoint.position.Y, meshPoint.position.z
    tmpFace.AddVertex meshPoint.position.x, meshPoint.position.Y, (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex meshPoint.position.x, (meshPoint.position.Y + meshPoint.normal.Y), (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.SetColorRGB meshPoint.colour.r, meshPoint.colour.g, meshPoint.colour.b
    tmpFace.SetMaterial tmpMat
    mesh.MeshB.AddFace tmpFace
    
    ' Left
    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    tmpFace.AddVertex meshPoint.position.x, meshPoint.position.Y, meshPoint.position.z
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), meshPoint.position.Y, meshPoint.position.z
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), meshPoint.position.Y, (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex meshPoint.position.x, meshPoint.position.Y, (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.SetColorRGB meshPoint.colour.r, meshPoint.colour.g, meshPoint.colour.b
    tmpFace.SetMaterial tmpMat
    mesh.MeshB.AddFace tmpFace
    
    ' Front
    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), meshPoint.position.Y, (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), (meshPoint.position.Y + meshPoint.normal.Y), (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex meshPoint.position.x, (meshPoint.position.Y + meshPoint.normal.Y), (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex meshPoint.position.x, meshPoint.position.Y, (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.SetColorRGB meshPoint.colour.r, meshPoint.colour.g, meshPoint.colour.b
    tmpFace.SetMaterial tmpMat
    mesh.MeshB.AddFace tmpFace
    
    ' Right
    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    tmpFace.AddVertex meshPoint.position.x, (meshPoint.position.Y + meshPoint.normal.Y), (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), (meshPoint.position.Y + meshPoint.normal.Y), (meshPoint.position.z + meshPoint.normal.z)
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), (meshPoint.position.Y + meshPoint.normal.Y), meshPoint.position.z
    tmpFace.AddVertex meshPoint.position.x, (meshPoint.position.Y + meshPoint.normal.Y), meshPoint.position.z
    tmpFace.SetColorRGB meshPoint.colour.r, meshPoint.colour.g, meshPoint.colour.b
    tmpFace.SetMaterial tmpMat
    mesh.MeshB.AddFace tmpFace
    
    ' Back
    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    tmpFace.AddVertex meshPoint.position.x, meshPoint.position.Y, meshPoint.position.z
    tmpFace.AddVertex meshPoint.position.x, (meshPoint.position.Y + meshPoint.normal.Y), meshPoint.position.z
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), (meshPoint.position.Y + meshPoint.normal.Y), meshPoint.position.z
    tmpFace.AddVertex (meshPoint.position.x + meshPoint.normal.x), meshPoint.position.Y, meshPoint.position.z
    tmpFace.SetColorRGB meshPoint.colour.r, meshPoint.colour.g, meshPoint.colour.b
    tmpFace.SetMaterial tmpMat
    mesh.MeshB.AddFace tmpFace
    
End Sub

Public Sub drawLine(srcObject As clsShipMeshExtensionPoint, meshObject As Direct3DRMMeshBuilder3)
  'errModule = "modD3D"
  'errFunction = "drawLine"
  'errParms = ""
  'On Error GoTo standardError
  
  Dim offset As Single
  offset = 0.001

  Dim tmpFace As Direct3DRMFace2
  Dim tmpMat As Direct3DRMMaterial2
    
  Set tmpMat = Canvas.dx.Direct3DRMCreate.CreateMaterial(0)
  
  With srcObject
  
    tmpMat.SetEmissive .colour.r, .colour.g, .colour.b
  
    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    ' 1
    tmpFace.AddVertex .position.x, .position.Y, .position.z
    ' 2
    If isNormal(srcObject.normal) = True Then
      tmpFace.AddVertex (srcObject.position.x + (srcObject.normal.x * (DV_MaxMeshAxis / 3))), (srcObject.position.Y + (srcObject.normal.Y * (DV_MaxMeshAxis / 3))), (srcObject.position.z + (srcObject.normal.z * (DV_MaxMeshAxis / 3)))
    Else
      tmpFace.AddVertex (srcObject.position.x + srcObject.normal.x), (srcObject.position.Y + srcObject.normal.Y), (srcObject.position.z + srcObject.normal.z)
    End If
    ' 3
    tmpFace.AddVertex .position.x + offset, .position.Y + offset, .position.z + offset
    
    tmpFace.SetColorRGB srcObject.colour.r, srcObject.colour.g, srcObject.colour.b
    tmpFace.SetMaterial tmpMat
    meshObject.AddFace tmpFace

    Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
    
    ' 1
    tmpFace.AddVertex .position.x, .position.Y, .position.z
    ' 3
    tmpFace.AddVertex .position.x + offset, .position.Y + offset, .position.z + offset
    ' 2
    If isNormal(srcObject.normal) = True Then
      tmpFace.AddVertex (srcObject.position.x + (srcObject.normal.x * (DV_MaxMeshAxis / 3))), (srcObject.position.Y + (srcObject.normal.Y * (DV_MaxMeshAxis / 3))), (srcObject.position.z + (srcObject.normal.z * (DV_MaxMeshAxis / 3)))
    Else
      tmpFace.AddVertex (srcObject.position.x + srcObject.normal.x), (srcObject.position.Y + srcObject.normal.Y), (srcObject.position.z + srcObject.normal.z)
    End If
    
    tmpFace.SetColorRGB srcObject.colour.r, srcObject.colour.g, srcObject.colour.b
    tmpFace.SetMaterial tmpMat
    meshObject.AddFace tmpFace

    objHost.DisplayText "Drawing line from: " & .position.x & "/" & .position.Y & "/" & .position.z & " to " & .normal.x & "/" & .normal.Y & "/" & .normal.z

  End With
  
End Sub

Function getMeshParent(meshNo As Integer) As Integer
  Dim Count As Integer

  For Count = 1 To myShip.objects.Count
    With myShip.objects(Count)
      If .refID = meshNo Then
        getMeshParent = myShip.objects(.Parent.Value).refID
      End If
    End With
  Next
  objHost.DisplayText "Mesh #" & meshNo & " parent is mesh: " & getMeshParent
End Function

Sub drawGrid(meshObject As Direct3DRMMeshBuilder3)
  
  Set grid = Canvas.D3DRM.CreateMeshBuilder()
  Dim tmpFace As Direct3DRMFace2

  Dim x As Integer
  Dim Y As Integer
  For x = -20 To 20
    For Y = -20 To 20
      Set tmpFace = Canvas.dx.Direct3DRMCreate.CreateFace()
      tmpFace.AddVertex x, 0, Y
      tmpFace.AddVertex x + 1, 0, Y
      tmpFace.AddVertex x + 1, 0, Y + 1
      tmpFace.AddVertex x, 0, Y + 1
      If x < 0 And Y < 0 Then
        tmpFace.SetColorRGB 255, 0, 0
      ElseIf x < 0 And Y >= 0 Then
        tmpFace.SetColorRGB 0, 255, 0
      ElseIf x >= 0 And Y < 0 Then
        tmpFace.SetColorRGB 0, 0, 255
      Else
        tmpFace.SetColorRGB 255, 0, 255
      End If
      meshObject.AddFace tmpFace
    Next
  Next
  meshObject.SetQuality D3DRMFILL_WIREFRAME Or D3DRMLIGHT_ON

End Sub

Public Sub drawSphere(srcObject As clsShipMeshExtensionPoint, meshObject As Direct3DRMMeshBuilder3)
  
  Dim Mesh_Vertices(17) As D3DVECTOR
  Dim Mesh_Faces((32 * 4)) As Long
  Dim offset1 As Single, offset2 As Single
  Dim Norm(0) As D3DVECTOR
  Dim tmpNormal As D3DVECTOR
  
  ' calculate the offset for the main-axis points
  offset1 = srcObject.coneAngle
  ' calculate the offset for the rotatet axis-points
  offset2 = 0.707106781 * offset1
  
  
  'v0
  Mesh_Vertices(0).x = srcObject.position.x
  Mesh_Vertices(0).Y = srcObject.position.Y + offset1
  Mesh_Vertices(0).z = srcObject.position.z
  
  Mesh_Vertices(1).x = srcObject.position.x - offset2
  Mesh_Vertices(1).Y = srcObject.position.Y + offset2
  Mesh_Vertices(1).z = srcObject.position.z
  
  Mesh_Vertices(2).x = srcObject.position.x
  Mesh_Vertices(2).Y = srcObject.position.Y + offset2
  Mesh_Vertices(2).z = srcObject.position.z + offset2
  
  Mesh_Vertices(3).x = srcObject.position.x + offset2
  Mesh_Vertices(3).Y = srcObject.position.Y + offset2
  Mesh_Vertices(3).z = srcObject.position.z
  
  Mesh_Vertices(4).x = srcObject.position.x
  Mesh_Vertices(4).Y = srcObject.position.Y + offset2
  Mesh_Vertices(4).z = srcObject.position.z - offset2
  
  Mesh_Vertices(5).x = srcObject.position.x - offset1
  Mesh_Vertices(5).Y = srcObject.position.Y
  Mesh_Vertices(5).z = srcObject.position.z
  
  Mesh_Vertices(6).x = srcObject.position.x - offset2
  Mesh_Vertices(6).Y = srcObject.position.Y
  Mesh_Vertices(6).z = srcObject.position.z + offset2
  
  Mesh_Vertices(7).x = srcObject.position.x
  Mesh_Vertices(7).Y = srcObject.position.Y
  Mesh_Vertices(7).z = srcObject.position.z + offset1
  
  Mesh_Vertices(8).x = srcObject.position.x + offset2
  Mesh_Vertices(8).Y = srcObject.position.Y
  Mesh_Vertices(8).z = srcObject.position.z + offset2
  
  Mesh_Vertices(9).x = srcObject.position.x + offset1
  Mesh_Vertices(9).Y = srcObject.position.Y
  Mesh_Vertices(9).z = srcObject.position.z
  
  Mesh_Vertices(10).x = srcObject.position.x + offset2
  Mesh_Vertices(10).Y = srcObject.position.Y
  Mesh_Vertices(10).z = srcObject.position.z - offset2
  
  Mesh_Vertices(11).x = srcObject.position.x
  Mesh_Vertices(11).Y = srcObject.position.Y
  Mesh_Vertices(11).z = srcObject.position.z - offset1
  
  Mesh_Vertices(12).x = srcObject.position.x - offset2
  Mesh_Vertices(12).Y = srcObject.position.Y
  Mesh_Vertices(12).z = srcObject.position.z - offset2
  
  Mesh_Vertices(13).x = srcObject.position.x - offset2
  Mesh_Vertices(13).Y = srcObject.position.Y - offset2
  Mesh_Vertices(13).z = srcObject.position.z
  
  Mesh_Vertices(14).x = srcObject.position.x
  Mesh_Vertices(14).Y = srcObject.position.Y - offset2
  Mesh_Vertices(14).z = srcObject.position.z + offset2
  
  Mesh_Vertices(15).x = srcObject.position.x + offset2
  Mesh_Vertices(15).Y = srcObject.position.Y - offset2
  Mesh_Vertices(15).z = srcObject.position.z
  
  Mesh_Vertices(16).x = srcObject.position.x
  Mesh_Vertices(16).Y = srcObject.position.Y - offset2
  Mesh_Vertices(16).z = srcObject.position.z - offset2
  
  Mesh_Vertices(17).x = srcObject.position.x
  Mesh_Vertices(17).Y = srcObject.position.Y - offset1
  Mesh_Vertices(17).z = srcObject.position.z
  
  
  Mesh_Faces(0) = 3
  Mesh_Faces(1) = 0: Mesh_Faces(2) = 2: Mesh_Faces(3) = 1
  Mesh_Faces(4) = 3
  Mesh_Faces(5) = 0: Mesh_Faces(6) = 3: Mesh_Faces(7) = 2
  Mesh_Faces(8) = 3
  Mesh_Faces(9) = 0: Mesh_Faces(10) = 4: Mesh_Faces(11) = 3
  Mesh_Faces(12) = 3
  Mesh_Faces(13) = 0: Mesh_Faces(14) = 1: Mesh_Faces(15) = 4
  
  Mesh_Faces(16) = 3
  Mesh_Faces(17) = 1: Mesh_Faces(18) = 6: Mesh_Faces(19) = 5
  Mesh_Faces(20) = 3
  Mesh_Faces(21) = 1: Mesh_Faces(22) = 2: Mesh_Faces(23) = 6
  Mesh_Faces(24) = 3
  Mesh_Faces(25) = 2: Mesh_Faces(26) = 7: Mesh_Faces(27) = 6
  Mesh_Faces(28) = 3
  Mesh_Faces(29) = 2: Mesh_Faces(30) = 8: Mesh_Faces(31) = 7
  Mesh_Faces(32) = 3
  Mesh_Faces(33) = 2: Mesh_Faces(34) = 3: Mesh_Faces(35) = 8
  Mesh_Faces(36) = 3
  Mesh_Faces(37) = 3: Mesh_Faces(38) = 9: Mesh_Faces(39) = 8
  Mesh_Faces(40) = 3
  Mesh_Faces(41) = 3: Mesh_Faces(42) = 10: Mesh_Faces(43) = 9
  Mesh_Faces(44) = 3
  Mesh_Faces(45) = 3: Mesh_Faces(46) = 4: Mesh_Faces(47) = 10
  Mesh_Faces(48) = 3
  Mesh_Faces(49) = 4: Mesh_Faces(50) = 11: Mesh_Faces(51) = 10
  Mesh_Faces(52) = 3
  Mesh_Faces(53) = 4: Mesh_Faces(54) = 12: Mesh_Faces(55) = 11
  Mesh_Faces(56) = 3
  Mesh_Faces(57) = 4: Mesh_Faces(58) = 1: Mesh_Faces(59) = 12
  Mesh_Faces(60) = 3
  Mesh_Faces(61) = 1: Mesh_Faces(62) = 5: Mesh_Faces(63) = 12
  
  Mesh_Faces(64) = 3
  Mesh_Faces(65) = 13: Mesh_Faces(66) = 5: Mesh_Faces(67) = 6
  Mesh_Faces(68) = 3
  Mesh_Faces(69) = 13: Mesh_Faces(70) = 6: Mesh_Faces(71) = 14
  Mesh_Faces(72) = 3
  Mesh_Faces(73) = 14: Mesh_Faces(74) = 6: Mesh_Faces(75) = 7
  Mesh_Faces(76) = 3
  Mesh_Faces(77) = 14: Mesh_Faces(78) = 7: Mesh_Faces(79) = 8
  Mesh_Faces(80) = 3
  Mesh_Faces(81) = 14: Mesh_Faces(82) = 8: Mesh_Faces(83) = 15
  Mesh_Faces(84) = 3
  Mesh_Faces(85) = 15: Mesh_Faces(86) = 8: Mesh_Faces(87) = 9
  Mesh_Faces(88) = 3
  Mesh_Faces(89) = 15: Mesh_Faces(90) = 9: Mesh_Faces(91) = 10
  Mesh_Faces(92) = 3
  Mesh_Faces(93) = 15: Mesh_Faces(94) = 10: Mesh_Faces(95) = 16
  Mesh_Faces(96) = 3
  Mesh_Faces(97) = 16: Mesh_Faces(98) = 10: Mesh_Faces(99) = 11
  Mesh_Faces(100) = 3
  Mesh_Faces(101) = 16: Mesh_Faces(102) = 11: Mesh_Faces(103) = 12
  Mesh_Faces(104) = 3
  Mesh_Faces(105) = 16: Mesh_Faces(106) = 12: Mesh_Faces(107) = 13
  Mesh_Faces(108) = 3
  Mesh_Faces(109) = 13: Mesh_Faces(110) = 12: Mesh_Faces(111) = 5
  
  Mesh_Faces(112) = 3
  Mesh_Faces(113) = 17: Mesh_Faces(114) = 14: Mesh_Faces(115) = 15
  Mesh_Faces(116) = 3
  Mesh_Faces(117) = 17: Mesh_Faces(118) = 15: Mesh_Faces(119) = 16
  Mesh_Faces(120) = 3
  Mesh_Faces(121) = 17: Mesh_Faces(122) = 16: Mesh_Faces(123) = 13
  Mesh_Faces(124) = 3
  Mesh_Faces(125) = 17: Mesh_Faces(126) = 13: Mesh_Faces(127) = 14
  
  meshObject.AddFaces UBound(Mesh_Vertices) + 1, Mesh_Vertices, 0, Norm, Mesh_Faces

End Sub

