VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShipDefs"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Enum hwShipType
  hwShip = 1026
  hwcShip = 1280
End Enum

Public Type hwColourType
    r As Byte
    g As Byte
    b As Byte
    a As Byte
End Type

Public Type heirachy
    offset As Long
    value As Long
End Type

Public Type peoPolygon
    Vertex(2) As Long
    material As Long
    normal As Long
    flags As Integer
    Reserved As Integer
    texlist(5) As Single
End Type

Public Type peoVertex
    x As Single
    y As Single
    z As Single
    normal As Long
End Type

Public Type peoStats
    nFaceNormals As Long
    nVertexNormals As Long
    nPolygons As Long
    nVertices As Long
    max As D3DVECTOR
    min As D3DVECTOR
    size As D3DVECTOR
End Type

Public Type hwPeoSaveData
  oVertexList As Long
  oFaceNormalList As Long
  oVertNormalList As Long ' Cat only
  oPolygonList As Long
End Type

Public Type peoObject
    faces() As peoPolygon
    matrix As D3DMATRIX
    vertexList() As peoVertex
    faceNormalList() As D3DVECTOR
    vertNormalList() As D3DVECTOR
    objName As String
    Mother As heirachy
    Daughter As heirachy
    Sister As heirachy
    flags As Long
    stats As peoStats
    madObjNo As Integer ' Index into the MAD objects list
    sharedObjNo As Integer ' If this object shares polys/verts/normals
                           ' with another, the sharedObjNo will
                           ' be > -1
    saveData As hwPeoSaveData ' Only used when saving shared
                              ' data
End Type

Public Type hwPeo
    object() As peoObject
    numPMaterials As Integer   ' Public Materials
    numLMaterials As Integer   ' Local Materials
End Type

Public Type hwLif
    'main As DirectDrawSurface4
    Main As Direct3DRMTexture3
    base As DirectDrawSurface7
    Stripe As DirectDrawSurface7
    texName As String
    lWidth As Long
    lHeight As Long
    loaded As Boolean
End Type

' Note - a ship may have more materials than textures
' as textures are individual lifs, but multiple materials can
' reference one texture

Public Type hwMatFlag
  smoothed As Boolean
  flatShaded As Boolean
  twoSided As Boolean
  baseColour As Boolean
  stripeColour As Boolean
  selfIllum As Boolean
End Type

Public Type hwMat
    material As Direct3DRMMaterial2
    ambient As hwColourType
    diffuse As hwColourType
    specular As hwColourType
    texture As Integer
    'flags As Long
    flags As hwMatFlag
    kAlpha As Single
    nFullAmbient As Integer
    offset As Long
    'twoSided As Boolean
End Type

Public Type mexChunk
    position As D3DVECTOR
    normal As D3DVECTOR
    chunkId As String
    text As String
    coneAngle As Single
    edgeAngle As Single
    colour As D3DCOLORVALUE
    level As Long
    type As String
End Type

Public Type hwMex
    noOfChunks As Long
    chunk() As mexChunk
End Type

Public Type hwMadAnimInfo
    name As String
    startTime As Single
    endTime As Single
    loop As Byte
End Type

Public Type hwMadKeyframe
    time As Single
    tension As Single
    continuity As Single
    bias As Single
    x As Single
    y As Single
    z As Single
    rotX As Single
    rotY As Single
    rotZ As Single
End Type

Public Type hwMadObject
    name As String
    animBits As Integer
    keyframes() As hwMadKeyframe
    matrix As D3DMATRIX
    noOfKeyframes As Long
End Type

Public Type hwMad
    animations() As hwMadAnimInfo
    objects() As hwMadObject
    noOfObjects As Integer
End Type

Public Type filePaths
    lodFile As String
    mexFile As String
    madFile As String
End Type

Public Enum shpGunType
  gunGimble = 1
  gunNewGimble = 2
  gunMissileLauncher = 3
  gunMineLauncher = 4
End Enum

Public Type shpGun
  type As shpGunType
  barrelLength As Single
  recoilLength As Single
  slaveDriver As Integer
  peoObjectName As String
  minturnangle As Single
  maxturnangle As Single
  mindeclination As Single
  maxdeclination As Single
End Type

Public Type hwShip
    PEO As hwPeo
    MEX As hwMex
    MAD As hwMad
    guns() As shpGun
    materials() As hwMat
    textures() As hwLif
    numObjects As Integer
    noOfGuns As Integer
    numMaterials As Integer
    ' 1026: HW, 1280: HW:C
    version As hwShipType
    files As filePaths
End Type

'-----------------------------------
' PEO Types
Type geoHeader
  ' 8 character string
  identifier As String
  version As Long
  name As Long
  fileSize As Long
  localSize As Long
  nPublicMaterials As Long
  nLocalMaterials As Long
  oPublicMaterials As Long
  oLocalMaterials As Long
  nPolygonObjects As Long
  ' 24 bytes
  Reserved As String
End Type

' 32 bytes per material
Public Type tagMaterial
  nameOffset As Long
  ambient As hwColourType
  diffuse As hwColourType
  specular As hwColourType
  kAlpha As Single
  oTexture As Long
  flags As Integer
  nFullAmbient As Integer
  bTexturesRegistered As Integer
  textureNameSave As Integer
End Type

Public Type polygonObject
  nameOffset As Long
  flags As Long
  nVertices As Long
  nFaceNormals As Long
  nVertexNormals As Long
  nPolygons As Long
  oVertexList As Long
  oFaceNormalList As Long
  oVertNormalList As Long ' Cat only
  oPolygonList As Long
  oMother As Long
  oDaughter As Long
  oSister As Long
  matrix As D3DMATRIX
  localmatrix(16) As Single
  lmatrix As Single
  actualName As String ' Import only
End Type

Public Type tagVertex
  x As Single
  y As Single
  z As Single
  iVertexNormal As Long
End Type

Public Type tagNormal
  x As Single
  y As Single
  z As Single
  ' 4 bytes
  pad As String
End Type

' 40 bytes long?
' 00 00 00 00 4D 00 57 00 31 00 00 00 01 00 22 3F 7D C7 CF 3D
' 22 DB 18 3F 10 9D 41 3E 01 00 22 3F 00 00 80 3E 00 08 00 78

Public Type tagPolygon
  iFaceNormal As Long       ' 00 00 00 00
  v0 As Integer              ' 4D 00
  v1 As Integer              ' 57 00
  v2 As Integer              ' 31 00
  iMaterial As Integer      ' 00 00
  s0 As Single              ' 00 01 22 3F
  t0 As Single              ' 7D C7 CF 3D
  s1 As Single              ' 22 D8 18 3F
  t1 As Single              ' 10 9D 41 3E
  s2 As Single              ' 01 00 00 22
  t2 As Single              ' 3F 00 00 80
  flags As Integer          ' 3E 00
  Reserved As Integer    ' 08 00
End Type

Public Type nodeObject
  Key As String
  text As String
  Mother As Long
  Daughter As Long
  Sister As Long
  Added As Boolean
  localmatrix(16) As Single
End Type

Public Type SM_PEODATA
    MeshB As Direct3DRMMeshBuilder3
    Frame As Direct3DRMFrame3
    localmatrix As D3DMATRIX
    Interpolator As Direct3DRMFrameInterpolator
    ColourR As Single
    ColourG As Single
    ColourB As Single
    BoundBox As D3DRMBOX
    name As String
    Index As Integer
    Visible As Boolean
End Type
